VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDeviceContext"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function SaveDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function RestoreDC Lib "gdi32" (ByVal hdc As Long, ByVal nSavedDC As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long


Private mlngWidth As Long
Private mlngHeight As Long

Private mlngDeviceContext As Long
Private mlngDeviceContextOld As Long
Private mlngCompatibleBitmap As Long

Public Property Get GetDC() As Long

    GetDC = mlngDeviceContext

End Property

Public Property Get GetWidth() As Long

    GetWidth = mlngWidth

End Property

Public Property Get GetHeight() As Long

    GetHeight = mlngHeight

End Property

Public Function Create( _
    ByVal vlngHDC As Long, _
    ByVal vlngWidth As Long, _
    ByVal vlngHeight As Long) As Boolean


    ' es wurde bereits ein DeviceContext erzeugt -> alten entfernen
    If mlngDeviceContext <> 0 Then
        Delete
    End If

    ' alten DeviceContext speichern
    mlngDeviceContextOld = SaveDC(vlngHDC)

    ' gertekompatiblen DeviceContext erzeugen
    mlngDeviceContext = CreateCompatibleDC(vlngHDC)
    
    ' gertekompatible Bitmap erzeugen
    mlngCompatibleBitmap = CreateCompatibleBitmap(vlngHDC, vlngWidth, vlngHeight)
    
    ' erzeugte Bitmap dem DeviceContext zuweisen
    SelectObject mlngDeviceContext, mlngCompatibleBitmap
    
    ' Dimensionen des DeviceContexts speichern
    mlngWidth = vlngWidth
    mlngHeight = vlngHeight
    
    
    Create = True

End Function

' DeviceContext und zugehrige Bitmap freigeben
' alten DeviceContext wiederherstellen
Public Function Delete() As Boolean

    ' prfen, ob DeviceContext erzeugt wurde
    If mlngDeviceContext <> 0 Then
    
        ' alten DeviceContext wiederherstellen
        RestoreDC mlngDeviceContext, mlngDeviceContextOld
    
        ' Bitmap aus Speicher entfernen
        DeleteObject mlngCompatibleBitmap
        
        ' DeviceContext aus Speicher entfernen
        DeleteDC mlngDeviceContext
        
    End If
    
    
    Delete = True

End Function

Private Sub Class_Initialize()

    mlngDeviceContext = 0

End Sub

Private Sub Class_Terminate()
    
    ' erzeugten DeviceContext aus Speicher entfernen
    Delete

End Sub
