VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGFX"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long

Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, lpPoint As POINTAPI) As Long

Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Private Declare Function PaintRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long) As Long

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long


' folgende Deklaration werden fr den Tipp 0114 von http://www.activevb.de bentigt
Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth _
        As Long, ByVal nHeight As Long, ByVal nPlanes As Long, _
        ByVal nBitCount As Long, lpBits As Any) As Long

Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As _
        Long, ByVal crColor As Long) As Long

Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal _
        hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) _
        As Long

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc _
        As Long) As Long

Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) _
        As Long

Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject _
       As Long) As Long
       

Private mobjDeviceContext As clsDeviceContext
Private mobjPen As clsPen
Private mobjBrush As clsBrush

Private mblnPenChanged As Boolean
Private mblnBrushChanged As Boolean


Private Type POINTAPI
    lngX As Long
    lngY As Long
End Type

Public Property Set SetDeviceContext(ByVal vobjDeviceContext As clsDeviceContext)

    Set mobjDeviceContext = vobjDeviceContext
    
    ' Pen und Brush mssen neu gesetzt werden
    mblnPenChanged = True
    mblnBrushChanged = True

End Property

Public Property Set SetPen(ByVal vobjPen As clsPen)

    Set mobjPen = vobjPen

    ' Pen wurde gewechselt
    mblnPenChanged = True

End Property

Public Property Set SetBrush(ByVal vobjBrush As clsBrush)

    Set mobjBrush = vobjBrush
    
    ' Brush wurde gewechselt
    mblnBrushChanged = True

End Property

Public Function DrawLine( _
    ByVal vlngX1 As Long, _
    ByVal vlngY1 As Long, _
    ByVal vlngX2 As Long, _
    ByVal vlngY2 As Long) As Boolean

    Dim blnUpdateDC As Boolean
    Dim blnDrawLine As Boolean
    Dim udtOldPosition As POINTAPI
    
    
    blnDrawLine = False
    
    ' DeviceContext aktualisieren
    blnUpdateDC = UpdateDC

    ' Aktualisierung erfolgreich
    If blnUpdateDC Then
        
        ' Ausgangsposition setzen
        MoveToEx mobjDeviceContext.GetDC, vlngX1, vlngY1, udtOldPosition
        
        ' Linie zeichen
        LineTo mobjDeviceContext.GetDC, vlngX2, vlngY2
        
        blnDrawLine = True

    End If
    
    
    DrawLine = blnDrawLine

End Function

Public Function DrawRectangle( _
    ByVal vlngX1 As Long, _
    ByVal vlngY1 As Long, _
    ByVal vlngX2 As Long, _
    ByVal vlngY2 As Long) As Boolean
    
    Dim blnUpdateDC As Boolean
    Dim blnDrawRect As Boolean
    
    
    blnDrawRect = False
    
    ' DeviceContext aktualisieren
    blnUpdateDC = UpdateDC

    ' Aktualisierung erfolgreich
    If blnUpdateDC Then

        ' Rechteck zeichen
        Rectangle mobjDeviceContext.GetDC, vlngX1, vlngY1, vlngX2, vlngY2
        
        blnDrawRect = True

    End If
    
    
    DrawRectangle = blnDrawRect

End Function

Public Function DrawEllipse( _
    ByVal vlngX1 As Long, _
    ByVal vlngY1 As Long, _
    ByVal vlngX2 As Long, _
    ByVal vlngY2 As Long) As Boolean
    
    Dim blnUpdateDC As Boolean
    Dim blnDrawEllipse As Boolean
    
    
    blnDrawEllipse = False
    
    ' DeviceContext aktualisieren
    blnUpdateDC = UpdateDC

    ' Aktualisierung erfolgreich
    If blnUpdateDC Then

        ' Ellipse zeichen
        Ellipse mobjDeviceContext.GetDC, vlngX1, vlngY1, vlngX2, vlngY2
        
        blnDrawEllipse = True

    End If
    
    
    DrawEllipse = blnDrawEllipse

End Function

Public Function DrawRegion(ByVal vlngRegion As Long) As Boolean
    
    Dim blnUpdateDC As Boolean
    Dim blnPaintRegion As Boolean
    
    
    blnPaintRegion = False
    
    ' DeviceContext aktualisieren
    blnUpdateDC = UpdateDC

    ' Aktualisierung erfolgreich
    If blnUpdateDC Then

        ' Region fllen
        PaintRgn mobjDeviceContext.GetDC, vlngRegion
        
        blnPaintRegion = True

    End If
    
    
    DrawRegion = blnPaintRegion

End Function

Public Function DrawDC( _
    ByVal vobjDC As clsDeviceContext, _
    ByVal vlngX As Long, _
    ByVal vlngY As Long, _
    ByVal venuRop As RasterOpConstants) As Boolean


    With vobjDC
        BitBlt mobjDeviceContext.GetDC, vlngX, vlngY, .GetWidth, .GetHeight, _
            vobjDC.GetDC, 0, 0, venuRop
    End With
        
        
    DrawDC = True

End Function

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
' Tipp 0114: Bitmap transparent in eine andere Grafik einbinden
'
'
' SourceCode leicht gendert:
'   - Sub in Funktion umgewandelt
'   - Attributsbezeichnungen der RECT-Strukur angepasst
Public Function TranspPic(OutDstDC&, DstDC&, SrcDC&, SrcRect _
                      As RECT, ByVal DstX&, ByVal DstY&, _
                      TransColor&) As Boolean
 
  Dim Result&, W&, H&
  Dim MonoMaskDC&, hMonoMask&, MonoInvDC&, hMonoInv&
  Dim ResultDstDC&, hResultDst&, ResultSrcDC&, hResultSrc&
  Dim hPrevMask&, hPrevInv&, hPrevSrc&, hPrevDst&
    
    W = SrcRect.lngRight - SrcRect.lngLeft
    H = SrcRect.lngBottom - SrcRect.lngTop
     
    'Generieren einer Monochromen & einer inversen Maske
    MonoMaskDC = CreateCompatibleDC(DstDC)
    MonoInvDC = CreateCompatibleDC(DstDC)
    hMonoMask = CreateBitmap(W, H, 1, 1, ByVal 0&)
    hMonoInv = CreateBitmap(W, H, 1, 1, ByVal 0&)
    hPrevMask = SelectObject(MonoMaskDC, hMonoMask)
    hPrevInv = SelectObject(MonoInvDC, hMonoInv)
     
    'Puffer erstellen
    ResultDstDC = CreateCompatibleDC(DstDC)
    ResultSrcDC = CreateCompatibleDC(DstDC)
    hResultDst = CreateCompatibleBitmap(DstDC, W, H)
    hResultSrc = CreateCompatibleBitmap(DstDC, W, H)
    hPrevDst = SelectObject(ResultDstDC, hResultDst)
    hPrevSrc = SelectObject(ResultSrcDC, hResultSrc)
     
    'Sourcebild in die monochrome Maske kopieren
    Dim OldBC As Long
    OldBC = SetBkColor(SrcDC, TransColor)
    Result = BitBlt(MonoMaskDC, 0, 0, W, H, SrcDC, _
                  SrcRect.lngLeft, SrcRect.lngTop, vbSrcCopy)
    TransColor = SetBkColor(SrcDC, OldBC)
     
    'Inverse Maske erstellen
    Result = BitBlt(MonoInvDC, 0, 0, W, H, _
                  MonoMaskDC, 0, 0, vbNotSrcCopy)
     
    'Hintergrund des Zielbildes auslesen
    Result = BitBlt(ResultDstDC, 0, 0, W, H, _
                  DstDC, DstX, DstY, vbSrcCopy)
     
    'AND mit der Maske
    Result = BitBlt(ResultDstDC, 0, 0, W, H, _
                  MonoMaskDC, 0, 0, vbSrcAnd)
     
    'berlappung des Sourcebildes mit dem Zielbild auslesen
    Result = BitBlt(ResultSrcDC, 0, 0, W, H, SrcDC, _
                  SrcRect.lngLeft, SrcRect.lngTop, vbSrcCopy)
     
    'AND mit der invertierten, monochromen Maske
    Result = BitBlt(ResultSrcDC, 0, 0, W, H, _
                  MonoInvDC, 0, 0, vbSrcAnd)
     
    'XOR mit beiden
    Result = BitBlt(ResultDstDC, 0, 0, W, H, _
                  ResultSrcDC, 0, 0, vbSrcInvert)
     
    'Ergebnis in das Zielbild kopieren
    Result = BitBlt(OutDstDC, DstX, DstY, W, H, _
                  ResultDstDC, 0, 0, vbSrcCopy)
     
    'Erstellte Objekte & DCs wieder freigeben
    hMonoMask = SelectObject(MonoMaskDC, hPrevMask)
    DeleteObject hMonoMask
    DeleteDC MonoMaskDC
    
    hMonoInv = SelectObject(MonoInvDC, hPrevInv)
    DeleteObject hMonoInv
    DeleteDC MonoInvDC
    
    hResultDst = SelectObject(ResultDstDC, hPrevDst)
    DeleteObject hResultDst
    DeleteDC ResultDstDC
    
    hResultSrc = SelectObject(ResultSrcDC, hPrevSrc)
    DeleteObject hResultSrc
    DeleteDC ResultSrcDC
    
    TranspPic = True
    
End Function

Private Function UpdateDC() As Boolean

    Dim blnObjectsOK  As Boolean

    
    ' prfen, ob Objekte mit gltigen Eigenschaften existieren
    blnObjectsOK = VerifyObjects
    
    ' DeviceContext aktualisieren, falls Pen gewechselt wurde
    If mblnPenChanged And blnObjectsOK Then
        SelectObject mobjDeviceContext.GetDC, mobjPen.GetPen
        mblnPenChanged = False
    End If
    
    ' DeviceContext aktualisieren, falls Brush gewechselt wurde
    If mblnBrushChanged And blnObjectsOK Then
        SelectObject mobjDeviceContext.GetDC, mobjBrush.GetBrush
        mblnBrushChanged = False
    End If
    
    
    UpdateDC = blnObjectsOK

End Function

Private Function VerifyObjects() As Boolean

    Dim blnObjectsOK As Boolean


    blnObjectsOK = True

    ' prfen, ob DeviceContext-Objekt existiert
    If mobjDeviceContext Is Nothing Then
        blnObjectsOK = False
    
    ' prfen, ob DeviceContext-Objekt DeviceContext besitzt
    ElseIf mobjDeviceContext.GetDC = 0 Then
        blnObjectsOK = False
    End If
    
    
    ' prfen, ob Pen-Objekt existiert
    If mobjPen Is Nothing Then
        blnObjectsOK = False
        
    ' prfen ob Pen-Objekt Pen besitzt
    ElseIf mobjPen.GetPen = 0 Then
        blnObjectsOK = False
    End If
    
    
    ' prfen, ob Brush-Objekt existiert
    If mobjBrush Is Nothing Then
        blnObjectsOK = False
    
    ' prfen, obj Brush-Objekt Brush besitzt
    ElseIf mobjBrush.GetBrush = 0 Then
        blnObjectsOK = False
    End If
    
    
    VerifyObjects = blnObjectsOK
    
End Function

Private Sub Class_Initialize()

    mblnPenChanged = False
    mblnBrushChanged = False

End Sub

Private Sub Class_Terminate()

    Set mobjPen = Nothing
    Set mobjBrush = Nothing
    Set mobjDeviceContext = Nothing

End Sub
