VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGrain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mblnDropImpossible As Boolean
Private mobjPoint As clsPoint
Private mobjMap As clsMap

Public Property Set SetMap(ByVal vobjMap As clsMap)

    Set mobjMap = vobjMap

End Property

Public Function Point() As clsPoint

    Set Point = mobjPoint

End Function

' Sandkorn an definierter Position erzeugen
Public Function Create( _
    ByVal vlngX As Long, _
    ByVal vlngY As Long) As Boolean
    
    Dim blnCreated As Boolean
    
    
    blnCreated = False
    
    ' prfen, ob Feld frei ist
    If mobjMap.GetFieldState(vlngX, vlngY) = enuFSfree Then
    
        ' Sandkorn an neue Position setzen
        mobjMap.SetFieldState vlngX, vlngY, enuFSGrain
        mobjPoint.x = vlngX
        mobjPoint.y = vlngY
        
        blnCreated = True
        mblnDropImpossible = False
    
    End If
    
    
    Create = blnCreated
    
End Function

' prfen, ob sich Sandkorn im oberen Teil des Glases befindet
Public Function IsInUpperGlass() As Boolean
      
    Dim blnIsInUpperGlass As Boolean
    
    
    blnIsInUpperGlass = mobjMap.GetUpperGlassRect.IsPointInRect(mobjPoint)
    
    
    IsInUpperGlass = blnIsInUpperGlass

End Function

' prfen, ob sich Sandkorn im unteren Teil des Glases befindet
Public Function IsInLowerGlass() As Boolean
      
    Dim blnIsInLowerGlass As Boolean
    
    
    blnIsInLowerGlass = mobjMap.GetLowerGlassRect.IsPointInRect(mobjPoint)
    
    
    IsInLowerGlass = blnIsInLowerGlass

End Function

' Sandkorn bis zu der Grenze des oberen Glases fallen lassen
Public Function DropToUpperBorder() As Boolean

    Dim blnDropped As Boolean
    
    
    If Not mblnDropImpossible Then
        blnDropped = DropToBorderBottom(mobjMap.GetUpperGlassRect)
    End If

    
    DropToUpperBorder = blnDropped

End Function

' Sandkorn bis zu der Grenze des unteren Glases fallen lassen
Public Function DropToLowerBorder() As Boolean

    Dim blnDropped As Boolean
    
    
    If Not mblnDropImpossible Then
        blnDropped = DropToBorderBottom(mobjMap.GetLowerGlassRect)
    End If
    
    ' Sandkorn wird sich nicht mehr bewegen
    If blnDropped Then
        mblnDropImpossible = True
    End If

    
    DropToLowerBorder = blnDropped

End Function

' Sandkorn bis zu der definierten Grenze fallen lassen
Private Function DropToBorderBottom(ByVal vobjRect As clsRect) As Boolean

    Dim blnDropImpossible As Boolean
    Dim blnDropped As Boolean
    Dim blnDroppedToBorderBottom As Boolean


    blnDropped = False
    blnDropImpossible = False
    
    ' Sandkorn solange fallen lassen bis die unterer Bereich des Rechtecks erreicht worden ist
    ' oder es sich nicht mehr bewegen kann
    While (mobjPoint.y < vobjRect.Bottom) And Not blnDropImpossible
        
        blnDropped = DropOnce
        
        ' Sandkorn kann sich nicht bewegen
        If Not blnDropped Then
            blnDropImpossible = True
        End If
        
    Wend
    
    ' befindet sich Sandkorn im Zielbereich?
    blnDroppedToBorderBottom = vobjRect.IsPointInRect(mobjPoint)
           
    
    DropToBorderBottom = blnDroppedToBorderBottom

End Function

' Sandkorn um ein Feld fallen lassen
Private Function DropOnce() As Boolean

    Dim blnDropped As Boolean


    ' nach unten fallen
    blnDropped = DropVertically

    With mobjPoint

        ' prfen, ob nach links oder rechts gefallen werden soll
        If Not blnDropped Then
            ' prfen, ob zwei Felder unter mir belegt sind
            If (mobjMap.GetFieldState(.x, .y + 1) <> enuFSfree) _
            And (mobjMap.GetFieldState(.x, .y + 2) <> enuFSfree) Then
            
                ' nach links fallen
                blnDropped = DropHorizontally(-1)
                
                ' nach rechts fallen
                If Not blnDropped Then
                    blnDropped = DropHorizontally(1)
                End If
                
            End If
        End If
    
    End With
    
    DropOnce = blnDropped

End Function

' nach links oder rechts fallen
Private Function DropHorizontally(ByVal vlngXOffset As Long) As Boolean

    Dim blnDropped As Boolean
    
    
    blnDropped = False
    
    With mobjPoint
    
        ' prfen, ob Feld neben aktueller Position frei ist
'        If mobjMap.GetFieldState(.X + vlngXOffset, .Y) = enuFSFree Then
        
            ' prfen, ob Feld darunter auch frei ist
            If mobjMap.GetFieldState(.x + vlngXOffset, .y + 1) = enuFSfree Then
                
                ' Sandkorn an neue Position setzen
                mobjMap.SetFieldState .x, .y, enuFSfree
                mobjMap.SetFieldState .x + vlngXOffset, .y + 1, enuFSGrain
                .x = .x + vlngXOffset
                .y = .y + 1
                
                blnDropped = True
                
            End If
            
'        End If
        
    End With
    

    DropHorizontally = blnDropped

End Function

' nach unten fallen
Private Function DropVertically() As Boolean

    Dim blnDropped As Boolean


    blnDropped = False

    With mobjPoint
    
        ' nach unten fallen, wenn frei ist
        If mobjMap.GetFieldState(.x, .y + 1) = enuFSfree Then
        
            ' Sandkorn an neue Position setzen
            mobjMap.SetFieldState .x, .y, enuFSfree
            mobjMap.SetFieldState .x, .y + 1, enuFSGrain
            .y = .y + 1
            
            blnDropped = True
            
        End If
        
    End With
    
    
    DropVertically = blnDropped

End Function

' Sandkorn in ein freies Feld im unteren Glas setzen ohne dieses runterfallen zu lassen
Public Function CheatDrop() As Boolean

    Dim lngX As Long
    Dim lngY As Long
    Dim blnDropped As Boolean


    blnDropped = False

    With mobjMap.GetLowerGlassRect
        
        ' nchstes freies Feld im unteren Teil der Sanduhr ermitteln
        For lngY = .Bottom To .Top Step -1
            For lngX = .Left To .Right
                
                ' prfen, ob Feld frei ist
                If mobjMap.GetFieldState(lngX, lngY) = enuFSfree Then
                    
                    ' Sandkorn an neue Position setzen
                    mobjMap.SetFieldState mobjPoint.x, mobjPoint.y, enuFSfree
                    mobjMap.SetFieldState lngX, lngY, enuFSGrain
                    mobjPoint.x = lngX
                    mobjPoint.y = lngY
                    
                    blnDropped = True
                    
                End If
                
                ' Schleifenabbruch, wenn Sandkorn gesetzt wurde
                If blnDropped Then
                    Exit For
                End If
                    
            Next lngX
            
             ' Schleifenabbruch, wenn Sandkorn gesetzt wurde
            If blnDropped Then
                Exit For
            End If
            
        Next lngY
    
    End With
    
    
    CheatDrop = blnDropped

End Function

Private Sub Class_Initialize()

    Set mobjPoint = New clsPoint

End Sub

Private Sub Class_Terminate()

    Set mobjPoint = Nothing
    Set mobjMap = Nothing

End Sub
