VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHourglass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const mconCOLOR_TRANSPARENT = &HFF00FF
Private Const mconHOURGLASS_THICKNESS_MIN = 2
Private Const mconGRAIN_SIZE_MIN = 2

Private mblnRefillHourglass As Boolean

Private mlngHourglassBackColor As Long
Private mlngHourglassBorderColor As Long
Private mlngHourglassFillColor As Long
Private mlngGrainColor As Long

Private mlngHourglassThickness As Long

Private mlngMin As Long
Private mlngMax As Long
Private mlngValue As Long

Private mlngGrainSize As Long

Private mlngWidth As Long
Private mlngHeight As Long

Private mlngHDC As Long

Private mobjGFX As clsGFX
Private mobjBrush As clsBrush
Private mobjPen As clsPen

Private mobjGrainDC As clsDeviceContext
Private mobjOutputDC As clsDeviceContext

Private mobjHourglassPoly As clsPolygon
Private mobjHourglassMap As clsMap
Private mobjHourglassDC As clsDeviceContext
Private mobjHourglassRegion As clsRegion

Private mobjUpperGlassPoly As clsPolygon
Private mobjLowerGlassPoly As clsPolygon

Private mobjUpperGlassPolyTemplate As clsPolygon
Private mobjLowerGlassPolyTemplate As clsPolygon

Private mcolGrains As colGrains

Public Event GFXHasChanged()

Public Property Get GetOutputHDC() As Long

    GetOutputHDC = mobjOutputDC.GetDC

End Property

Public Property Let HourglassThickness(ByVal vlngValue As Long)

    mlngHourglassThickness = vlngValue
    
    If mlngHourglassThickness < mconHOURGLASS_THICKNESS_MIN Then
        mlngHourglassThickness = mconHOURGLASS_THICKNESS_MIN
    End If

End Property

Public Property Get HourglassThickness() As Long

    HourglassThickness = mlngHourglassThickness

End Property

Public Property Let GrainColor(ByVal vlngValue As Long)

    mlngGrainColor = vlngValue

End Property

Public Property Get GrainColor() As Long

    GrainColor = mlngGrainColor

End Property

Public Property Let HourglassBackColor(ByVal vlngValue As Long)

    mlngHourglassBackColor = vlngValue

End Property

Public Property Get HourglassBackColor() As Long

    HourglassBackColor = mlngHourglassBackColor

End Property

Public Property Let HourglassFillColor(ByVal vlngValue As Long)

    mlngHourglassFillColor = vlngValue

End Property

Public Property Get HourglassFillColor() As Long

    HourglassFillColor = mlngHourglassFillColor

End Property

Public Property Let HourglassBorderColor(ByVal vlngValue As Long)

    mlngHourglassBorderColor = vlngValue

End Property

Public Property Get HourglassBorderColor() As Long

    HourglassBorderColor = mlngHourglassBorderColor

End Property

Public Property Let CompatibleHDC(ByVal vlngValue As Long)

    mlngHDC = vlngValue

End Property

Public Property Get CompatibleHDC() As Long

    CompatibleHDC = mlngHDC

End Property

Public Property Get Min() As Long

    Min = mlngMin

End Property

Public Property Let Min(ByVal vlngValue As Long)

    mlngMin = vlngValue
    
    If mlngMin > mlngMax Then
        mlngMax = mlngMin
        mlngValue = mlngMin
    End If

    ' Sanduhr neu fllen
    mblnRefillHourglass = True

End Property

Public Property Get Max() As Long

    Max = mlngMax

End Property

Public Property Let Max(ByVal vlngValue As Long)

    mlngMax = vlngValue
    
    If mlngMax < mlngMin Then
        mlngMin = mlngMax
        mlngValue = mlngMin
    End If

    ' Sanduhr neu fllen
    mblnRefillHourglass = True

End Property

Public Property Get Value() As Long

    Value = mlngValue

End Property

Public Property Let Value(ByVal vlngValue As Long)
    
    Dim lngValue As Long

    
    lngValue = vlngValue
    
    If lngValue < mlngMin Then
        lngValue = mlngMin
    End If
    
    If lngValue > mlngMax Then
        lngValue = mlngMax
    End If

    ' wenn neuer Wert kleiner als alter Wert ist, muss die Sanduhr neu gefllt werden
    If lngValue < mlngValue Then
        mblnRefillHourglass = True
    End If
    
    
    mlngValue = lngValue

End Property

Public Property Get GrainSize() As Long
    
    GrainSize = mlngGrainSize

End Property

Public Property Let GrainSize(ByVal vlngValue As Long)

    mlngGrainSize = vlngValue
    
    If mlngGrainSize < mconGRAIN_SIZE_MIN Then
        mlngGrainSize = mconGRAIN_SIZE_MIN
    End If

End Property

Public Property Get Width() As Long

    Width = mlngWidth

End Property

Public Property Let Width(ByVal vlngValue As Long)

    mlngWidth = vlngValue
    
    If mlngWidth < (2 * mlngGrainSize) Then
        mlngWidth = (2 * mlngGrainSize)
    End If
    
    ' Sanduhr an neue Gre anpassen und neu initialisieren
    mblnRefillHourglass = True

End Property

Public Property Get Height() As Long

    Height = mlngHeight

End Property

Public Property Let Height(ByVal vlngValue As Long)

    mlngHeight = vlngValue

    If mlngHeight < (2 * mlngGrainSize) Then
        mlngHeight = (2 * mlngGrainSize)
    End If

    ' Sanduhr an neue Gre anpassen und neu initialisieren
    mblnRefillHourglass = True

End Property

Public Property Set SetUpperGlassPoly(ByVal vobjPolygon As clsPolygon)
    
    Set mobjUpperGlassPoly = vobjPolygon.Clone
    Set mobjUpperGlassPolyTemplate = vobjPolygon.Clone
    
End Property

Public Property Set SetLowerGlassPoly(ByVal vobjPolygon As clsPolygon)
    
    Set mobjLowerGlassPoly = vobjPolygon.Clone
    Set mobjLowerGlassPolyTemplate = vobjPolygon.Clone
        
End Property

' Sanduhr komplett neu erzeugen
Public Function CreateHourglass() As Boolean

    Dim blnResult As Boolean
    

    mblnRefillHourglass = True

    ' Polygon erzeugen
    blnResult = CreateHourglassPoly

    ' Region aus diesem Polygon erzeugen
    If blnResult Then
        blnResult = mobjHourglassRegion.Create(mobjHourglassPoly)
    End If
    
    ' bentigte DeviceContexts erstellen
    If blnResult Then
        blnResult = CreateDCs
    End If
    
    ' Map der Sanduhr erstellen
    If blnResult Then
        blnResult = mobjHourglassMap.Create(mobjHourglassPoly, mobjHourglassRegion, _
            mobjUpperGlassPoly.GetBoundaryRect, mlngGrainSize)
    End If
    
    ' Sanduhr fllen
    If blnResult Then
        blnResult = FillHourglass
    End If
    
    ' aktuellen Fortschritt anzeigen
    If blnResult Then
        blnResult = SetPercent
    End If

    
    CreateHourglass = blnResult

End Function

' Polygon der Sanduhr erzeugen
Private Function CreateHourglassPoly() As Boolean

    Dim blnResult As Boolean
    Dim objPoint As clsPoint
    
    
    ' altes Polygon lschen
    blnResult = mobjHourglassPoly.Clear

    ' Polygon der gesamten Sanduhr erzeugen
    If blnResult Then

        ' begonnen wird mit dem ersten Punkt des oberen Teils der Sanduhr im Uhrzeigersinn
        For Each objPoint In mobjUpperGlassPoly.ColPoints
            mobjHourglassPoly.Add objPoint.x, objPoint.y
        Next
        
        ' danach kommt der untere Teil der Sanduhr
        For Each objPoint In mobjLowerGlassPoly.ColPoints
            mobjHourglassPoly.Add objPoint.x, objPoint.y
        Next
        
        
        mlngWidth = mobjHourglassPoly.GetBoundaryRect.GetWidth
        mlngHeight = mobjHourglassPoly.GetBoundaryRect.GetHeight
        
    End If
    
    Set objPoint = Nothing
    
    
    CreateHourglassPoly = blnResult

End Function

' Sanduhr mit Sandkrnern fllen
Private Function FillHourglass() As Boolean

    Dim blnResult As Boolean
    
        
    Set mcolGrains = New colGrains
        
    ' alle Felder zurcksetzen
    blnResult = mobjHourglassMap.ClearFields
    
    ' Sanduhr mit Sandkrner fllen
    If blnResult Then
        blnResult = FillHourglassEx
    End If
    
    
    FillHourglass = blnResult

End Function

' Sanduhr mit Sandkrnern fllen
Private Function FillHourglassEx() As Boolean

    Dim lngElements As Long
    Dim lngMaxElements As Long
    Dim lngX As Long
    Dim lngY As Long
    Dim blnGrainAdded As Boolean
    Dim blnCancel As Boolean
    Dim blnBoundaryReached As Boolean
    

    With mobjHourglassMap.GetUpperGlassRect

        lngX = .Left
        lngY = .Bottom

        ' Anzahl Sandkrner, die maximal in Sanduhr passen
        lngMaxElements = mobjHourglassMap.GetMaxElements

        ' Anzahl bentigter Sandkrner erzeugen
        For lngElements = 1 To lngMaxElements
            
            blnCancel = False
            blnGrainAdded = False
            blnBoundaryReached = False
            
            ' Sandkrner von links nach rechts, von unten nach oben setzen
            While Not blnGrainAdded And Not blnCancel
                
                While Not blnGrainAdded And Not blnCancel And Not blnBoundaryReached
                
                    ' Sandkorn an Position X/Y erzeugen
                    blnGrainAdded = FillHourglassAddGrain(lngX, lngY)
                                    
                    lngX = lngX + 1
                    
                    ' rechte Grenze des Glases erreicht
                    If lngX > .Right Then
                        lngX = .Left
                        blnBoundaryReached = True
                    End If
                
                Wend
            
            
                If blnBoundaryReached Then
                    lngY = lngY - 1
                    blnBoundaryReached = False
                End If
                
                ' obere Grenze des Glases erreicht, fllen abbrechen
                If lngY < .Top Then
                    blnCancel = True
                End If
                
            Wend
        
        Next lngElements
    
    End With


    FillHourglassEx = True
    
End Function

' Sandkorn in Sanduhr an Position X/Y erzeugen
Private Function FillHourglassAddGrain( _
    ByVal vlngX As Long, _
    ByVal vlngY As Long) As Boolean

    Dim objGrain As clsGrain
    Dim blnGrainAdded As Boolean
    

    Set objGrain = New clsGrain

    ' Map als Referenz bergeben
    Set objGrain.SetMap = mobjHourglassMap
    
    ' Sandkorn erzeugen
    blnGrainAdded = objGrain.Create(vlngX, vlngY)

    ' Sandkorn in Collection speichern
    If blnGrainAdded Then
        mcolGrains.Add objGrain
    End If

    Set objGrain = Nothing
    
    
    FillHourglassAddGrain = blnGrainAdded

End Function

' Initialisierungsarbeiten
Private Sub Class_Initialize()

    Set mobjHourglassPoly = New clsPolygon
    Set mobjHourglassMap = New clsMap
    Set mobjHourglassRegion = New clsRegion
    Set mobjHourglassDC = New clsDeviceContext
    
    Set mobjGrainDC = New clsDeviceContext
    Set mobjOutputDC = New clsDeviceContext
    
    Set mobjUpperGlassPoly = New clsPolygon
    Set mobjLowerGlassPoly = New clsPolygon
    
    Set mobjUpperGlassPolyTemplate = New clsPolygon
    Set mobjLowerGlassPolyTemplate = New clsPolygon
    
    Set mcolGrains = New colGrains
    
    Set mobjGFX = New clsGFX
    Set mobjBrush = New clsBrush
    Set mobjPen = New clsPen
        
        
    mblnRefillHourglass = True
        
    mlngGrainSize = 5
    
    mlngMax = 100
    mlngMin = 0
    mlngValue = mlngMin
    
    mlngHourglassThickness = mconHOURGLASS_THICKNESS_MIN
    
End Sub

' Aufrumarbeiten
Private Sub Class_Terminate()

    Set mobjHourglassPoly = Nothing
    Set mobjHourglassMap = Nothing
    Set mobjHourglassRegion = Nothing
    Set mobjHourglassDC = Nothing
    
    Set mobjGrainDC = Nothing
    Set mobjOutputDC = Nothing
    
    Set mobjUpperGlassPoly = Nothing
    Set mobjLowerGlassPoly = Nothing
    
    Set mobjUpperGlassPolyTemplate = Nothing
    Set mobjLowerGlassPolyTemplate = Nothing
    
    Set mcolGrains = Nothing
            
    Set mobjGFX = Nothing
    Set mobjBrush = Nothing
    Set mobjPen = Nothing
    
End Sub

' Prozentanteil ermitteln
Private Function GetPercent( _
    ByVal vdblMin As Double, _
    ByVal vdblMax As Double, _
    ByVal vdblValue As Double) As Double

    Dim dblPercent As Double
    
    
    ' Division durch 0 vermeiden
    If vdblMin <> vdblMax Then
        dblPercent = CDbl((100 / (vdblMax - vdblMin)) * (vdblValue - vdblMin))
        
    Else
        dblPercent = 100
    End If
    
    GetPercent = dblPercent

End Function

' Sanduhr bis zu bestimmten Prozentwert fllen (abhngig von Min, Max, Value)
Public Function SetPercent() As Boolean

    Dim blnResult As Boolean
    Dim sngPercent As Single
    

    blnResult = True

    ' Sanduhr neu fllen, falls notwendig
    If mblnRefillHourglass Then
        blnResult = FillHourglass
        mblnRefillHourglass = False
    End If

    If blnResult Then
        ' zu wievel Prozent ist Sanduhr gefllt?
        sngPercent = GetPercent(mlngMin, mlngMax, mlngValue)
    
        ' Sandkrner aus dem oberen Glas nach unten fallen lassen
        blnResult = SetPercentEx(sngPercent)
        
        ' nicht alle Sandkrner konnten nach unten fallen
        If Not blnResult Then
            blnResult = SetPercentCheatDrop(sngPercent)
        End If
    End If
    
    ' Sandkrner im oberen Glas bis zur Grenze des oberen Glases fallen lassen
    If blnResult Then
        blnResult = DropGrainToUpperGlass
    End If
    
    ' Grafik zur Anzeige erzeugen
    DrawOutputDC
    

    SetPercent = True

End Function

' Sanduhr bis zu bestimmten Prozentwert fllen
Private Function SetPercentEx(ByVal vsngPercent As Single) As Boolean

    Dim blnCancel As Boolean
    Dim blnGrainDropped As Boolean
    Dim sngPercent As Single
    Dim lngMaxGrains As Long
    Dim lngGrainsInUpperGlass As Long
    Dim lngGrainsInLowerGlass As Long
    
    
    ' Anzahl Sandkrner in Sanduhr zhlen
    With mobjHourglassMap
        lngGrainsInUpperGlass = .CountElementsInRect(.GetUpperGlassRect, enuFSGrain)
        lngGrainsInLowerGlass = .CountElementsInRect(.GetLowerGlassRect, enuFSGrain)
        lngMaxGrains = lngGrainsInUpperGlass + lngGrainsInLowerGlass
    End With
        
    
    sngPercent = GetPercent(0, lngMaxGrains, lngGrainsInLowerGlass)
    
    blnGrainDropped = True
    
    ' solange durchlaufen bis Prozentanteil erreicht wurde
    ' abbruch, wenn kein Sandkorn mehr fallen kann
    While (sngPercent < vsngPercent) And blnGrainDropped
    
        ' ein Sandkorn aus oberem Glas in das untere Glas fallen lassen
        blnGrainDropped = DropGrainToLowerGlass
    
        ' Prozentanteil neu berechnen
        If blnGrainDropped Then
            lngGrainsInUpperGlass = lngGrainsInUpperGlass - 1
            lngGrainsInLowerGlass = lngGrainsInLowerGlass + 1
            
            sngPercent = GetPercent(0, lngMaxGrains, lngGrainsInLowerGlass)
        End If
    
    Wend
    
    
    SetPercentEx = blnGrainDropped

End Function

' Sanduhr bis zu bestimmten Prozentanteil fllen
' Verwendung der CheatDrop Methode der Klasse clsGrain
' wird aufgerufen, wenn Sandkrner auf normalen Weg nicht mehr fallen knnen
Private Function SetPercentCheatDrop(ByVal vsngPercent As Single) As Boolean

    Dim blnCancel As Boolean
    Dim blnGrainDropped As Boolean
    Dim sngPercent As Single
    Dim lngMaxGrains As Long
    Dim lngGrainsInUpperGlass As Long
    Dim lngGrainsInLowerGlass As Long
    
    
    ' Anzahl Sandkrner in Sanduhr zhlen
    With mobjHourglassMap
        lngGrainsInUpperGlass = .CountElementsInRect(.GetUpperGlassRect, enuFSGrain)
        lngGrainsInLowerGlass = .CountElementsInRect(.GetLowerGlassRect, enuFSGrain)
        lngMaxGrains = lngGrainsInUpperGlass + lngGrainsInLowerGlass
    End With
        
    
    sngPercent = GetPercent(0, lngMaxGrains, lngGrainsInLowerGlass)
    
    blnGrainDropped = True
    
    
    ' solange durchlaufen bis Prozentanteil erreicht wurde
    ' abbruch, wenn kein Sandkorn mehr fallen kann
    While (sngPercent < vsngPercent) And blnGrainDropped
    
        ' ein Sandkorn aus oberem Glas in das untere Glas setzen
        blnGrainDropped = CheatDrop
    
        ' Prozentanteil neu berechnen
        If blnGrainDropped Then
            lngGrainsInUpperGlass = lngGrainsInUpperGlass - 1
            lngGrainsInLowerGlass = lngGrainsInLowerGlass + 1
            
            sngPercent = GetPercent(0, lngMaxGrains, lngGrainsInLowerGlass)
        End If
    
    Wend
    
    
    SetPercentCheatDrop = blnGrainDropped

End Function

' Sandkrner aus oberem Glas ins untere Glas setzen ohne diese fallen zu lassen
Private Function CheatDrop() As Boolean

    Dim objGrain As clsGrain
    Dim blnGrainDropped As Boolean


    blnGrainDropped = False

    ' alle Sandkrner durchlaufen
    For Each objGrain In mcolGrains

        With objGrain

            ' befindet sich Sandkorn im oberen Glas?
            If .IsInUpperGlass Then
                ' Sandkorn nach unten fallen lassen
                blnGrainDropped = .CheatDrop
            End If

            ' abbruch, wenn Sandkorn gefallen ist
            If blnGrainDropped Then
                Exit For
            End If

        End With

    Next


    CheatDrop = blnGrainDropped

End Function

' ein einzelnes Sandkorn aus dem oberen Teil des Glases in den unteren Teil fallen lassen
Private Function DropGrainToLowerGlass() As Boolean

    Dim objGrain As clsGrain
    Dim blnGrainDropped As Boolean


    blnGrainDropped = False

    ' alle Sandhrner durchlaufen
    For Each objGrain In mcolGrains

        With objGrain

            ' befindet sich Sandkorn im oberen Glas?
            If .IsInUpperGlass Then
                ' Sandkorn nach unten fallen lassen
                blnGrainDropped = .DropToLowerBorder
            End If

            ' abbruch, wenn Sandkorn gefallen ist
            If blnGrainDropped Then
                Exit For
            End If

        End With

    Next


    DropGrainToLowerGlass = blnGrainDropped

End Function

' alle Sandkrner im oberen Glass bis zur Grenze des oberen Glases fallen lassen
Private Function DropGrainToUpperGlass() As Boolean

    Dim objGrain As clsGrain

    
    ' alle Sandhrner durchlaufen
    For Each objGrain In mcolGrains

        With objGrain

            ' befindet sich Sandkorn im oberen Glas?
            If .IsInUpperGlass Then
                ' Sandkorn bis zur Grenze des oberen Glases fallen lassen
                .DropToUpperBorder
            End If

        End With

    Next


    DropGrainToUpperGlass = True

End Function

' Sanduhr an neue Gre anpassen
Public Function ResizeHourglass() As Boolean

    Dim blnResult As Boolean


    ' Polygone von Template klonen
    Set mobjUpperGlassPoly = mobjUpperGlassPolyTemplate.Clone
    Set mobjLowerGlassPoly = mobjLowerGlassPolyTemplate.Clone

    
    ' Breite anpassen
    blnResult = ResizeHourglassWidth(mlngWidth)
    
    ' Hhe anpassen
    If blnResult Then
        blnResult = ResizeHourglassHeight(mlngHeight)
    End If
    
    
    ResizeHourglass = blnResult
    
End Function

' Breite der Sanduhr anpassen
Private Function ResizeHourglassWidth(ByVal vlngValue As Long) As Boolean

    Dim blnResult As Boolean
 
 
    ' oberen Teil der Sanduhr anpassen
    blnResult = mobjUpperGlassPoly.Resize(vlngValue, _
        mobjUpperGlassPoly.GetBoundaryRect.GetHeight)
    
    ' unteren Teil der Sanduhr anpassen
    If blnResult Then
        blnResult = mobjLowerGlassPoly.Resize(vlngValue, _
            mobjLowerGlassPoly.GetBoundaryRect.GetHeight)
    End If
    
    
    ResizeHourglassWidth = blnResult

End Function

' Hhe der Sanduhr anpassen
Private Function ResizeHourglassHeight(ByVal vlngValue As Long) As Boolean

    Dim lngOldHeight As Long
    Dim sngUpperGlassPercent As Single
    Dim sngLowerGlassPercent As Single
    Dim blnResult As Boolean
    

'    Set mobjUpperGlassPoly = mobjUpperGlassPolyTemplate.Clone
'    Set mobjLowerGlassPoly = mobjLowerGlassPolyTemplate.Clone
    
    
    ' gesamte Hhe
    lngOldHeight = GetPolyHeight(mobjUpperGlassPoly, mobjLowerGlassPoly)
    
    ' prozentualer Anteil des oberen Teils der Sanduhr
    sngUpperGlassPercent = GetPercent(0, lngOldHeight, _
        mobjUpperGlassPoly.GetBoundaryRect.GetHeight)
        
    ' prozentualer Anteil des unteren Teils der Sanduhr
    sngLowerGlassPercent = GetPercent(0, lngOldHeight, _
        mobjLowerGlassPoly.GetBoundaryRect.GetHeight)
        
        
    ' Grenanpassung durchfhren
    ' oberen Teil der Sanduhr anpassen
    blnResult = mobjUpperGlassPoly.Resize(mobjUpperGlassPoly.GetBoundaryRect.GetWidth, _
        CLng((vlngValue / 100) * sngUpperGlassPercent))
    
    ' unteren Teil der Sanduhr anpassen
    If blnResult Then
        blnResult = mobjLowerGlassPoly.Resize(mobjLowerGlassPoly.GetBoundaryRect.GetWidth, _
            CLng((vlngValue / 100) * sngLowerGlassPercent))
    End If
    
    
    ResizeHourglassHeight = blnResult

End Function

' DeviceContext der Sanduhr erstellen und Sanduhr zeichnen
Private Function CreateHourglassDC() As Boolean

    Dim blnResult As Boolean

    
    ' DeviceContext erzeugen
    blnResult = mobjHourglassDC.Create(mlngHDC, mlngWidth, mlngHeight)
    
    ' Grafikobjekt erzeugten DC zuweisen
    If blnResult Then
        Set mobjGFX.SetDeviceContext = mobjHourglassDC
    End If
    
    ' Hintergrund der Sanduhr erstellen
    If blnResult Then
        blnResult = BlitColor(mobjHourglassDC, mlngHourglassBackColor)
    End If

    ' Region der Sanduhr fllen
    If blnResult Then
        blnResult = CreateHourglassDCRegion
    End If

    ' Polygon der Sanduhr zeichnen
    If blnResult Then
        blnResult = CreateHourglassDCPoly
    End If

    
    CreateHourglassDC = blnResult

End Function

' Polygon der Sanduhr zeichnen
Private Function CreateHourglassDCPoly() As Boolean

    Dim objPoint As clsPoint
    Dim lngLastX As Long
    Dim lngLastY As Long
    Dim blnFirstElement As Boolean
    
    
    blnFirstElement = True
    
    mobjPen.Create PS_SOLID, mlngHourglassThickness, mlngHourglassBorderColor
    
    With mobjGFX
    
        Set .SetPen = mobjPen
    
        ' alle Punkte durchlaufen
        For Each objPoint In mobjHourglassPoly.ColPoints
    
            ' Punkte miteinander verbinden
            If Not blnFirstElement Then
                .DrawLine lngLastX, lngLastY, objPoint.x, objPoint.y
            End If
            
            lngLastX = objPoint.x
            lngLastY = objPoint.y
            
            blnFirstElement = False
    
        Next
        
        ' letzen Punkt mit ersten verbinden
        With mobjHourglassPoly.ColPoints
            If .Count > 1 Then
                mobjGFX.DrawLine lngLastX, lngLastY, .Item(1).x, .Item(1).y
            End If
        End With
        
    End With
    
    
    CreateHourglassDCPoly = True

End Function

' Region der Sanduhr zeichnen
Private Function CreateHourglassDCRegion() As Boolean

    ' transparente Farbe whlen
    mobjBrush.Create mconCOLOR_TRANSPARENT
    
    With mobjGFX
    
        Set .SetBrush = mobjBrush
        
        ' Region mit transparenter Farbe fllen
        .DrawRegion mobjHourglassRegion.GetRegion
    
    End With


    CreateHourglassDCRegion = True

End Function

' DeviceContext eines Sandkorns erstellen und zeichnen
Private Function CreateGrainDC() As Boolean

    Dim blnResult As Boolean


    ' DeviceContext erzeugen
    blnResult = mobjGrainDC.Create(mlngHDC, mlngGrainSize, mlngGrainSize)
    
    ' Grafikobjekt erzeugten DC zuweisen
    If blnResult Then
        Set mobjGFX.SetDeviceContext = mobjGrainDC
    End If
    
    ' DC mit Farbe des Sandkorns fllen
    If blnResult Then
        blnResult = BlitColor(mobjGrainDC, mlngGrainColor)
    End If
    

    CreateGrainDC = blnResult

End Function

' DeviceContexts erstellen
Public Function CreateDCs() As Boolean

    Dim blnResult As Boolean


    ' DeviceContext der Sanduhr erzeugen
    blnResult = CreateHourglassDC
        
    ' DeviceContext des Sandkorns erzeugen
    If blnResult Then
        blnResult = CreateGrainDC
    End If
    
    ' DeviceContext der Ausgabe erzeugen
    If blnResult Then
        blnResult = mobjOutputDC.Create(mlngHDC, mlngWidth, mlngHeight)
    End If
    
    
    CreateDCs = blnResult
    
End Function

' DeviceContext komplett mit Farbe fllen
Private Function BlitColor( _
    ByVal vobjDC As clsDeviceContext, _
    ByVal vlngColor As Long) As Boolean
    
    
    mobjBrush.Create vlngColor
    mobjPen.Create PS_SOLID, 2, vlngColor
    
    With mobjGFX
        
        Set .SetDeviceContext = vobjDC
        Set .SetBrush = mobjBrush
        Set .SetPen = mobjPen
            
        .DrawRectangle 1, 1, vobjDC.GetWidth, vobjDC.GetHeight
            
    End With
    
    
    BlitColor = True
    
End Function

' DeviceContext zur grafischen ausgaben zeichnen
Public Function DrawOutputDC() As Boolean

    Dim blnResult As Boolean


    ' Fllfarbe der Sanduhr
    blnResult = BlitColor(mobjOutputDC, mlngHourglassFillColor)
    
    ' Sandkrner zeichen
    If blnResult Then
        blnResult = DrawGrains
    End If

    ' Sanduhr zeichnen
    If blnResult Then
        blnResult = DrawHourglass
    End If
    
    
    ' Grafik hat sich gendert
    RaiseEvent GFXHasChanged
    
    
    DrawOutputDC = blnResult

End Function

' Sandkrner zeichnen
Private Function DrawGrains() As Boolean

    Dim objGrain As clsGrain
    

    ' Farbe der Sandkrner zuweisen
    mobjPen.Create PS_SOLID, 1, mlngGrainColor
    mobjBrush.Create mlngGrainColor
    
    With mobjGFX
        
        ' DC wurde bereits durch BlitColor selektiert
        'Set .SetDeviceContext = mobjOutputDC
        Set .SetPen = mobjPen
        Set .SetBrush = mobjBrush
    
        ' alle Sandkrner durchlaufen
        For Each objGrain In mcolGrains
            ' Sandkorn zeichnen
            .DrawRectangle _
                (objGrain.Point.x - 1) * mlngGrainSize, _
                (objGrain.Point.y - 1) * mlngGrainSize, _
                objGrain.Point.x * mlngGrainSize, _
                objGrain.Point.y * mlngGrainSize
        Next
    
    End With
    
    
    DrawGrains = True
    
End Function

' Sanduhr zeichnen
Private Function DrawHourglass() As Boolean

    Dim udtSrcRect As RECT

    
    With udtSrcRect
        .lngLeft = 0
        .lngTop = 0
        .lngRight = .lngLeft + mobjHourglassDC.GetWidth
        .lngBottom = .lngTop + mobjHourglassDC.GetHeight
    End With


    With mobjGFX
    
        ' DC wurde bereits durch BlitColor selektiert
        '.SetDeviceContext = mobjOutputDC
        
        .TranspPic mobjOutputDC.GetDC, mobjOutputDC.GetDC, mobjHourglassDC.GetDC, _
            udtSrcRect, 0, 0, mconCOLOR_TRANSPARENT

    End With
    
    
    DrawHourglass = True

End Function

' Hhe der bergebenen Polygone ermitteln
' Summe bilden reicht nicht, da zwischen oberen und unterem Polygon ein beliebig groer
' Zwischenraum sein darf
Private Function GetPolyHeight( _
    ByVal vobjUpperPoly As clsPolygon, _
    ByVal vobjLowerPoly As clsPolygon) As Long
    
    Dim objPoint As clsPoint
    Dim objPoly As clsPolygon
    Dim lngHeight As Long
    
    
    Set objPoly = New clsPolygon
    
    ' einzelnes Polygon aus den beiden Polygonen erzeugen
    For Each objPoint In mobjUpperGlassPoly.ColPoints
        objPoly.Add objPoint.x, objPoint.y
    Next
    
    For Each objPoint In mobjLowerGlassPoly.ColPoints
        objPoly.Add objPoint.x, objPoint.y
    Next
    
    ' Hhe ermitteln
    lngHeight = objPoly.GetBoundaryRect.GetHeight
    
    Set objPoly = Nothing
    
    
    GetPolyHeight = lngHeight
    
End Function
