VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum enuFieldState
    enuFSNothing = 0
    enuFSBlocked = 1
    enuFSfree = 2
    enuFSGrain = 3
End Enum

Private maenuFieldState() As enuFieldState
Private mobjUpperGlassRect As clsRect
Private mobjLowerGlassRect As clsRect
Private mobjMapRect As clsRect
Private mlngGrainSize As Long

Public Property Get GetMapRect() As clsRect

    Set GetMapRect = mobjMapRect

End Property

Public Property Get GetUpperGlassRect() As clsRect

    Set GetUpperGlassRect = mobjUpperGlassRect

End Property

Public Property Get GetLowerGlassRect() As clsRect

    Set GetLowerGlassRect = mobjLowerGlassRect

End Property

' Map erzeugen
Public Function Create( _
    ByVal vobjPolygon As clsPolygon, _
    ByVal vobjRegion As clsRegion, _
    ByVal vobjUpperGlassRect As clsRect, _
    ByVal vlngGrainSize As Long) As Boolean

    Dim blnResult As Boolean
   

    mlngGrainSize = vlngGrainSize
    
    ' Dimensionen der Map erzeugen
    blnResult = CreateMapDimension(vobjPolygon)
    
    ' Matrix der Map initialisieren
    If blnResult Then
        blnResult = CreateMapMatrix(vobjRegion)
    End If
    
    ' oberen und unteren Teil der Sanduhr definieren
    If blnResult Then
        blnResult = CreateMapRect(vobjUpperGlassRect)
    End If

    
    Create = blnResult

End Function

' Matrix der Map erzeugen
Private Function CreateMapMatrix(ByVal vobjRegion As clsRegion) As Boolean

    Dim lngX As Long
    Dim lngY As Long
    Dim objRect As clsRect
    Dim blnIsRectInRegion As Boolean
    
    
    Set objRect = New clsRect
    
    ' gesamte Matrix durchlaufen
    For lngX = LBound(maenuFieldState, 1) To UBound(maenuFieldState, 1)
        For lngY = LBound(maenuFieldState, 2) To UBound(maenuFieldState, 2)
        
            With objRect
                .Left = (lngX - 1) * mlngGrainSize
                .Top = (lngY - 1) * mlngGrainSize
                .Right = lngX * mlngGrainSize
                .Bottom = lngY * mlngGrainSize
            End With
            
            ' prfen, ob Rechteck in Region ist
            blnIsRectInRegion = vobjRegion.IsRectInRegion(objRect)
    
            ' wenn Rechteck in Region ist, soll Feld frei bleiben
            If blnIsRectInRegion Then
                maenuFieldState(lngX, lngY) = enuFSfree
            Else
                maenuFieldState(lngX, lngY) = enuFSBlocked
            End If
    
        Next lngY
    Next lngX
    
    
    Set objRect = Nothing
    
    CreateMapMatrix = True

End Function

' Rechteck fr oberen und unteren Teil der Sanduhr erzeugen
' Rechteck des unteren Teils der Sanduhr ist abhngig von Gre des oberen Teils der Sanduhr
Private Function CreateMapRect(ByVal vobjUpperRect As clsRect) As Boolean
            
    ' oberer Teil der Sanduhr
    With mobjUpperGlassRect
        .Left = mobjMapRect.Left
        .Top = mobjMapRect.Top
        .Right = mobjMapRect.Right
        .Bottom = Fix(vobjUpperRect.GetHeight / mlngGrainSize)
    End With
    
    ' unterer Teil der Sanduhr
    With mobjLowerGlassRect
        .Left = mobjMapRect.Left
        .Top = mobjUpperGlassRect.Bottom + 1
        .Right = mobjMapRect.Right
        .Bottom = mobjMapRect.Bottom
    End With
    
    
    CreateMapRect = True
    
End Function

' Gre der Map festlegen
Private Function CreateMapDimension(ByVal vobjPolygon As clsPolygon) As Boolean
        
    Dim lngWidth As Long
    Dim lngHeight As Long
    Dim lngPolyWidth As Long
    Dim lngPolyHeight As Long
    
    
    ' Hhe/Breite des Polygons
    lngPolyWidth = vobjPolygon.GetBoundaryRect.GetWidth
    lngPolyHeight = vobjPolygon.GetBoundaryRect.GetHeight
    
    ' Breite der Map bestimmen
    lngWidth = Fix(lngPolyWidth / mlngGrainSize)
    
    If lngWidth <> (lngPolyWidth / mlngGrainSize) Then
        lngWidth = lngWidth + 1
    End If
    
    ' Hhe der Map bestimmen
    lngHeight = Fix(lngPolyHeight / mlngGrainSize)
    
    If lngHeight <> (lngPolyHeight / mlngGrainSize) Then
        lngHeight = lngHeight + 1
    End If
    
    ' Rechteck, welches Map umfasst, festlegen
    With mobjMapRect
        .Left = 1
        .Top = 1
        .Right = lngWidth
        .Bottom = lngHeight
    End With
    
    ' Speicher reservieren
    ReDim maenuFieldState(1 To lngWidth, 1 To lngHeight)
    
    
    CreateMapDimension = True
    
End Function
    
' Feldstatus von Position X/Y ermitteln
Public Function GetFieldState( _
    ByVal vlngX As Long, _
    ByVal vlngY As Long) As enuFieldState
            
    Dim enuRetVal As enuFieldState
    
    
    enuRetVal = enuFSNothing
    
    ' prfen, ob sich Position im gltigen Bereich befindet
    If vlngX >= mobjMapRect.Left And vlngX <= mobjMapRect.Right Then
        If vlngY >= mobjMapRect.Top And vlngY <= mobjMapRect.Bottom Then
                
            ' Status ermitteln
            enuRetVal = maenuFieldState(vlngX, vlngY)
            
        End If
    End If
    
            
    GetFieldState = enuRetVal
    
End Function

' Feldstatus an Position X/Y setzen
Public Function SetFieldState( _
    ByVal vlngX As Long, _
    ByVal vlngY As Long, _
    ByVal venuFieldstate As enuFieldState) As Boolean
   
    Dim blnResult As Boolean
    
    
    blnResult = False
   
    ' prfen, ob sich Position im gltigen Bereich befindet
    If vlngX >= mobjMapRect.Left And vlngX <= mobjMapRect.Right Then
        If vlngY >= mobjMapRect.Top And vlngY <= mobjMapRect.Bottom Then
                
            ' Status setzen
            maenuFieldState(vlngX, vlngY) = venuFieldstate
            blnResult = True
            
        End If
    End If
    
    
    SetFieldState = blnResult

End Function

' ermittelt, wieviele Krner maximal in die Sanduhr passen
Public Function GetMaxElements() As Long

    Dim lngCountUpperGlass As Long
    Dim lngCountLowerGlass As Long
    Dim lngMaxElements As Long
    
    
    ' freie Felder im oberen Teil zhlen
    lngCountUpperGlass = CountElementsInRect(mobjUpperGlassRect, enuFSfree)
    
    ' freie Felder im unteren Teil zhlen
    lngCountLowerGlass = CountElementsInRect(mobjLowerGlassRect, enuFSfree)
    
    ' kleineren Wert ermitteln
    lngMaxElements = lngCountUpperGlass
    
    If lngCountLowerGlass < lngMaxElements Then
        lngMaxElements = lngCountLowerGlass
    End If
        
    
    GetMaxElements = lngMaxElements

End Function

' Anzahl Elemente mit bestimmten Status in Rechteck definieren
Public Function CountElementsInRect( _
    ByVal vobjRect As clsRect, _
    ByVal venuFieldstate As enuFieldState) As Long
    
    Dim lngX As Long
    Dim lngY As Long
    Dim lngElements As Long
    
    
    lngElements = 0
    
    With vobjRect
        
        ' alle Felder des Rechtecks durchlaufen
        For lngX = .Left To .Right
            For lngY = .Top To .Bottom
            
                ' Status vergleichen
                If maenuFieldState(lngX, lngY) = venuFieldstate Then
                    lngElements = lngElements + 1
                End If
                
            Next lngY
        Next lngX
        
    End With


    CountElementsInRect = lngElements

End Function

' alle Felder, die blockiert sind, als frei markieren
Public Function ClearFields() As Boolean

    Dim lngX As Long
    Dim lngY As Long
    
    
    With mobjMapRect
        
        ' alle Felder des Rechtecks durchlaufen
        For lngX = .Left To .Right
            For lngY = .Top To .Bottom
                    
                ' wenn Feld nicht blockiert ist, dann Feld auf frei setzen
                If maenuFieldState(lngX, lngY) <> enuFSBlocked Then
                    maenuFieldState(lngX, lngY) = enuFSfree
                End If
            
            Next lngY
        Next lngX
    
    End With
    

    ClearFields = True

End Function

Private Sub Class_Initialize()

    Set mobjMapRect = New clsRect
    Set mobjUpperGlassRect = New clsRect
    Set mobjLowerGlassRect = New clsRect
    
End Sub

Private Sub Class_Terminate()

    Set mobjMapRect = Nothing
    Set mobjUpperGlassRect = Nothing
    Set mobjLowerGlassRect = Nothing

End Sub
