VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPolygon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mcolPoints As ColPoints
Private mobjBoundaryRect As clsRect

' wird lediglich intern fr Clone() Methode bentigt, nicht zum Aufruf von auen gedacht
Friend Property Set ColPoints(ByVal vobjPoints As ColPoints)

    Set mcolPoints = vobjPoints

End Property

Public Property Get ColPoints() As ColPoints

    Set ColPoints = mcolPoints

End Property

' Punkt dem Polygon hinzufgen
Public Function Add( _
    ByVal vlngX As Long, _
    ByVal vlngY As Long) As Boolean
    
    Dim objPoint As clsPoint
    
    
    ' neuen Punkt erzeugen und initalisieren
    Set objPoint = New clsPoint
    
    With objPoint
        .x = vlngX
        .y = vlngY
    End With
    
    ' Objekt der Collection hinzufgen
    mcolPoints.Add objPoint
    
    
    Set objPoint = Nothing
    
    Add = True

End Function

' alle Punkte des Polygons lschen
Public Function Clear() As Boolean

    ' Collection aus Speicher entfernen und neue Collection erzeugen
    Set mcolPoints = Nothing
    Set mcolPoints = New ColPoints

    Clear = True

End Function

' Gre des Polygons ndern
Public Function Resize( _
    ByVal vlngNewWidth As Long, _
    ByVal vlngNewHeight As Long)
    
    Dim objPoint As clsPoint
    Dim objBoundaryRect As clsRect
    
    
    Set objBoundaryRect = GetBoundaryRect
    
    ' alle Punkte an neue Gre anpassen
    For Each objPoint In mcolPoints
    
        ' Grenverhltnis bleibt erhalten
        With objPoint
            .x = (.x / objBoundaryRect.GetWidth) * vlngNewWidth
            .y = (.y / objBoundaryRect.GetHeight) * vlngNewHeight
        End With
    
    Next
    

    Set objBoundaryRect = Nothing
    
    Resize = True

End Function

' Polygon in X/Y Richtung bewegen
Public Function Move( _
    ByVal vlngXOffset As Long, _
    ByVal vlngYOffset As Long) As Boolean
        
    Dim objPoint As clsPoint
    
    
    ' alle Punkte verschieben
    For Each objPoint In mcolPoints
    
        ' neue Koordinaten setzen
        With objPoint
            .x = .x + vlngXOffset
            .y = .y + vlngYOffset
        End With
    
    Next
    
    
    Move = True
    
End Function

' Kopie des Polygons erzeugen
Public Function Clone() As clsPolygon

    Dim objPolyClone As clsPolygon
    Dim objPoint As clsPoint
    
    
    Set objPolyClone = New clsPolygon
    
    ' alle Punkte speichern
    For Each objPoint In mcolPoints
        objPolyClone.ColPoints.Add objPoint.Clone
    Next

    
    Set Clone = objPolyClone
    
    Set objPolyClone = Nothing

End Function

' Polygon horizontal spiegeln
Public Function RotateHorizontally() As Boolean

    Dim objBoundaryRect As clsRect
    Dim objPoint As clsPoint
    
    
    Set objBoundaryRect = GetBoundaryRect
    
    ' alle Punkte rotieren
    For Each objPoint In mcolPoints
    
        With objPoint
            ' Punkt horizontal spiegeln
            .y = objBoundaryRect.Bottom - (.y - objBoundaryRect.Top)
        End With
    
    Next
    
    Set objBoundaryRect = Nothing
    
    
    RotateHorizontally = True

End Function

' Polygon vertikal spiegeln
Public Function RotateVertically() As Boolean

    Dim objBoundaryRect As clsRect
    Dim objPoint As clsPoint
    
    
    Set objBoundaryRect = GetBoundaryRect
    
    ' alle Punkte rotieren
    For Each objPoint In mcolPoints
    
        With objPoint
            ' Punkt horizontal spiegeln
            .x = objBoundaryRect.Right - (.x - objBoundaryRect.Left)
        End With
    
    Next
    
    Set objBoundaryRect = Nothing
    
    
    RotateVertically = True

End Function

' Umgebungsrechteck des Polygons ermitteln
Public Function GetBoundaryRect() As clsRect

    Dim objPoint As clsPoint
    
    
    ' Standardwerte irgendeines Punktes setzen
    If mcolPoints.Count > 0 Then
        With mobjBoundaryRect
            .Left = mcolPoints.Item(1).x
            .Right = mcolPoints.Item(1).x
            .Top = mcolPoints.Item(1).y
            .Bottom = mcolPoints.Item(1).y
        End With
    End If
    
    ' BoundaryRect ber alle Punkte erstellen
    For Each objPoint In mcolPoints
    
        With mobjBoundaryRect
            ' linke Kante
            If .Left > objPoint.x Then
                .Left = objPoint.x
            End If
            
            ' rechte Kante
            If .Right < objPoint.x Then
                .Right = objPoint.x
            End If
            
            ' obere Kante
            If .Top > objPoint.y Then
                .Top = objPoint.y
            End If
            
            ' untere Kante
            If .Bottom < objPoint.y Then
                .Bottom = objPoint.y
            End If
        End With
    
    Next
    
    
    Set GetBoundaryRect = mobjBoundaryRect

End Function

' Punkte als Array vom Typ POINTAPI zurckgeben
Public Function GetPOINTAPIArray() As POINTAPI()

    Dim lngIndex As Long
    Dim objPoint As clsPoint
    Dim audtPoint() As POINTAPI
    
    
    ' Index des ersten Array-Elementes
    lngIndex = 1
    
    ' Array mit der entsprechenden Anzahl von Elementen dimensionieren
    ReDim audtPoint(lngIndex To mcolPoints.Count)
    
    ' alle Punkte des Polygons durchlaufen
    For Each objPoint In mcolPoints
    
        ' Punkt im Array Wert zuweisen
        audtPoint(lngIndex) = objPoint.GetPOINTAPI
        
        ' Zhler erhhen
        lngIndex = lngIndex + 1
    
    Next
    
    
    GetPOINTAPIArray = audtPoint

End Function

Private Sub Class_Initialize()

    Set mobjBoundaryRect = New clsRect
    Set mcolPoints = New ColPoints

End Sub

Private Sub Class_Terminate()

    Set mobjBoundaryRect = Nothing
    Set mcolPoints = Nothing

End Sub
