VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRegion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function PtInRegion Lib "gdi32" (ByVal hRgn As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function RectInRegion Lib "gdi32" (ByVal hRgn As Long, lpRect As RECT) As Long

Private mlngRegion As Long

Public Property Get GetRegion() As Long

    GetRegion = mlngRegion

End Property

' Region erzeugen
Public Function Create(ByVal vobjPolygon As clsPolygon) As Boolean

    Dim audtPoint() As POINTAPI


    ' es wurde bereits eine Region erzeugt -> alte entfernen
    If mlngRegion <> 0 Then
        Delete
    End If
    
    ' Array von Punkten erzeugen
    audtPoint = vobjPolygon.GetPOINTAPIArray
    
    ' Region erzeugen
    mlngRegion = CreatePolygonRgn(audtPoint(LBound(audtPoint)), _
        vobjPolygon.ColPoints.Count, 1)
    
    
    Create = True

End Function

' prfen, ob sich ein Punkt in der Region befindet
Public Function IsPointInRegion( _
    ByVal vlngX As Long, _
    ByVal vlngY As Long) As Boolean

    Dim blnIsPointInRegion As Boolean
    Dim lngIsPointInRegion As Long
    
    
    blnIsPointInRegion = False
    
    ' prfen, ob Region definiert wurde
    If mlngRegion <> 0 Then
    
        ' prfen, ob Punkt in Region ist
        lngIsPointInRegion = PtInRegion(mlngRegion, vlngX, vlngY)
    
        ' Rckgabe ist ungleich 0, wenn Punkt in Region ist
        If lngIsPointInRegion <> 0 Then
            blnIsPointInRegion = True
        End If
    
    End If
    
    
    IsPointInRegion = blnIsPointInRegion

End Function

' prfen, ob sich Rechteck in der Region befindet
Public Function IsRectInRegion(ByVal vobjRect As clsRect) As Boolean

    Dim blnIsRectInRegion As Boolean
    Dim lngIsRectInRegion As Long

    
    blnIsRectInRegion = False
    
    ' prfen, ob Region definiert wurde
    If mlngRegion <> 0 Then
        
        ' prfen, ob sich Rechteck in der Region befindet
        lngIsRectInRegion = RectInRegion(mlngRegion, vobjRect.GetRECT)
    
        ' Rckgabe ist ungleich 0, wenn Rechteck in Region ist
        If lngIsRectInRegion <> 0 Then
            blnIsRectInRegion = True
        End If
    
    End If
    
    
    IsRectInRegion = blnIsRectInRegion

End Function

' Region entfernen
Public Function Delete() As Boolean

    ' pfen, ob Region existiert
    If mlngRegion <> 0 Then
    
        ' Region aus Speicher entfernen
        DeleteObject mlngRegion
    
    End If
    
    
    Delete = True

End Function

Private Sub Class_Initialize()

    mlngRegion = 0

End Sub

Private Sub Class_Terminate()

    ' Region aus Speicher entfernen
    Delete

End Sub

