VERSION 5.00
Begin VB.UserControl ctlHourglass 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1350
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   900
   ScaleHeight     =   1350
   ScaleWidth      =   900
End
Attribute VB_Name = "ctlHourglass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Private Const mconDEFAULT_MIN = 0
Private Const mconDEFAULT_MAX = 100
Private Const mconDEFAULT_VALUE = 0
Private Const mconDEFAULT_GRAINSIZE = 5
Private Const mconDEFAULT_GRAINCOLOR = &HC0FFFF
Private Const mconDEFAULT_HOURGLASSTHICKNESS = 2
Private Const mconDEFAULT_HOURGLASSBACKCOLOR = &H0
Private Const mconDEFAULT_HOURGLASSFILLCOLOR = &H0
Private Const mconDEFAULT_HOURGLASSBORDERCOLOR = &H80FF&
Private Const mconDEFAULT_HOURGLASSSTYLE = 0
Private Const mconDEFAULT_WIDTH = 50
Private Const mconDEFAULT_HEIGHT = 80


Private WithEvents mobjHourglass As clsHourglass
Attribute mobjHourglass.VB_VarHelpID = -1

Private mblnInitInProgress As Boolean
Private mblnHourglassChanged As Boolean
Private mblnColorChanged As Boolean
Private mblnValueChanged As Boolean
Private mblnSizeChanged As Boolean

Private mlngGrainSize As Long
Private moleGrainColor As OLE_COLOR

Private mlngHourglassThickness As Long
Private moleHourglassBackColor As OLE_COLOR
Private moleHourglassBorderColor As OLE_COLOR
Private moleHourglassFillColor As OLE_COLOR

Private mobjLowerGlassPoly As clsPolygon
Private mobjUpperGlassPoly As clsPolygon

Private menuHourglassStyle As enuHourglassStyle

Public Enum enuHourglassStyle
    enuHGClassic = 0
    enuHGModern = 1
    enuHGTwins = 2
End Enum

Public Property Set SetUpperGlassPoly(ByVal vobjPoly As clsPolygon)

    Set mobjUpperGlassPoly = vobjPoly.Clone

End Property

Public Property Set SetLowerGlassPoly(ByVal vobjPoly As clsPolygon)

    Set mobjLowerGlassPoly = vobjPoly.Clone

End Property

Public Property Let Value(ByVal vlngValue As Long)
Attribute Value.VB_Description = "aktueller Wert"

    mobjHourglass.Value = vlngValue

    mblnValueChanged = True
    UpdateHourglass

End Property

Public Property Get Value() As Long

    Value = mobjHourglass.Value

End Property

Public Property Let Max(ByVal vlngValue As Long)
Attribute Max.VB_Description = "maximaler Wert"

    mobjHourglass.Max = vlngValue
    
    mblnValueChanged = True
    UpdateHourglass

End Property

Public Property Get Max() As Long

    Max = mobjHourglass.Max

End Property

Public Property Let Min(ByVal vlngValue As Long)
Attribute Min.VB_Description = "minimaler Wert"

    mobjHourglass.Min = vlngValue
    
    mblnValueChanged = True
    UpdateHourglass

End Property

Public Property Get Min() As Long

    Min = mobjHourglass.Min

End Property

Public Property Let HourglassThickness(ByVal vlngValue As Long)
Attribute HourglassThickness.VB_Description = "Dicke des Glases der Sanduhr"

    mobjHourglass.HourglassThickness = vlngValue
    mlngHourglassThickness = mobjHourglass.HourglassThickness
    
    mblnColorChanged = True
    UpdateHourglass

End Property

Public Property Get HourglassThickness() As Long

    HourglassThickness = mlngHourglassThickness

End Property

Public Property Let GrainSize(ByVal vlngValue As Long)
Attribute GrainSize.VB_Description = "Gre eines Sandkorns"

    mobjHourglass.GrainSize = vlngValue
    mlngGrainSize = mobjHourglass.GrainSize
    
    mblnHourglassChanged = True
    UpdateHourglass

End Property

Public Property Get GrainSize() As Long

    GrainSize = mlngGrainSize

End Property

Public Property Let GrainColor(ByVal voleValue As OLE_COLOR)
Attribute GrainColor.VB_Description = "Farbe der Sandkrner"

    mobjHourglass.GrainColor = voleValue
    moleGrainColor = mobjHourglass.GrainColor
    
    mblnColorChanged = True
    UpdateHourglass

End Property

Public Property Get GrainColor() As OLE_COLOR

    GrainColor = moleGrainColor

End Property

Public Property Let HourglassFillColor(ByVal voleValue As OLE_COLOR)
Attribute HourglassFillColor.VB_Description = "Hintergrundfarbe innerhalb der Sanduhr"

    mobjHourglass.HourglassFillColor = voleValue
    moleHourglassFillColor = mobjHourglass.HourglassFillColor
    
    mblnColorChanged = True
    UpdateHourglass

End Property

Public Property Get HourglassFillColor() As OLE_COLOR

    HourglassFillColor = moleHourglassFillColor

End Property

Public Property Let HourglassBorderColor(ByVal voleValue As OLE_COLOR)
Attribute HourglassBorderColor.VB_Description = "Farbe des Glases der Sanduhr"

    mobjHourglass.HourglassBorderColor = voleValue
    moleHourglassBorderColor = mobjHourglass.HourglassBorderColor
    
    mblnColorChanged = True
    UpdateHourglass

End Property

Public Property Get HourglassBorderColor() As OLE_COLOR

    HourglassBorderColor = moleHourglassBorderColor

End Property

Public Property Let HourglassBackColor(ByVal voleValue As OLE_COLOR)
Attribute HourglassBackColor.VB_Description = "Hintergrundfarbe auerhalb der Sanduhr"

    mobjHourglass.HourglassBackColor = voleValue
    moleHourglassBackColor = mobjHourglass.HourglassBackColor
    
    mblnColorChanged = True
    UpdateHourglass

End Property

Public Property Get HourglassBackColor() As OLE_COLOR

    HourglassBackColor = moleHourglassBackColor

End Property

Public Property Let HourglassStyle(ByVal venuValue As enuHourglassStyle)
Attribute HourglassStyle.VB_Description = "Auswahl einer vorgefertigten Sanduhr"

    menuHourglassStyle = venuValue
    ApplyHourglassStyle

    mobjHourglass.Width = mobjHourglass.Width
    mobjHourglass.Height = mobjHourglass.Height

    mblnSizeChanged = True
    mblnHourglassChanged = True
    UpdateHourglass

End Property

Public Property Get HourglassStyle() As enuHourglassStyle

    HourglassStyle = menuHourglassStyle

End Property

' Grafik hat sich gendert, nderung anzeigen
Private Sub mobjHourglass_GFXHasChanged()

    With mobjHourglass
        BitBlt UserControl.hdc, 0, 0, .Width, .Height, .GetOutputHDC, 0, 0, vbSrcCopy
    End With
        
    UserControl.Refresh
        
End Sub

' Initialisierungsarbeiten
Private Sub UserControl_Initialize()

    mblnInitInProgress = True
    mblnHourglassChanged = True
    mblnValueChanged = True
    mblnSizeChanged = True
    mblnColorChanged = True
    
    Set mobjLowerGlassPoly = New clsPolygon
    Set mobjUpperGlassPoly = New clsPolygon

    Set mobjHourglass = New clsHourglass
    
    mobjHourglass.CompatibleHDC = UserControl.hdc

End Sub

' Standardwerte setzen
Private Sub UserControl_InitProperties()

    mblnInitInProgress = True

    Min = mconDEFAULT_MIN
    Max = mconDEFAULT_MAX
    Value = mconDEFAULT_VALUE

    GrainSize = mconDEFAULT_GRAINSIZE
    GrainColor = mconDEFAULT_GRAINCOLOR

    HourglassThickness = mconDEFAULT_HOURGLASSTHICKNESS
    HourglassBackColor = mconDEFAULT_HOURGLASSBACKCOLOR
    HourglassFillColor = mconDEFAULT_HOURGLASSFILLCOLOR
    HourglassBorderColor = mconDEFAULT_HOURGLASSBORDERCOLOR

    HourglassStyle = mconDEFAULT_HOURGLASSSTYLE
    
    UserControl.Width = mconDEFAULT_WIDTH * Screen.TwipsPerPixelX
    UserControl.Height = mconDEFAULT_HEIGHT * Screen.TwipsPerPixelY


    mblnInitInProgress = False
    UpdateHourglass

End Sub

' benutzerdefinierte Einstellungen lesen
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    mblnInitInProgress = True

    Min = PropBag.ReadProperty("Min", mconDEFAULT_MIN)
    Max = PropBag.ReadProperty("Max", mconDEFAULT_MAX)
    Value = PropBag.ReadProperty("Value", mconDEFAULT_VALUE)

    GrainSize = PropBag.ReadProperty("GrainSize", mconDEFAULT_GRAINSIZE)
    GrainColor = PropBag.ReadProperty("GrainColor", mconDEFAULT_GRAINCOLOR)

    HourglassThickness = PropBag.ReadProperty("HourglassThickness", mconDEFAULT_HOURGLASSTHICKNESS)
    HourglassBackColor = PropBag.ReadProperty("HourglassBackColor", mconDEFAULT_HOURGLASSBACKCOLOR)
    HourglassFillColor = PropBag.ReadProperty("HourglassFillColor", mconDEFAULT_HOURGLASSFILLCOLOR)
    HourglassBorderColor = PropBag.ReadProperty("HourglassBorderColor", mconDEFAULT_HOURGLASSBORDERCOLOR)

    HourglassStyle = PropBag.ReadProperty("HourglassStyle", mconDEFAULT_HOURGLASSSTYLE)

    UserControl.Width = PropBag.ReadProperty("CtlWidth", mconDEFAULT_WIDTH)
    UserControl.Height = PropBag.ReadProperty("CtlHeight", mconDEFAULT_HEIGHT)


    mblnInitInProgress = False
    UpdateHourglass

End Sub

' Gre der Sanduhr anpassen
Private Sub UserControl_Resize()

    ' durch nderung der Gre bekommt Control neue HDC zugewiesen
    mobjHourglass.CompatibleHDC = UserControl.hdc
    
    mblnSizeChanged = True
    mblnHourglassChanged = True
    UpdateHourglass
                    
End Sub

' Aufrumarbeiten
Private Sub UserControl_Terminate()

    Set mobjUpperGlassPoly = Nothing
    Set mobjLowerGlassPoly = Nothing
    Set mobjHourglass = Nothing

End Sub

' ausgewhlten Style setzen
Private Function ApplyHourglassStyle() As Boolean

    Dim blnResult As Boolean


    Select Case menuHourglassStyle
    
        Case enuHourglassStyle.enuHGClassic
            blnResult = ApplyHGClassic
            
        Case enuHourglassStyle.enuHGTwins
            blnResult = ApplyHGTwins
            
        Case enuHourglassStyle.enuHGModern
            blnResult = ApplyHGModern
        
    End Select
    

    ApplyHourglassStyle = blnResult

End Function

' enuHGModern Style setzen
Private Function ApplyHGModern() As Boolean

    Dim objUpperPoly As clsPolygon
    Dim objLowerPoly As clsPolygon


    Set objUpperPoly = New clsPolygon

    ' upper polygon
    With objUpperPoly
        .Add 40, 80
        .Add 0, 40
        .Add 0, 20
        .Add 40, 0
        .Add 60, 0
        .Add 100, 20
        .Add 100, 40
        .Add 60, 80
    End With

    ' lower polygon
    Set objLowerPoly = objUpperPoly.Clone
    objLowerPoly.RotateHorizontally
    objLowerPoly.RotateVertically
    objLowerPoly.Move 0, 100

    Set mobjHourglass.SetLowerGlassPoly = objLowerPoly
    Set mobjHourglass.SetUpperGlassPoly = objUpperPoly


    Set objUpperPoly = Nothing
    Set objLowerPoly = Nothing


    ApplyHGModern = True
    
End Function

' enuHGClassic Style setzen
Private Function ApplyHGClassic() As Boolean

    Dim objUpperPoly As clsPolygon
    Dim objLowerPoly As clsPolygon


    Set objUpperPoly = New clsPolygon
    Set objLowerPoly = New clsPolygon

    ' upper polygon
    With objUpperPoly
        .Add 65, 140
        .Add 0, 100
        .Add 0, 0
        .Add 140, 0
        .Add 140, 100
        .Add 75, 140
    End With

    
    ' lower polygon
    Set objLowerPoly = objUpperPoly.Clone
    objLowerPoly.RotateHorizontally
    objLowerPoly.RotateVertically
    objLowerPoly.Move 0, 150


    Set mobjHourglass.SetLowerGlassPoly = objLowerPoly
    Set mobjHourglass.SetUpperGlassPoly = objUpperPoly


    Set objUpperPoly = Nothing
    Set objLowerPoly = Nothing


    ApplyHGClassic = True

End Function

' enuHGTwins Style setzen
Private Function ApplyHGTwins() As Boolean

    Dim objUpperPoly As clsPolygon
    Dim objLowerPoly As clsPolygon
    
    
    Set objUpperPoly = New clsPolygon
    Set objLowerPoly = New clsPolygon

    ' upper polygon
    With objUpperPoly
        .Add 35, 90
        .Add 35, 80
        .Add 0, 0
        .Add 80, 0
        .Add 45, 80
        .Add 85, 85
        .Add 125, 80
        .Add 90, 0
        .Add 170, 0
        .Add 135, 80
        .Add 135, 90
    End With

    ' lower polygon
    With objLowerPoly
        '.Add 135, 90
        .Add 170, 170
        .Add 90, 170
        .Add 125, 90
        .Add 85, 85
        .Add 45, 90
        .Add 80, 170
        .Add 0, 170
        .Add 35, 90
    End With

    Set mobjHourglass.SetLowerGlassPoly = objLowerPoly
    Set mobjHourglass.SetUpperGlassPoly = objUpperPoly
    
    
    Set objUpperPoly = Nothing
    Set objLowerPoly = Nothing


    ApplyHGTwins = True

End Function

' benutzerdefinierte Einstellungen speichern
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    PropBag.WriteProperty "Min", mobjHourglass.Min
    PropBag.WriteProperty "Max", mobjHourglass.Max
    PropBag.WriteProperty "Value", mobjHourglass.Value
    
    PropBag.WriteProperty "GrainSize", mlngGrainSize
    PropBag.WriteProperty "GrainColor", moleGrainColor

    PropBag.WriteProperty "HourglassThickness", mlngHourglassThickness
    PropBag.WriteProperty "HourglassBackColor", moleHourglassBackColor
    PropBag.WriteProperty "HourglassFillColor", moleHourglassFillColor
    PropBag.WriteProperty "HourglassBorderColor", moleHourglassBorderColor

    PropBag.WriteProperty "HourglassStyle", menuHourglassStyle
    
    PropBag.WriteProperty "CtlWidth", UserControl.Width
    PropBag.WriteProperty "CtlHeight", UserControl.Height

End Sub

' Sanduhr aktualisieren
Private Function UpdateHourglass() As Boolean

    Dim blnResult As Boolean
    
    
    blnResult = True
    
    ' nicht ausfhren, falls Initialisierungsarbeiten noch nicht beendet sind
    If Not mblnInitInProgress Then
        
        ' Grenanpassung
        If mblnSizeChanged Then
            mobjHourglass.Width = UserControl.Width / Screen.TwipsPerPixelX
            mobjHourglass.Height = UserControl.Height / Screen.TwipsPerPixelY
            mobjHourglass.ResizeHourglass
            
            mblnSizeChanged = False
        End If
    
        ' Sanduhr muss neu initialisiert werden
        If mblnHourglassChanged Then
            blnResult = mobjHourglass.CreateHourglass
            mblnHourglassChanged = False
            
            ' macht andere Anpassungen berflssig
            mblnValueChanged = False
            mblnColorChanged = False
        
        ' Fllgehalt der Sanduhr aktualisieren
        ElseIf mblnValueChanged Then
            blnResult = mobjHourglass.SetPercent
            mblnValueChanged = False
            
        ' Farben aktualisieren
        ElseIf mblnColorChanged Then
            blnResult = mobjHourglass.CreateDCs
            
            If blnResult Then
                mobjHourglass.DrawOutputDC
            End If
            
            mblnColorChanged = True
        End If
    
    End If


    UpdateHourglass = blnResult

End Function

' benutzerdefinierte Sanduhr erstellen
Public Function CreateHourglass() As Boolean

    Dim blnResult As Boolean
    
    
    Set mobjHourglass.SetLowerGlassPoly = mobjLowerGlassPoly
    Set mobjHourglass.SetUpperGlassPoly = mobjUpperGlassPoly
    
    ' Sanduhr an Gre anpassen
    blnResult = mobjHourglass.ResizeHourglass
    
    ' Sanduhr erzeugen
    If blnResult Then
        blnResult = mobjHourglass.CreateHourglass
    End If
    

    CreateHourglass = blnResult

End Function
