VERSION 5.00
Begin VB.UserControl MLLabel 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   2730
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3675
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   24
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   MousePointer    =   99  'Custom
   ScaleHeight     =   182
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   245
   ToolboxBitmap   =   "MLLabel.ctx":0000
   Begin VB.PictureBox picTmp 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   795
      Left            =   0
      ScaleHeight     =   53
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   77
      TabIndex        =   0
      Top             =   -1.50000e5
      Width           =   1155
   End
End
Attribute VB_Name = "MLLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
'****************************** MLLabel.CTL ******************************************
' Autor:           Interflo(@gmx.de)
' Erstellt:        05.12.2005
' Letzte nderung: 26.12.2005
' Erstellt fr:    www.ActiveVb.de - Weihnachtsausschreibung 2005
'*************************************************************************************

Option Explicit

'Event Declarations:
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Event Resize() 'MappingInfo=UserControl,UserControl,-1,Resize
Attribute Resize.VB_Description = "Occurs when a form is first displayed or the size of an object changes."

Enum enmBorderStyle
  [Kein] = 0
  [Fest-Einfach] = 1
End Enum

Enum enmTagFunction
  [SetBold] = 0
  [SetItalic] = 1
  [SetUnderline] = 2
  [SetStrikeThrough] = 3
  [SetFont] = 4
  [SetSuperior] = 5
  [SetInferior] = 6
  [SetLink] = 7
End Enum

Enum enmPropertieFunction
  [SetFontColor] = 0
  [SetFontBackColor] = 1
  [SetFontSize] = 2
  [SetFontName] = 3
  [SetLinkURL] = 4
End Enum

'Default Property Values:
Const m_def_UseHexColor = False
Const m_def_LineSpacing = 0
Const m_def_Text = ""
Const m_def_LeftMagrin = 0
Const m_def_TopMagrin = 0
Const m_def_TagOpener = "["
Const m_def_TagCloser = "]"
Const m_def_Scrollbars = 3
'Const m_def_Text = ""

'Type einer Propertie (Die einzelnen Werte werden in der Funktion "AddPropertie" beschrieben)
Private Type typPropertie
  Name As String
  Function As enmPropertieFunction
End Type

'Type eines Tags (Die einzelnen Werte werden in der Funktion "AddTag" beschrieben)
Private Type typTag
  TagBegin As String
  TagEnd As String
  Function As enmTagFunction
  Properties() As typPropertie
End Type

'Type eines Links (Die einzelnen Werte werden in der Funktion "AddLink" beschrieben)
Private Type typLink
  LinkURL As String
  LinkPosition As Rect
End Type

'Property Variables:
Dim m_UseHexColor As Boolean
Dim m_LinkCursor As Picture
Dim m_LineSpacing As Integer
Dim m_Text As String
Dim m_LeftMagrin As Long
Dim m_TopMagrin As Long
Dim m_TagOpener As String
Dim m_TagCloser As String
'Dim m_Text As String

'Array fr die Tags
Private Tags() As typTag
Private Links() As typLink

Private OverLink As Boolean
Private OverLinkURL As String

'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
'                              FFENTLICHE ROUTINEN
'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

'********************************************************************************************
' AddTag - Funktion                                                                         '
'                                                                                           '
' Fgt einen neuen Tag hinzu                                                                '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' TagBegin          Bestimmt den Starttext eines Tags z.B.: "b"                             '
' TagEnd            Bestimmt den Endtext eines Tags z.B.: "/b"                              '
' TagFunction       Bestimmt die Funktion die der Tag ausfhren soll z.B.:                  '
'                   SetBold (Fett setzen) wrde den Text zwischen dem Taginhalt             '
'                   Fett darstellen                                                         '
' - - - - - - - - - - - - - - -                                                             '
' Rckgabewerte: 0 = Fehler,  1 - ... = Index des erstellten Tags                           '
'********************************************************************************************

Public Function AddTag(TagBegin As String, TagEnd As String, TagFunction As enmTagFunction) As Long
Attribute AddTag.VB_Description = "Fgt einen Tag hinzu."
  On Error GoTo errout
  
  Dim TagCount As Long
  
  'Anzahl der schon vorhandenen Tags ermitteln und danach das Array vergrern
  TagCount = UBound(Tags)
  ReDim Preserve Tags(TagCount + 1)
  
  'Dem neuem Tag Werte zuweisen:
  With Tags(TagCount + 1)
    .TagBegin = TagBegin
    .TagEnd = TagEnd
    .Function = TagFunction
  End With
  
  ReDim Tags(TagCount + 1).Properties(0)
  
  'Den Index des erstellten Tags zurckgeben
  AddTag = TagCount + 1
  Call Refresh
  Exit Function
  
errout:
  AddTag = 0
End Function

'********************************************************************************************
' AddPropertie - Funktion                                                                   '
'                                                                                           '
' Fgt zu einem Tag eine neue Eigenschaft hinzu z.B.: "<font SIZE="3">test</font>"          '
' Wobei SIZE die Eigenschaft darstellt!                                                     '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' TagIndex          Die Nummer des Tags zu dem die Eigenschaft hinzugefgt werden soll      '
' PropertieName     Bestimmt den Namen der Eigenschaft z.B.: "size"                         '
' PropertieFunction Bestimmt die Funktion die die Eigenschaft in einem Tag ausfhren        '
'                   soll z.B.: SetFontSize = Schriftgre ndern                            '
'                   wrde die Textgre in einem Font Tag verndern                         '
'                                                                                           '
'                   ACHTUNG: Nicht jedem Tag kann man Eigenschaften zuweisen!               '
'                   Ein Tag mit der Funktion "SetBold" kann z.B. keine Eigenschaft          '
'                   zugewiesen werden! Wozu die Eigenschaft gehrt, ist im namen            '
'                   angegeben z.B. gehrt SetFontSize (Set>>Font<<Size) zu einem Tag        '
'                   mit der Funktion SetFont.                                               '
' - - - - - - - - - - - - - - -                                                             '
' Rckgabewerte: 0 = Fehler,  1 - ... = Index der erstellten Eigenschaft im Tag             '
'********************************************************************************************

Public Function AddPropertie(TagIndex As Long, PropertieName As String, PropertieFunction As enmPropertieFunction)
Attribute AddPropertie.VB_Description = "Fgt eine Eigenschaft zu einem Tag hinzu."
  On Error GoTo errout
  'Exestiert der Tag?
  If Not UBound(Tags) >= TagIndex Then
    'Exestiert nicht, also Fehler...
    AddPropertie = 0
    Exit Function
  End If
  
  'Ist die Funktion des Tags eine SetFont Funktion
  If Tags(TagIndex).Function = SetFont Then
    'Prfen ob eine dafr mgliche Eigenschaft gesetzt wird
    If PropertieFunction > 3 Then
      'Eigenschaft ist keine Font eigenschaft, Fehler zurckgeben
      AddPropertie = 0
      Exit Function
    End If
  End If
  
  Dim PropertieCount As Long
  
  'Anzahl der schon vorhandenen Eigenschaften im Tag ermitteln und danach das Array vergrern
  PropertieCount = UBound(Tags(TagIndex).Properties)
  ReDim Preserve Tags(TagIndex).Properties(PropertieCount + 1)
  
  'Der neuen Eigenschaft Werte zuweisen:
  With Tags(TagIndex).Properties(PropertieCount + 1)
    .Name = PropertieName
    .Function = PropertieFunction
  End With
  
  'Den Index der erstellten Eigenschaft zurckgeben
  AddPropertie = PropertieCount + 1
  Call Refresh
  Exit Function
  
errout:
  AddPropertie = 0
End Function

'********************************************************************************************
' OpenFile - Prozedur                                                                       '
'                                                                                           '
' Setzt den MLText auf den Inhalt einer Datei                                               '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' Filename          Dateiname der Datei                                                     '
'********************************************************************************************

Public Sub OpenFile(Filename As String)
  Dim FileNumber As Long
  FileNumber = FreeFile
  'Prfen ob Datei exestiert
  If Dir$(Filename, vbNormal) <> "" Then
    Open Filename For Binary As #FileNumber
      'String mit leerzeichen fllen
      m_Text = Space$(LOF(FileNumber))
      'Gesamten Inhalt einlesen
      Get #FileNumber, , m_Text
    Close #FileNumber
    Call Refresh
  End If
End Sub

'********************************************************************************************
' SaveFile - Prozedur                                                                       '
'                                                                                           '
' Speichert den MLText in eine Datei                                                        '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' Filename          Dateiname der Datei                                                     '
'********************************************************************************************

Public Sub SaveFile(Filename As String)
  Dim FileNumber As Long
  FileNumber = FreeFile
  Open Filename For Binary As #FileNumber
    'Gesamten Inhalt schreiben
    Put #FileNumber, , m_Text
  Close #FileNumber
End Sub

'********************************************************************************************
' Refresh - Prozedur                                                                        '
'                                                                                           '
' Zeichnet gesammten Inhalt neu                                                             '
'********************************************************************************************

Public Sub Refresh()
  Dim rct As Rect
  rct.Right = UserControl.ScaleWidth
  rct.Bottom = UserControl.ScaleHeight
  DrawMLText UserControl.hdc, m_Text, rct
End Sub

'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
'                                 PRIVATE ROUTINEN
'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||


'********************************************************************************************
' AddLink - Funktion                                                                        '
'                                                                                           '
' Fgt einen (nicht sichtbaren) Link ein, so dass er mit der Maus anklickbar ist            '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' LinkURL           Die Adresse auf die der Hyperlink verweist                              '
' LinkPosition      Die Position ber die der Mauszeiger schweben muss, um ber dem Link zu '
'                   sein.                                                                   '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Rckgabewerte: 0 = Fehler,  1 - ... = Index des erstellten Links                          '
'********************************************************************************************

Private Function AddLink(LinkURL As String, LinkPosition As Rect) As Long
  'On Error GoTo errout
  
  Dim LinkCount As Long
  
  'Anzahl der schon vorhandenen Links ermitteln und danach das Array vergrern
  LinkCount = UBound(Links)
  ReDim Preserve Links(LinkCount + 1)
  
  'Dem neuem Link Werte zuweisen:
  With Links(LinkCount + 1)
    .LinkURL = LinkURL
    .LinkPosition = LinkPosition
  End With

  'Den Index des erstellten Links zurckgeben
  AddLink = LinkCount + 1
  
  Exit Function
  
errout:
  AddLink = 0
End Function

'********************************************************************************************
' DrawMLText - Prozedur                                                                     '
'                                                                                           '
' Die Herzprozedur: Zeichnet den MLText                                                     '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' hdc               Der hDC auf dem der Text gezeichnet werden soll                         '
' MLText            Der MLText der gezeichnet werden soll                                   '
' Rect              Das Rect in dem die Ausgabe auf dem hDC erfolgen soll                   '
'********************************************************************************************

Private Sub DrawMLText(hdc As Long, MLText As String, Rect As Rect)
  Dim i As Long
  Dim CurChar As String
  Dim IsInTag As Boolean
  Dim IsInPropertie As Boolean       'Wenn sich die Schleife in einer Eigenschaft befindet
                                     'z.B.: "<font eigenschaft="test">"
  Dim IsInPropertieValue As Boolean  'Wenn sich die Schleife in einem Eigenschaftswert befindet
                                     'z.B.: "<font size="EigenschaftsWert">"
                                     
  Dim TagPosition As Long            'Taganfang z.B.: Position von "<"
  Dim TagEndPosition As Long         'Tagende   z.B.: Position von ">"
  Dim TagText As String              'Text des Tags z.B.: bei "<b>" wre es "b"
  Dim TagFunction As enmTagFunction
  Dim TagIsBegin As Boolean          'Ist es ein ffnender oder schlieender Tag? z.B.:
                                     '<b> wre ein Beginn und </b> wre eine Ende
                                     
  Dim FirstPropertie As Boolean      'Ist aktuelle Eigenschaft die Erste eines Tags?
  Dim PropertiePosition As Long      'Position der aktuellen Eigenschaft
  Dim PropertieEndPosition As Long   'EndPositition des aktuellen Eigenschaftsnamen
  Dim PropertieName As String        'Name der aktuellen Eigenschaft
  Dim PropertieValue As String       'Wert der aktuellen Eigenschaft
  Dim PropertieFunction As Long      'Funktion der aktuellen Eigenschaft
  
  Dim TagContent As String           'Der Text zwischen den Tags z.B.: <b>TagContent</b>
                                     'Dabei muss dort allerdings nur ein anderer Tag stehen
                                     'z.B.: <b>TagContent<i>...
  Dim TextRect As Rect
  
  Dim InSuperiorMode As Boolean
  Dim InInferiorMode As Boolean
  
  Dim CurFontBackColor As Long
  
  Dim DefFont As StdFont
  Dim DefFontColor As Long
  Dim DefFontBackColor As Long
  
  Dim CurLinePosition As Long        'Anfang der aktuellen Zeile
  Dim CurLineEndPosition As Long     'Ende der aktuellen Zeile
  Dim CurLineY As Long               'Y-Position der aktuellen Zeile
  Dim CurLineHeight As Long          'Hhe der aktuellen Zeile
  Dim CurLineDrawn As Boolean        'Ist die aktuelle Zeile schon gezeichnet worden?
  
  Dim LastCreatedLinkID As Long      'ID des zuletzt erstellten Links
  Dim LinkPosition As Rect           'Position des aktuellen Links
  
  'Standartschriftart setzen
  Set DefFont = New StdFont
  DefFont.Name = picTmp.Font.Name
  DefFont.Size = picTmp.Font.Size
  DefFontColor = picTmp.ForeColor
  DefFontBackColor = picTmp.BackColor
  
  CurFontBackColor = DefFontBackColor
  
  TextRect = Rect
  TextRect.Left = Rect.Left + LeftMagrin
  TextRect.Top = Rect.Top + TopMagrin
  CurLineY = TextRect.Top
  
  'Alles gezeichnete lschen
  picTmp.Cls
  UserControl.Cls
  
  CurLineHeight = picTmp.TextHeight("|")
  
  'Alle Links lschen
  Call ClearLinks
  
  'Wenn kein MLText bergeben wurde, prozedur verlassen
  If MLText = "" Then Exit Sub
  
  'Schleife die jedes einzelne Zeichen durchluft
  For i = 1 To Len(MLText)
    CurLineDrawn = False
    If CurLineHeight = 0 Then CurLineHeight = picTmp.TextHeight("|")
    CurChar = Mid(MLText, i, 1)
    'Falls wir uns in einem Tag befinden
    If IsInTag Then
      'Falls wir uns in einer Eigenschaft befinden
      If IsInPropertie Then
      
        'Wenn ein " gefunden wird
        If CurChar = """" Then
          'Falls wir uns NICHT in einem Eigenschaftenwert befinden
          If Not IsInPropertieValue Then
            'Namen und EndPosition der Eigenschaft setzen
            PropertieName = Mid(MLText, PropertiePosition, i - PropertiePosition)
            PropertieEndPosition = i
            IsInPropertieValue = True
          Else 'Wir sind in einem Eigenschaftswert
            'Eigenschaftswert setzen
            PropertieValue = Mid(MLText, PropertieEndPosition + 1, i - PropertieEndPosition - 1)
            IsInPropertieValue = False
            'Funktion der Eigenschaft ermitteln
            PropertieFunction = FindPropertieAndGetFunction(TagText, PropertieName)
            'Auf gltige Eigenschaft prfen
            If CheckForVaildPropertie(TagFunction, PropertieFunction, PropertieValue) Then
              'Funktion auswerten
              Select Case PropertieFunction
                Case SetFontName: picTmp.Font.Name = PropertieValue
                Case SetFontSize: picTmp.Font.Size = PropertieValue
                Case SetFontColor: picTmp.ForeColor = IIf(UseHexColor, Hexcode2Long(PropertieValue), PropertieValue)
                Case SetFontBackColor: CurFontBackColor = IIf(UseHexColor, Hexcode2Long(PropertieValue), PropertieValue)
                Case SetLinkURL:
                                  LastCreatedLinkID = AddLink(PropertieValue, LinkPosition)
                                  LinkPosition.Top = CurLineY
                                  LinkPosition.Left = TextRect.Left
                Case -1: Debug.Print "Ungltige Eigenschaft! (Zeichen: " & i & ", Tag: " + TagText + ", Eigenschaft: " + PropertieName + ", Wert: " + PropertieValue + ")"
              End Select
              'Setzen der aktuellen Zeilenhhe
              If picTmp.TextHeight("|") > CurLineHeight Then CurLineHeight = picTmp.TextHeight("|")
            End If
          End If
        End If
        
        'Wenn wir am Ende der aktuellen Eigenschaft sind
        If CurChar = " " Or CurChar = TagCloser Then
          'Sind wir jetzt nichtmehr in der letzten Eigenschaft
          IsInPropertie = False
          'Wenn wir am Tagende sind
          If CurChar = TagCloser Then
            'EndPosition des Tags setzen
            TagEndPosition = i
            IsInTag = False
          End If
          
          'Ist dies die erste Eigenschaft des Tags?
          If FirstPropertie Then
            '*** Tagnamen auslesen: ***
            
            'Der Tagname wird wie eine Eigenschaft ausgelesen, somit ist die erste eigenschaft der Tagname!
            'Ende der "Eigenschaft" setzen
            PropertieEndPosition = i
            'Den Tagnamen auslesen
            TagText = Mid(MLText, PropertiePosition, PropertieEndPosition - PropertiePosition)
            
            'Function und zugehrigen Tag ermitteln
            TagFunction = FindTagAndGetFunction(TagText, TagIsBegin)
            
            Select Case TagFunction
              Case SetBold: picTmp.Font.Bold = TagIsBegin
              Case SetItalic: picTmp.Font.Italic = TagIsBegin
              Case SetUnderline: picTmp.Font.Underline = TagIsBegin
              Case SetStrikeThrough: picTmp.Font.Strikethrough = TagIsBegin
              Case SetSuperior: InSuperiorMode = TagIsBegin
              Case SetInferior: InInferiorMode = TagIsBegin
              Case SetFont:
                            If Not TagIsBegin Then
                              picTmp.Font.Name = DefFont.Name
                              picTmp.Font.Size = DefFont.Size
                              picTmp.ForeColor = DefFontColor
                              CurFontBackColor = DefFontBackColor
                            End If
              Case SetLink:
                            If Not TagIsBegin Then
                              LinkPosition.Right = TextRect.Left
                              LinkPosition.Bottom = LinkPosition.Top + CurLineHeight
                              
                              Links(LastCreatedLinkID).LinkPosition = LinkPosition
                            End If
              Case -1: Debug.Print "Ungltiger Tag! (Zeichen: " & i & ", Tag: " + TagText + ")"
            End Select
            'Setzen der aktuellen Zeilenhhe
            If picTmp.TextHeight("|") > CurLineHeight Then CurLineHeight = picTmp.TextHeight("|")
            
            'Jetzt haben wir die erste Eigenschaft abgearbeitet!
            FirstPropertie = False
          End If
        End If
      Else 'Wir befinden uns nicht in einer Eigenschaft
        'Der aktuelle Char ist alles auer das Eigenschaftentrennzeichen
        If CurChar <> " " Then
          'Hier beginnt eine neue Eigenschaft:
          'Eigenschaftsposition setzen
          PropertiePosition = i
          IsInPropertie = True
        End If
      End If
    Else 'Wir befinden uns in keinem Tag
      'Wenn der Char der Tagffner ist
      If CurChar = TagOpener Then
        'Wir befinden uns jetzt in einem Tag!
        IsInTag = True
        'TagInhalt ermitteln z.B.: <b>TagContent</b>
        TagContent = Mid(MLText, TagEndPosition + 1, i - TagEndPosition - 1)
        'Neuer Tag heit: Den Text bis zu diesem Tag zeichnen
        TextRect.Left = TextRect.Left + DrawTextWithProps(picTmp.hdc, TagContent, TextRect, picTmp.Font, InSuperiorMode, InInferiorMode, CurFontBackColor)
        'Position des Tags setzen
        TagPosition = i
        
        'Da wir in einem neuen Tag sind, ist die nchst gefundene "Eigenschaft" die erste und somit der Tagname!
        FirstPropertie = True
      End If
    End If
    'Falls eine neue Zeile begonnen werden soll
    If Mid(MLText, i, Len(vbNewLine)) = vbNewLine Then
DrawLine:
      'TagInhalt ermitteln z.B.: <b>TagContent</b>
      TagContent = Mid(MLText, TagEndPosition + 1, i - TagEndPosition - 1)
      'TagEndPosition setzen
      TagEndPosition = i
      'Textabschnitt zeichnen
      TextRect.Left = TextRect.Left + DrawTextWithProps(picTmp.hdc, TagContent, TextRect, picTmp.Font, InSuperiorMode, InInferiorMode, CurFontBackColor)
      'Auf das Steuerelement blitten
      BitBlt hdc, 0, CurLineY, UserControl.ScaleWidth, CurLineHeight, picTmp.hdc, 0, UserControl.ScaleHeight - CurLineHeight, SRCCOPY
      'Y-Position der aktuellen Zeile bestimmen
      CurLineY = CurLineY + CurLineHeight + m_LineSpacing
      'Der Hhe der nchsten Zeile beginnt bei 0 um sie nicht so gro wie die aktuelle zu haben
      CurLineHeight = 0
      CurLinePosition = i + 1
      'Temporre Picturebox saubermachen
      picTmp.Cls
      'Textrect auf nchste Zeilenposition setzen
      TextRect.Left = Rect.Left + LeftMagrin
      TextRect.Top = CurLineY
      'Die aktuelle Zeile wurde gezeichnet
      CurLineDrawn = True
    End If
  Next i
  'Falls wir uns noch in einem Tag befinden
  If IsInTag Then Debug.Print "Ein Tag wurde nicht geschlossen!"
  'Falls die aktuelle Zeile noch nicht gezeichnet wurde, zum Zeichnen der Zeile springen
  If Not CurLineDrawn Then GoTo DrawLine
  Set picTmp.Font = DefFont
  'Temporre Objekte lschen
  Set DefFont = Nothing
End Sub

'********************************************************************************************
' FindTagAndGetFunction - Funktion                                                          '
'                                                                                           '
' Ermittelt die Funktion eines Tags                                                         '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' TagText           Der Text des Tags z.B.: "<b>" oder "</font>"                            '
' IsBegin           Ist es ein Starttag?                                                    '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Rckgabewerte: -1 = Tag nicht gefunden,  0 - ... = Tag Funktion                           '
'********************************************************************************************

Private Function FindTagAndGetFunction(TagText As String, IsBegin As Boolean) As enmTagFunction
  Dim i As Long
  
  'Alle Tags durchlaufen
  For i = 1 To UBound(Tags)
    If Tags(i).TagBegin = TagText Then
      'Tag Funktion zurckgeben
      FindTagAndGetFunction = Tags(i).Function
      'Es ist der TagBegin
      IsBegin = True
      Exit Function
    End If
    If Tags(i).TagEnd = TagText Then
      'Tag Funktion zurckgeben
      FindTagAndGetFunction = Tags(i).Function
      'Es ist der TagEnd
      IsBegin = False
      Exit Function
    End If
  Next i
  'Fehler zurckgeben, wenn nichts passendes gefunden wurde...
  FindTagAndGetFunction = -1
End Function

'********************************************************************************************
' FindPropertieAndGetFunction - Funktion                                                    '
'                                                                                           '
' Ermittelt die Funktion einer Eigenschaft                                                  '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' TagText           Der Text des Tags z.B.: "<b>" oder "</font>"                            '
' Propertie         Der Name der Eigenschaft z.B.: "color"                                  '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Rckgabewerte: -1 = Tag oder Eigenschaft nicht gefunden,  0 - ... = Eigenschaftsfunktion  '
'********************************************************************************************

Private Function FindPropertieAndGetFunction(TagText As String, Propertie As String) As enmPropertieFunction
  Dim i As Long
  Dim j As Long
  
  'Alle Tags durchlaufen
  For i = 1 To UBound(Tags)
    If Tags(i).TagBegin = TagText Then
      'Alle Eigenschaften des Tags durchlaufen
      For j = 1 To UBound(Tags(i).Properties)
        'Wenn es die gesuchte Eigenschaft ist
        If Tags(i).Properties(j).Name = Propertie Then
          'Eigenschaftsfunktion zurckgeben
          FindPropertieAndGetFunction = Tags(i).Properties(j).Function
          Exit Function
        End If
      Next j
    End If
  Next i
  'Fehler zurckgeben, wenn nichts passendes gefunden wurde...
  FindPropertieAndGetFunction = -1
End Function

'********************************************************************************************
' CheckForVaildPropertie - Funktion                                                         '
'                                                                                           '
' Prft ob eine Eigenschaft gltig ist. z.B.: Wre die Size Eigenschaft bei einem Bold Tag  '
' ungltig!                                                                                 '
' Auerdem wird geprft ob der Eigenschaftswert dem richtigem Format entspricht             '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' TagFunction       Funktion des Tags                                                       '
' PropertieName     Funktion des Eigenschaft                                                '
' PropertieValue    Wert der Eigenschaft z.B.: "<font name="PROPERTIEVALUE">"               '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Rckgabewerte: True = Eigenschaft gltig, False = Eigenschaft ungltig                    '
'********************************************************************************************

Private Function CheckForVaildPropertie(TagFunction As enmTagFunction, PropertieFunction As enmPropertieFunction, PropertieValue As String) As Boolean
  If TagFunction = SetFont Then
    If PropertieFunction >= 0 And PropertieFunction <= 2 Then
      If CheckNum(PropertieValue) Then
        CheckForVaildPropertie = True
        Exit Function
      ElseIf PropertieFunction = SetFontBackColor Or PropertieFunction = SetFontColor Then
            If UseHexColor Then
              CheckForVaildPropertie = True
              Exit Function
            End If
      End If
    End If
    If PropertieFunction = SetFontName Then
      CheckForVaildPropertie = True
      Exit Function
    End If
  End If
  If TagFunction = SetLink Then
    If PropertieFunction = SetLinkURL Then
      CheckForVaildPropertie = True
      Exit Function
    End If
  End If
  Debug.Print "Ungltiger Eigenschaftswert: Wert: " + PropertieValue
  CheckForVaildPropertie = False
End Function

'********************************************************************************************
' CheckNum - Funktion                                                                       '
'                                                                                           '
' Prft ob ein String eine gltige Nummer enthlt                                           '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' Text              Text der geprft werden soll                                            '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Rckgabewerte: True = Gltig, False = Ungltig                                            '
'********************************************************************************************

Private Function CheckNum(Text As String) As Boolean
  On Error GoTo NoInt
  Dim i As Long
  i = Text
  CheckNum = True
  Exit Function
NoInt:
  CheckNum = False
End Function


'********************************************************************************************
' DrawTextWithProps - Funktion                                                              '
'                                                                                           '
' Zeichnet einen Text mit speziellen Eigenschaften                                          '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Parameter:        Beschreibung:                                                           '
' hdc               hDC auf dem der Text gezeichnet wird                                    '
' Text              Der Text der gezeichnet wird                                            '
' Rect              Rect indem der Text gezeichnet wird                                     '
' Font              Schrift mit dem der Text gezeichnet wird                                '
' Superior          Soll der Text hochgestellt gezeichnet werden?                           '
' Inferior          Soll der Text tiefgestellt gezeichnet werden?                           '
' BackColor         Hintergrundfarbe des Textes                                             '
'                                                                                           '
' - - - - - - - - - - - - - - -                                                             '
' Rckgabewerte: Breite des gezeichneten Textes                                             '
'********************************************************************************************

Private Function DrawTextWithProps(hdc As Long, Text As String, Rect As Rect, ByVal Font As StdFont, _
                                   Optional Superior As Boolean = False, Optional Inferior As Boolean = False, _
                                   Optional BackColor As Long = -1) As Long
  Dim DrawRect As Rect
  Dim ExtraFormat As Long
  Dim OldFont As StdFont

  Set OldFont = New StdFont
  CopyFont picTmp.Font, OldFont

  If BackColor <> -1 Then
    SetBkMode picTmp.hdc, OPAQUE
    SetBkColor picTmp.hdc, BackColor
  End If
  
  DrawRect = Rect
  
  ExtraFormat = DT_BOTTOM
  
  'Wenn Hochgestellt
  If Superior Then
    'Der Text soll oben gezeichnet werden
    DrawRect.Top = DrawRect.Bottom - picTmp.TextHeight("|")
    
    'Da fast alle Schriftarten nichts kleiner als 8 erlauben stellen wir SmallFonts ein
    If picTmp.Font.Size <= 11 And picTmp.Font.Name <> "SmallFonts" Then picTmp.Font.Name = "SmallFonts"
    'Halbe textgre
    picTmp.Font.Size = Font.Size / 2
    
    ExtraFormat = DT_TOP
  Else
    'Tiefgestellt packen wir hier rein denn ein Text darf nicht hoch- und tiefgestellt sein!
    If Inferior Then
      'Da fast alle Schriftarten nichts kleiner als 8 erlauben stellen wir SmallFonts ein
      If picTmp.Font.Size <= 11 And picTmp.Font.Name <> "SmallFonts" Then picTmp.Font.Name = "SmallFonts"
      'Halbe textgre
      picTmp.Font.Size = Font.Size / 2
    End If
  End If
  
  Set picTmp.Font = Font
  'Text zeichnen
  DrawText hdc, Text, -1, DrawRect, DT_SINGLELINE + DT_NOCLIP + ExtraFormat
  
  'Textbreite zurckgeben                           Bei kursivem Text hngen wir noch ein Leerzeichen mit dran (Sieht besser aus)
  DrawTextWithProps = picTmp.TextWidth(Text) + IIf(picTmp.Font.Italic, picTmp.TextWidth(" "), 0)
  
  Set picTmp.Font = OldFont
  SetBkColor picTmp.hdc, picTmp.BackColor
End Function

'********************************************************************************************
' ClearLinks - Prozedur                                                                     '
'                                                                                           '
' Lscht alle Links                                                                         '
'                                                                                           '
'********************************************************************************************
Private Sub ClearLinks()
  ReDim Links(0)
End Sub


'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
'           EIGENSCHAFTEN UND INTERNE EREIGNISSREAKTIONEN DES STEUERELEMENTS
'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
  BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
  UserControl.BackColor() = New_BackColor
  picTmp.BackColor = New_BackColor
  PropertyChanged "BackColor"
  Call Refresh
End Property

'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
  ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
  UserControl.ForeColor() = New_ForeColor
  picTmp.ForeColor = New_ForeColor
  PropertyChanged "ForeColor"
  Call Refresh
End Property

'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_UserMemId = -512
  Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
  Set UserControl.Font = New_Font
  Set picTmp.Font = New_Font
  PropertyChanged "Font"
  Call Refresh
End Property

'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As enmBorderStyle
  BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As enmBorderStyle)
  UserControl.BorderStyle() = New_BorderStyle
  PropertyChanged "BorderStyle"
  Call Refresh
End Property

'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = "Allgemein"
  MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
  UserControl.MousePointer() = New_MousePointer
  PropertyChanged "MousePointer"
End Property

'MappingInfo=UserControl,UserControl,-1,MouseIcon
Public Property Get MouseIcon() As Picture
  Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
  Set UserControl.MouseIcon = New_MouseIcon
  PropertyChanged "MouseIcon"
End Property

Public Property Get TagOpener() As String
Attribute TagOpener.VB_ProcData.VB_Invoke_Property = "Allgemein"
  TagOpener = m_TagOpener
End Property

Public Property Let TagOpener(ByVal New_TagOpener As String)
  m_TagOpener = New_TagOpener
  PropertyChanged "TagOpener"
  Call Refresh
End Property

Public Property Get TagCloser() As String
Attribute TagCloser.VB_ProcData.VB_Invoke_Property = "Allgemein"
  TagCloser = m_TagCloser
End Property

Public Property Let TagCloser(ByVal New_TagCloser As String)
  m_TagCloser = New_TagCloser
  PropertyChanged "TagCloser"
  Call Refresh
End Property

Public Property Get LeftMagrin() As Long
Attribute LeftMagrin.VB_ProcData.VB_Invoke_Property = "Allgemein"
  LeftMagrin = m_LeftMagrin
End Property

Public Property Let LeftMagrin(ByVal New_LeftMagrin As Long)
  m_LeftMagrin = New_LeftMagrin
  PropertyChanged "LeftMagrin"
  Call Refresh
End Property

Public Property Get TopMagrin() As Long
Attribute TopMagrin.VB_ProcData.VB_Invoke_Property = "Allgemein"
  TopMagrin = m_TopMagrin
End Property

Public Property Let TopMagrin(ByVal New_TopMagrin As Long)
  m_TopMagrin = New_TopMagrin
  PropertyChanged "TopMagrin"
  Call Refresh
End Property

Public Property Get Text() As String
Attribute Text.VB_ProcData.VB_Invoke_Property = "Allgemein"
  Text = m_Text
End Property

Public Property Let Text(ByVal New_Text As String)
  If Ambient.UserMode = False Then Err.Raise 394
  m_Text = New_Text
  PropertyChanged "Text"
  Call Refresh
End Property

Public Property Get LineSpacing() As Integer
Attribute LineSpacing.VB_ProcData.VB_Invoke_Property = "Allgemein"
  LineSpacing = m_LineSpacing
End Property

Public Property Let LineSpacing(ByVal New_LineSpacing As Integer)
  m_LineSpacing = New_LineSpacing
  PropertyChanged "LineSpacing"
  Call Refresh
End Property

Public Property Get LinkCursor() As Picture
  Set LinkCursor = m_LinkCursor
End Property

Public Property Set LinkCursor(ByVal New_LinkCursor As Picture)
  Set m_LinkCursor = New_LinkCursor
  PropertyChanged "LinkCursor"
End Property

Public Property Get UseHexColor() As Boolean
  UseHexColor = m_UseHexColor
End Property

Public Property Let UseHexColor(ByVal New_UseHexColor As Boolean)
  m_UseHexColor = New_UseHexColor
  PropertyChanged "UseHexColor"
  Call Refresh
End Property

Private Sub UserControl_Click()
  RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
  RaiseEvent DblClick
End Sub

Private Sub UserControl_Initialize()
  ReDim Tags(0)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  'Falls sich die Maus ber einem Link befindet
  If OverLink Then
    'URL ffnen
    ShellExecute UserControl.hwnd, "open", OverLinkURL, "", "", 0
  End If
  RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  Dim i As Long
  Dim MouseRect As Rect 'Rect in dem die Mauskoordinaten gespeichert werden
  Dim TmpRect As Rect 'Temp-Rect in dem das IntersectRect gespeichert wird

  MouseRect.Left = x
  MouseRect.Top = y
  MouseRect.Right = x + 1
  MouseRect.Bottom = y + 1
  
  For i = 1 To UBound(Links)
    'Wenn Maus mit Linkrect kollidiert
    If IntersectRect(TmpRect, MouseRect, Links(i).LinkPosition) <> 0 Then
      'Mauscursor in eine Hand verwandeln
      UserControl.MousePointer = 99
      Set UserControl.MouseIcon = m_LinkCursor
      'Maus befindet sich nun ber einem Link!
      OverLink = True
      OverLinkURL = Links(i).LinkURL
      GoTo newmouse
    End If
  Next i
  'Mauscursor aufs Standart zurcksetzen
  OverLink = False
  UserControl.MousePointer = 0
newmouse:
  
  RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  RaiseEvent MouseUp(Button, Shift, x, y)
End Sub

Private Sub UserControl_Paint()
  Refresh
End Sub

Private Sub UserControl_Resize()
  'Die Temporre Picturebox sollte immer so gro wie das Steuerelement sein
  picTmp.Width = UserControl.ScaleWidth
  picTmp.Height = UserControl.ScaleHeight
  RaiseEvent Resize
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
  Set Font = Ambient.Font
  m_TagOpener = m_def_TagOpener
  m_TagCloser = m_def_TagCloser
  m_LeftMagrin = m_def_LeftMagrin
  m_TopMagrin = m_def_TopMagrin
  m_Text = m_def_Text
  m_LineSpacing = m_def_LineSpacing
  Set m_LinkCursor = picTmp.MouseIcon
  m_UseHexColor = m_def_UseHexColor
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
  picTmp.BackColor = UserControl.BackColor
  UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
  picTmp.ForeColor = UserControl.ForeColor
  Set Font = PropBag.ReadProperty("Font", Ambient.Font)
  Set picTmp.Font = PropBag.ReadProperty("Font", Ambient.Font)
  UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
  UserControl.MousePointer = PropBag.ReadProperty("MousePointer", 0)
  Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
  m_Text = PropBag.ReadProperty("Text", m_def_Text)
  m_TagOpener = PropBag.ReadProperty("TagOpener", m_def_TagOpener)
  m_TagCloser = PropBag.ReadProperty("TagCloser", m_def_TagCloser)
  m_LeftMagrin = PropBag.ReadProperty("LeftMagrin", m_def_LeftMagrin)
  m_TopMagrin = PropBag.ReadProperty("TopMagrin", m_def_TopMagrin)
  m_Text = PropBag.ReadProperty("Text", m_def_Text)
  m_LineSpacing = PropBag.ReadProperty("LineSpacing", m_def_LineSpacing)
  Set m_LinkCursor = PropBag.ReadProperty("LinkCursor", Nothing)
  m_UseHexColor = PropBag.ReadProperty("UseHexColor", m_def_UseHexColor)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
  Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H80000012)
  Call PropBag.WriteProperty("Font", Font, Ambient.Font)
  Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
  Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, 0)
  Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
  Call PropBag.WriteProperty("Text", m_Text, m_def_Text)
  Call PropBag.WriteProperty("TagOpener", m_TagOpener, m_def_TagOpener)
  Call PropBag.WriteProperty("TagCloser", m_TagCloser, m_def_TagCloser)
  Call PropBag.WriteProperty("LeftMagrin", m_LeftMagrin, m_def_LeftMagrin)
  Call PropBag.WriteProperty("TopMagrin", m_TopMagrin, m_def_TopMagrin)
  Call PropBag.WriteProperty("LineSpacing", m_LineSpacing, m_def_LineSpacing)
  Call PropBag.WriteProperty("LinkCursor", m_LinkCursor, Nothing)
  Call PropBag.WriteProperty("UseHexColor", m_UseHexColor, m_def_UseHexColor)
End Sub

