VERSION 5.00
Begin VB.UserControl MLLabel 
   ClientHeight    =   990
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1905
   ScaleHeight     =   66
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   127
   Begin VB.Label label 
      Alignment       =   2  'Zentriert
      AutoSize        =   -1  'True
      BackColor       =   &H80000004&
      BackStyle       =   0  'Transparent
      Height          =   195
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   120
      Width           =   165
   End
End
Attribute VB_Name = "MLLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim BOLD            As Integer
Dim ITALIC          As Integer
Dim UNDERLINED      As Integer
Dim VERTPOS         As Long
Dim ADD_COLOR       As Long
Dim ADD_FONT        As String
Dim ADD_SIZE        As Long
Dim DEFAULT_COLOR   As Long
Dim DEFAULT_FONT    As String
Dim DEFAULT_SIZE    As Integer
Dim NEWLINE         As Boolean

Dim offset          As Integer
Dim counter         As Integer


'-------------------------------------------------------------------------
'Startet die ganze Prozedur.
'
'Letzte nderung: 25.12.2005
'-------------------------------------------------------------------------

Public Sub Verarbeiten(ByVal InputString As String)

    Dim i               As Integer
    Dim InputArray()    As String
    
    Call Cls
    
    InputArray = SplitString(InputString)
    
    For i = 0 To UBound(InputArray)
    
        Call Settings(InputArray(i))
        
    Next i

End Sub

'-------------------------------------------------------------------------
'Sucht die Markierungszeichen "<" und ">" und ersetzt sie durch ein Symbol
'und spaltet den String an diesen Stellen zu einem Array.
'
'Letzte nderung: 26.12.2005
'-------------------------------------------------------------------------

Private Function SplitString(ByVal InputString As String) As String()
    
    Dim temp As String
    
    temp = Replace(Replace(InputString, "<", Chr(6)), ">", Chr(6))
    If Left(temp, 1) = Chr(6) Then temp = Mid(temp, 2)
    SplitString = Split(Replace(temp, Chr(6) & Chr(6), Chr(6)), Chr(6))

End Function

'-------------------------------------------------------------------------
'Settingstable fr die Kommandos.
'
'Letzte nderung: 27.12.2005
'-------------------------------------------------------------------------

Private Sub Settings(ByVal InputString As String)
    
    '---------------------------------------------------------------------
    'Verarbeitet alle Kommandos ohne Parameter.
    '---------------------------------------------------------------------

    Select Case LCase(InputString)
    
        Case "b"
            BOLD = 1
            Exit Sub
        Case "-b", "b-"
            BOLD = 0
            Exit Sub
            
        Case "i"
            ITALIC = 1
            Exit Sub
        Case "-i", "i-"
            ITALIC = 0
            Exit Sub
            
        Case "u"
            UNDERLINED = 1
            Exit Sub
        Case "-u", "u-"
            UNDERLINED = 0
            Exit Sub
        
        Case "h"
            VERTPOS = VERTPOS + 1
            Exit Sub
        Case "-h", "h-"
            VERTPOS = 0
            Exit Sub
            
        Case "d"
            VERTPOS = VERTPOS - 1
            Exit Sub
        Case "-d", "d-"
            VERTPOS = 0
            Exit Sub
        
        Case "-f", "f-"
            ADD_FONT = DEFAULT_FONT
            Exit Sub
        
        Case "-c", "c-"
            ADD_COLOR = DEFAULT_COLOR
            Exit Sub
            
        Case "-s", "s-"
            ADD_SIZE = DEFAULT_SIZE
            Exit Sub
            
        Case "br"
            NEWLINE = True
            Exit Sub
            
    End Select
    
    '---------------------------------------------------------------------
    'Verarbeitet 2-stelligen Kommandos.
    '---------------------------------------------------------------------

    Select Case LCase(Left(InputString, 2))

        Case "f="
            ADD_FONT = Mid(InputString, 3)
            Exit Sub
            
        Case "c="
            ADD_COLOR = Color_Extended(InputString)
            Exit Sub
            
        Case "s="
            ADD_SIZE = Mid(InputString, 3)
            Exit Sub
            
    End Select
    
    '---------------------------------------------------------------------
    'Verarbeitet alle 3-stelligen Kommandos.
    '---------------------------------------------------------------------

    Select Case LCase(Left(InputString, 3))
    
        Case "df="
            DEFAULT_FONT = Mid(InputString, 4)
            ADD_FONT = Mid(InputString, 4)
            Exit Sub
            
        Case "dc="
            DEFAULT_COLOR = Color_Extended(InputString)
            ADD_COLOR = Color_Extended(InputString)
            Exit Sub
            
        Case "ds="
            DEFAULT_SIZE = Mid(InputString, 4)
            ADD_SIZE = Mid(InputString, 4)
            Exit Sub
    
    End Select
    
    '---------------------------------------------------------------------
    'Nix dabei! Dann gegen wir das mal auf dem Bildschirm aus.
    '---------------------------------------------------------------------

    Call DrawLabel(InputString)

End Sub

'-------------------------------------------------------------------------
'Zeichnet dynamisch mit jedem Aufruf ein neues Label mit den ntigen,
'aktuellen Formatierungen.
'
'Letzte nderung: 26.12.2005
'-------------------------------------------------------------------------

Private Sub DrawLabel(ByVal InputString As String)
    
    counter = counter + 1
    
    Load label(counter)
     
    With label(counter)
        .Caption = InputString
        .Font.BOLD = BOLD
        .Font.ITALIC = ITALIC
        .Font.Underline = UNDERLINED
        .ForeColor = ADD_COLOR
        .Font.Name = ADD_FONT
        .Font.Size = ADD_SIZE - Abs(VERTPOS) * ADD_SIZE / 2
        
        offset = offset + NEWLINE * .Height     'offset enthlt die Gesamthhe der Labels aller Zeilen
        
        If NEWLINE Then
            .Left = label(0).Left + label(0).Width      'Ist NEWLINE True, zrck zur Anfangsposition
            NEWLINE = False
        Else
            .Left = label(counter - 1).Left + label(counter - 1).Width  'Orientiert am vorherigen Label
        End If
        
        .Top = label(0).Top + label(0).Height - .Height - VERTPOS * ADD_SIZE / 2 - offset  'Orientiert an der unteren Kante des Labels 0

        .Refresh
        .Visible = True
    End With
        
End Sub

'-------------------------------------------------------------------------
'Erweiterte Farbverwaltung: RGB-,QB-Farbfeld;Benannte Farben;
'
'Letzte nderung: 27.12.2005
'-------------------------------------------------------------------------

Private Function Color_Extended(ByVal InputString As String)

    If IsNumeric(Mid(InputString, 3)) Then
    
        If Len(Mid(InputString, 3)) > 3 Then
            Color_Extended = RGB(Mid(InputString, 3, 3), Mid(InputString, 6, 3), Mid(InputString, 9, 3))
        Else
            Color_Extended = QBColor(Mid(InputString, 3))
        End If
        
    Else
    
        Select Case LCase(Mid(InputString, 3))
        
            Case "red", "rot"
                Color_Extended = RGB(255, 0, 0)
                
            Case "green", "grn"
                Color_Extended = RGB(0, 128, 0)
                
            Case "yellow", "gelb"
                Color_Extended = RGB(255, 255, 0)
                
            Case "blue", "blau"
                Color_Extended = RGB(0, 0, 255)
                
            Case "black", "schwarz"
                Color_Extended = RGB(0, 0, 0)
                
            Case "white", "wei"
                Color_Extended = RGB(255, 255, 255)
        
        End Select
    
    End If

End Function

'-------------------------------------------------------------------------
'Initialisierung wichtiger Variablen.
'
'Letzte nderung: 26.12.2005
'-------------------------------------------------------------------------

Private Sub UserControl_Initialize()

    DEFAULT_COLOR = 0
    DEFAULT_FONT = "MS Sans Serif"
    DEFAULT_SIZE = 8
    
    ADD_COLOR = 0
    ADD_FONT = "MS Sans Serif"
    ADD_SIZE = 8
    
    VERTPOS = 0
        
    Call Verarbeiten("<df=Book Antiqua><b>ML<-b> <c=126045098>Label<-c>" & " " & Mid(UserControl.Name, Len(UserControl.Name))) 'Demotext

End Sub

'-------------------------------------------------------------------------
'Lscht deine Festplatte. XD
'
'Letzte nderung: 26.12.2005
'-------------------------------------------------------------------------

Public Sub Cls()

    Dim i As Integer
    
    For i = 1 To label.UBound
        Unload label(i)
    Next i
        
    counter = 0
        
End Sub

'-------------------------------------------------------------------------
'Hintergrundfarbe des Steuerelements.
'
'Letzte nderung: 27.12.2005
'-------------------------------------------------------------------------

Public Property Get BackColor() As Variant

    BackColor = UserControl.BackColor

End Property

Public Property Let BackColor(ByVal vNewValue As Variant)

    UserControl.BackColor = vNewValue

End Property
