VERSION 5.00
Begin VB.UserControl oHtmlLabel 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
End
Attribute VB_Name = "oHtmlLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : oHtmlLabel
' DateTime  : 31.12.2005 17:15
' Author    : Philipp S
' Purpose   : Label das HTML Code darstellen kann
'---------------------------------------------------------------------------------------

Option Explicit

Public Type COLORBYTES
   BlueByte       As Byte
   GreenByte      As Byte
   RedByte        As Byte
   AlphaByte      As Byte
End Type

Public Type COLORLONG
   longval        As Long
End Type

Public Type RECT
   Left           As Long
   Top            As Long
   Right          As Long
   Bottom         As Long
End Type

Public Type Size
   Width          As Long
   Height         As Long
End Type

Public Type bString
   l_lLenght      As Long
   l_bData()      As Byte
End Type

Public Type aTagOption
   l_rSize        As Size
   l_bBold        As Boolean
   l_bItalic      As Boolean
   l_bUnderline   As Boolean
   l_bStrikeout   As Boolean
   l_bAnitAlias   As Boolean
   l_lSize        As Long
   l_lColor       As Long
   l_lbgColor     As Long
   l_lFormat      As Long
   l_bbgImage     As String
   l_bFont        As String
End Type

Private Type aUserTag
   l_sTagName     As String
   l_alOption     As aTagOption
   l_lFormatSet   As Long
End Type

'Hier wird das Format gespeichert
Private Const c_SUB        As Long = 1    'Tiefgestellt
Private Const c_SUP        As Long = 2    'Hochgestellt

'Wird fr define Tags verwendet um zu speichern welche Attribute gesetzt sind
Private Const c_BOLD       As Long = 1    'Fett
Private Const c_ITALIC     As Long = 2    'Kursiv
Private Const c_UNDERLINE  As Long = 4    'Unterstrichen
Private Const c_STRIKEOUT  As Long = 8    'Durchstrichen
Private Const c_ANTIALIAS  As Long = 16   'Anti Alias
Private Const c_SIZE       As Long = 32   'Schriftgre
Private Const c_COLOR      As Long = 64   'Schriftfarbe
Private Const c_BGCOLOR    As Long = 128  'Hintergrundfarbe
Private Const c_FORMAT     As Long = 256  'Hoch/Tiefgestellt
Private Const c_BGIMAGE    As Long = 512  'Hintergrundbild
Private Const c_FONT       As Long = 1024 'Schriftart
Private Const c_WIDTH      As Long = 2048 'Hhe
Private Const c_HEIGHT     As Long = 4096 'Breite

'---=== Eigenschaften Variablen ===---
Dim mText         As String      'Entlt die Text Eigenschaft
Dim mParseErrors  As Boolean     'Legt fest ob XML fehler gezeigt werden
Dim mAutoHTMLTag  As Boolean     'Legt fest ob Automatisch <html></html>
                                 'Eingefgt wird

'---=== Dom Variablen ===---
Dim xmlDoc        As DOMDocument40 'Dokument
Dim mLineHeight() As Long        'Array der die Zeilenhhen enthlt
Dim maLine        As Long        'Aktuelle Zeile
Dim mDomList()    As aTagOption  'Liste der Dom Elemente
Dim mDomCount     As Long        'Anzahl der DomElemente
Dim maDomNumber   As Long        'Aktuelles Dom Element
Dim TagId         As Long        'Aktuelle Tag ID
Dim mUserTags()   As aUserTag    'Eigene Tags
Dim mUserTagCount As Long        'Anzahl der UserTags

Dim bPrint        As Boolean     'Wird gesetzt wenn der 1. String gezeichnet wurde

'---=== GDI+ Variablen ===---
Dim mGDI_Token    As Long        'Token mit dem GDI aufgerufen wurde
Dim mGDI_GFX      As Long        'Grafikobjekt von GDI+
Dim gBrush        As Long        'GDIP Brush fr die Zeichenroutine
Dim fontFamily    As Long
Dim gFont         As Long
Dim gImage        As Long
Dim gFormat       As Long

'---=== Zeichenpositionierungs Variablen ===---
Dim m_lLeft       As Long        '|
Dim m_lTop        As Long        '|->Aktuelle Zeichenposition
Dim m_llHeight    As Long        'Hhe der letzten Zeile
Dim m_laTop       As Long        'Hier wird der Wert gespeichert der bei einer
                                 'neuen Zeile zu m_lTop addiert werden soll

'---------------------------------------------------------------------------------------
' Procedure : Draw
' DateTime  : 31.12.2005 17:15
' Author    : Philipp S
' Purpose   : Zeichnet das Label
'---------------------------------------------------------------------------------------
'
Private Function Draw()
   Dim tmp As String
   On Error GoTo Draw_Error
   
   'Aufrumen und Variablen zurcksetzen
   Cls
   Refresh
   m_lLeft = 0
   m_lTop = 0
   TagId = 0
   maLine = 1
   bPrint = False
   ReDim mLineHeight(0)
   ReDim mDomList(0)
   ReDim mUserTags(0)
   mUserTagCount = 0
   maLine = 0
   maDomNumber = 0
   mDomCount = 0
   mLineHeight(0) = 12
         
   Set xmlDoc = New DOMDocument40
   
   'Erstellt von der eigenen HDC ein neues Grafikobjekt
   GdipError GdipCreateFromHDC(hDC, mGDI_GFX)
   
   
   If AutoHTMLTag Then
      tmp = "<html>" & Replace(mText, vbCrLf, " ") & "</html>"
   Else
      tmp = Replace(mText, vbCrLf, " ")
   End If
   
   xmlDoc.loadXML tmp
            
   'Auf Fehler berprfen
   If xmlDoc.parseError.errorCode = 0 Then
      If xmlDoc.childNodes.Item(0).childNodes.Length > 0 Then
         'Die Domliste auslesen
         GetDomList xmlDoc.childNodes, 0
         maLine = 0
         bPrint = False
            
         'Zeichenroutine
         DrawDomList xmlDoc.childNodes
      End If
   Else
      If mParseErrors Then
         MsgBox "Fehler im XML Code:" & vbCrLf & "Zeile:" & xmlDoc.parseError.Line & _
                vbCrLf & "Beschreibung:" & vbCrLf & xmlDoc.parseError.reason & _
                vbCrLf & "Code:" & vbCrLf & xmlDoc.parseError.srcText, _
                vbExclamation, "Falscher XML Code"
      End If
   End If
      
      
   Set xmlDoc = Nothing
   
   'Grafikobjekt lschen
   GdipDeleteGraphics mGDI_GFX
   Refresh

   On Error GoTo 0
   Exit Function

Draw_Error:

   MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Draw of Benutzersteuerelement oHtmlLabel"
End Function

'---------------------------------------------------------------------------------------
' Procedure : GetDomList
' DateTime  : 02.01.2006 17:07
' Author    : Philipp S
' Purpose   : Geht denn HTML Code durch und speichert die Hhe der Zeilen
'             in dem mLineHeight Array
' Extra     : Wird Rekursiv aufgerufen
'---------------------------------------------------------------------------------------
'
Function GetDomList(Optional DomElement As IXMLDOMNodeList, Optional ByVal alPtr As Long)
   Dim I          As Long
   Dim dAttr      As IXMLDOMAttribute
   Dim dElement   As Object
   Dim bColor     As COLORBYTES
   Dim lColor     As Long
   Dim Ptr        As Long

   On Error GoTo GetDomList_Error

   For Each dElement In DomElement
      If dElement Is Nothing Then Exit For
      If dElement.nodeType = NODE_ELEMENT Then
         'Ein neues Element der mDomList hinzufgen mit alPtr as Parent
         AddDomElement alPtr
         'mDomList(maDomNumber).l_sTag = dElement.baseName
         'Set mDomList(maDomNumber).l_dElement = dElement
                  
         'berprfen ob es sich um ein p oder br Tag handelt und im Fall
         'eine Neue Zeile beginnen. Wenn es sich um ein Formatierungstag handelt
         'die entsprechende Eigenschaft setzen
         Select Case LCase(dElement.baseName)
         Case "p", "br":
            If bPrint Then
               maLine = maLine + 1
               ReDim Preserve mLineHeight(maLine)
               mLineHeight(maLine) = 12
            End If
         Case "b"
            mDomList(maDomNumber).l_bBold = True
         Case "u"
            mDomList(maDomNumber).l_bUnderline = True
         Case "i"
            mDomList(maDomNumber).l_bItalic = True
         Case "s"
            mDomList(maDomNumber).l_bStrikeout = True
         Case "sub"
            mDomList(maDomNumber).l_lFormat = mDomList(maDomNumber).l_lFormat Or c_SUB
         Case "sup"
            mDomList(maDomNumber).l_lFormat = mDomList(maDomNumber).l_lFormat Or c_SUP
         Case "define"
            'Eigenes Tag definieren
            AddUserTag dElement
         Case Else
            'Ein unbekanntes Tag, evtl. ein User Tag wenn ja, Eigenschaften setzten
            For I = 0 To mUserTagCount - 1
               If mUserTags(I).l_sTagName = LCase(dElement.baseName) Then
                  If (mUserTags(I).l_lFormatSet And c_BOLD) = c_BOLD Then
                     mDomList(maDomNumber).l_bBold = mUserTags(I).l_alOption.l_bBold
                  End If
                  If (mUserTags(I).l_lFormatSet And c_ITALIC) = c_ITALIC Then
                     mDomList(maDomNumber).l_bItalic = mUserTags(I).l_alOption.l_bItalic
                  End If
                  If (mUserTags(I).l_lFormatSet And c_UNDERLINE) = c_UNDERLINE Then
                     mDomList(maDomNumber).l_bUnderline = mUserTags(I).l_alOption.l_bUnderline
                  End If
                  If (mUserTags(I).l_lFormatSet And c_STRIKEOUT) = c_STRIKEOUT Then
                     mDomList(maDomNumber).l_bStrikeout = mUserTags(I).l_alOption.l_bStrikeout
                  End If
                  If (mUserTags(I).l_lFormatSet And c_ANTIALIAS) = c_ANTIALIAS Then
                     mDomList(maDomNumber).l_bAnitAlias = mUserTags(I).l_alOption.l_bAnitAlias
                  End If
                  If (mUserTags(I).l_lFormatSet And c_SIZE) = c_SIZE Then
                     mDomList(maDomNumber).l_lSize = mUserTags(I).l_alOption.l_lSize
                     If mLineHeight(maLine) < mDomList(maDomNumber).l_lSize Then
                        mLineHeight(maLine) = mDomList(maDomNumber).l_lSize
                     End If
                  End If
                  If (mUserTags(I).l_lFormatSet And c_COLOR) = c_COLOR Then
                     mDomList(maDomNumber).l_lColor = mUserTags(I).l_alOption.l_lColor
                  End If
                  If (mUserTags(I).l_lFormatSet And c_BGCOLOR) = c_BGCOLOR Then
                     mDomList(maDomNumber).l_lbgColor = mUserTags(I).l_alOption.l_lbgColor
                  End If
                  If (mUserTags(I).l_lFormatSet And c_FORMAT) = c_FORMAT Then
                     mDomList(maDomNumber).l_lFormat = mUserTags(I).l_alOption.l_lFormat
                  End If
                  If (mUserTags(I).l_lFormatSet And c_WIDTH) = c_WIDTH Then
                     mDomList(maDomNumber).l_rSize.Width = mUserTags(I).l_alOption.l_rSize.Width
                  End If
                  If (mUserTags(I).l_lFormatSet And c_HEIGHT) = c_HEIGHT Then
                     mDomList(maDomNumber).l_rSize.Height = mUserTags(I).l_alOption.l_rSize.Height
                     If mLineHeight(maLine) < mDomList(maDomNumber).l_lSize Then
                        mLineHeight(maLine) = mDomList(maDomNumber).l_lSize
                     End If
                  End If
                  If (mUserTags(I).l_lFormatSet And c_FONT) = c_FONT Then
                     mDomList(maDomNumber).l_bFont = mUserTags(I).l_alOption.l_bFont
                  End If
                  If (mUserTags(I).l_lFormatSet And c_BGIMAGE) = c_BGIMAGE Then
                     mDomList(maDomNumber).l_bbgImage = mUserTags(I).l_alOption.l_bbgImage
                  End If
               End If
            Next I
         End Select
         
         'berprfen ob Attribute vorhanden sind und ob es sich um ein normales
         'Tag handelt
         If dElement.Attributes.Length > 0 And Not _
           (LCase(dElement.baseName) = "define" Or _
           LCase(dElement.baseName) = "docstyle") Then
           
            For I = 1 To dElement.Attributes.Length  'Attribute durchlaufen
               Set dAttr = dElement.Attributes(I - 1)
               
               'Die Attribute setzten
               Select Case LCase(dAttr.baseName)
               Case "size"
                  'Falls der Wert hher ist als die aktuelle Zeile,
                  'der Zeile eine neue Hhe zuweisen
                  If mLineHeight(maLine) < Val(dAttr.Value) Then
                     mLineHeight(maLine) = Val(dAttr.Value)
                  End If
                  mDomList(maDomNumber).l_lSize = Val(dAttr.Value)
               Case "height"
                  'Falls der Wert hher ist als die aktuelle Zeile,
                  'der Zeile eine neue Hhe zuweisen
                  If mLineHeight(maLine) < Val(dAttr.Value) Then
                     mLineHeight(maLine) = Val(dAttr.Value)
                  End If
                  mDomList(maDomNumber).l_rSize.Height = Val(dAttr.Value)
               Case "width"
                  mDomList(maDomNumber).l_rSize.Width = Val(dAttr.Value)
               Case "color"
                  mDomList(maDomNumber).l_lColor = TranslateColor(dAttr.Value)
               Case "bgcolor"
                  mDomList(maDomNumber).l_lbgColor = TranslateColor(dAttr.Value)
               Case "smoothingmode"
                  'Fals der Wert antialias ist, AntiAlias auf True setzten
                  'Wenn der Wert default ist->False
                  If LCase(dAttr.Text) = "antialias" Then
                     mDomList(maDomNumber).l_bAnitAlias = True
                  ElseIf LCase(dAttr.Text) = "default" Then
                     mDomList(maDomNumber).l_bAnitAlias = False
                  End If
               Case "alpha"
                  'Aktuelle Farbe auslesen und neuen Alpha Wert schreiben
                  bColor = GetARGB(mDomList(maDomNumber).l_lColor)
                  lColor = MakeARGB(Val(dAttr.Value), bColor.RedByte, bColor.GreenByte, bColor.BlueByte)
                  mDomList(maDomNumber).l_lColor = lColor
               Case "font"
                  mDomList(maDomNumber).l_bFont = dAttr.Value
               Case "bgimage"
                  mDomList(maDomNumber).l_bbgImage = dAttr.Value
               End Select
               
            Next I
         End If


         Ptr = maDomNumber
         If dElement.childNodes.Length > 0 Then
            GetDomList dElement.childNodes, Ptr
         End If
      ElseIf dElement.nodeType = NODE_TEXT Then
         bPrint = True
         AddDomElement alPtr
      End If
   Next

   On Error GoTo 0
   Exit Function

GetDomList_Error:

   MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure GetDomList of Benutzersteuerelement oHtmlLabel"
End Function



'---------------------------------------------------------------------------------------
' Procedure : DrawDomList
' DateTime  : 31.12.2005 17:34
' Author    : Philipp S
' Purpose   : Zeichnet die verschachtelten Elemente
'---------------------------------------------------------------------------------------
'
Private Function DrawDomList(DomElement As IXMLDOMNodeList)
   Dim dElement   As IXMLDOMElement
   Dim dText      As IXMLDOMText
   Dim I As Long, J As Long
   Dim dAttr      As IXMLDOMAttribute
   Dim style      As Long
   Dim rString    As RECTF
   Dim rMeasure   As RECTF
   Dim rDrawRect  As RECTF
   Dim percent    As Double
   
   On Error GoTo DrawDomList_Error
   
   'Auf Eintrge berprfen
   If DomElement.Length > 0 Then
      For I = 1 To DomElement.Length
         If DomElement(I - 1).nodeType = NODE_ELEMENT Then
            Set dElement = DomElement(I - 1)

            TagId = TagId + 1
            
            'Dokument Style
            If dElement.baseName = "docstyle" Then
               If dElement.Attributes.Length > 0 Then
                  For J = 1 To dElement.Attributes.Length
                     Set dAttr = dElement.Attributes(J - 1)
                     Select Case LCase(dAttr.baseName)
                     Case "bgimage"
                        If Mid(dAttr.Value, 2, 2) <> ":\" Then
                           dAttr.Value = App.Path & "\" & dAttr.Value
                        End If
                        GdipError GdipLoadImageFromFile(dAttr.Value, gImage)
                        GdipError GdipDrawImage(mGDI_GFX, gImage, 0, 0)
                        GdipError GdipDisposeImage(gImage)
                     Case "bgcolor"
                        GdipError GdipCreateSolidFill(TranslateColor(dAttr.Value) Or &HFF000000, gBrush)
                        GdipError GdipFillRectangle(mGDI_GFX, gBrush, 0, 0, ScaleWidth, ScaleHeight)
                        GdipError GdipDeleteBrush(gBrush)
                     End Select
                  Next J
               End If
            End If
            
            Select Case LCase(dElement.baseName)
            Case "br"
               m_lTop = m_lTop + mLineHeight(maLine) + m_laTop
               m_lLeft = 0
               maLine = maLine + 1
               m_laTop = 0
            Case "p"
               If bPrint Then
                  maLine = maLine + 1
               End If
               If maLine > 0 Then
                  m_lTop = m_lTop + mLineHeight(maLine - 1) + 3 + m_laTop
               End If
               m_lLeft = 0
               m_laTop = 0
            End Select
            If dElement.childNodes.Length > 0 Then
               DrawDomList dElement.childNodes
            End If
                        
         ElseIf DomElement(I - 1).nodeType = NODE_TEXT Then
            bPrint = True
            TagId = TagId + 1
            Set dText = DomElement(I - 1)
            If mDomList(TagId - 1).l_bFont = "" Then
               GdipError GdipCreateFontFamilyFromName("Verdana", 0&, fontFamily)
            Else
               GdipError GdipCreateFontFamilyFromName(mDomList(TagId - 1).l_bFont, 0&, fontFamily)
            End If
            
            With rString
               .Left = m_lLeft
               .Top = m_lTop + mLineHeight(maLine) - mDomList(TagId - 1).l_lSize
                      
               If (mDomList(TagId - 1).l_lFormat And c_SUB) = c_SUB Then
                  mDomList(TagId - 1).l_lSize = mDomList(TagId - 1).l_lSize - 2
                  .Top = .Top + 5
               ElseIf (mDomList(TagId - 1).l_lFormat And c_SUP) = c_SUP Then
                  mDomList(TagId - 1).l_lSize = mDomList(TagId - 1).l_lSize - 2
                  .Top = .Top - 2
               End If
               If mDomList(TagId - 1).l_rSize.Width > 0 Then
                  .Width = mDomList(TagId - 1).l_rSize.Width
               Else
                  .Width = ScaleWidth - m_lLeft
               End If
               If mDomList(TagId - 1).l_rSize.Height > 0 Then
                  .Height = mDomList(TagId - 1).l_rSize.Height
               Else
                  .Height = ScaleHeight - m_lTop
               End If
            End With
            
            style = 0
            
            If mDomList(TagId - 1).l_bBold Then style = style Or FontStyleBold
            If mDomList(TagId - 1).l_bItalic Then style = style Or FontStyleItalic
            If mDomList(TagId - 1).l_bUnderline Then style = style Or FontStyleUnderline
            If mDomList(TagId - 1).l_bStrikeout Then style = style Or FontStyleStrikeout
            
            GdipError GdipCreateFont(fontFamily, mDomList(TagId - 1).l_lSize, style, UnitPixel, gFont)
            
            If mDomList(TagId - 1).l_bAnitAlias Then
               GdipError GdipSetTextRenderingHint(mGDI_GFX, TextRenderingHintAntiAlias)
            Else
               GdipError GdipSetTextRenderingHint(mGDI_GFX, TextRenderingHintSystemDefault)
            End If
            
            GdipError GdipCreateStringFormat(0&, 0&, gFormat)
            
            GdipError GdipSetStringFormatLineAlign(gFormat, StringAlignmentNear)
            
            GdipError GdipMeasureString(mGDI_GFX, dText.Data, Len(dText.Data), gFont, rString, gFormat, rMeasure, 0, 0)
            
            rDrawRect.Left = rMeasure.Left
            rDrawRect.Top = rMeasure.Top
            If mDomList(TagId - 1).l_rSize.Height <> 0 Then
               rDrawRect.Height = mDomList(TagId - 1).l_rSize.Height
               rDrawRect.Top = rDrawRect.Top - (mLineHeight(maLine) - mDomList(TagId - 1).l_lSize)
            Else
               rDrawRect.Height = rMeasure.Height
            End If
            If mDomList(TagId - 1).l_rSize.Width <> 0 Then
               rDrawRect.Width = mDomList(TagId - 1).l_rSize.Width
            Else
               rDrawRect.Width = rMeasure.Width
            End If
            
            'Hintergrundfarbe zeichnen
            If mDomList(TagId - 1).l_lbgColor <> Colors.Black Then
               GdipError GdipCreateSolidFill(mDomList(TagId - 1).l_lbgColor, gBrush)
               GdipError GdipFillRectangles(mGDI_GFX, gBrush, rDrawRect, 1)
               GdipError GdipDeleteBrush(gBrush)
            End If
            'Hintergrundbild zeichnen
            If mDomList(TagId - 1).l_bbgImage <> "" Then
               If Mid(mDomList(TagId - 1).l_bbgImage, 2, 2) <> ":\" Then
                  mDomList(TagId - 1).l_bbgImage = App.Path & "\" & mDomList(TagId - 1).l_bbgImage
               End If
               GdipError GdipLoadImageFromFile(mDomList(TagId - 1).l_bbgImage, gImage)
               GdipError GdipDrawImageRect(mGDI_GFX, gImage, rDrawRect.Left, rDrawRect.Top, rDrawRect.Width, rDrawRect.Height)
               GdipError GdipDisposeImage(gImage)
            End If
            
            If ScaleWidth - m_lLeft < 10 Then
               m_lTop = m_lTop + mLineHeight(maLine) - mDomList(TagId - 1).l_lSize + m_llHeight + mLineHeight(maLine) + 3
               rString.Top = m_lTop
               rString.Left = 0
               rString.Width = ScaleWidth
               GdipError GdipMeasureString(mGDI_GFX, dText.Data, Len(dText.Data), gFont, rString, gFormat, rMeasure, 0, 0)
            End If
            
            GdipError GdipCreateSolidFill(mDomList(TagId - 1).l_lColor, gBrush)
            
            GdipError GdipDrawString(mGDI_GFX, dText.Data, Len(dText.Data), gFont, rString, gFormat, gBrush)

            GdipError GdipDeleteBrush(gBrush)
            GdipError GdipDeleteStringFormat(gFormat)
            GdipError GdipDeleteFont(gFont)
            GdipError GdipDeleteFontFamily(fontFamily)
            
            If mDomList(TagId - 1).l_rSize.Width < rMeasure.Width Then
               m_lLeft = rMeasure.Left + rMeasure.Width
            Else
               m_lLeft = rMeasure.Left + mDomList(TagId - 1).l_rSize.Width
            End If

            '
            If rMeasure.Height < 75 Then
               percent = 0.25
            ElseIf rMeasure.Height > 100 Then
               percent = 0
            Else
               percent = (100 - rMeasure.Height) / 100
            End If
            If mLineHeight(maLine) < rMeasure.Height - rMeasure.Height * percent Then
               m_laTop = rMeasure.Height - rMeasure.Height * percent
               m_llHeight = rMeasure.Height * percent
            Else
               m_llHeight = rMeasure.Height * percent
            End If
         End If
      Next I
   End If

   On Error GoTo 0
   Exit Function

DrawDomList_Error:

   MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawDomList of Benutzersteuerelement oHtmlLabel"
End Function

'---------------------------------------------------------------------------------------
' Procedure : Text
' DateTime  : 31.12.2005 17:26
' Author    : Philipp S
' Purpose   : Html Code speichern und berprfen
'---------------------------------------------------------------------------------------
'
Property Let Text(ByVal vData As String)
   On Error GoTo Text_Error

   mText = vData
   Draw
   PropertyChanged "Text"

   On Error GoTo 0
   Exit Property

Text_Error:

   MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Text of Benutzersteuerelement oHtmlLabel"
End Property

Property Get Text() As String
   Text = mText
End Property

'---------------------------------------------------------------------------------------
' Procedure : BodyAutoInsert
' DateTime  : 08.01.2006 17:44
' Author    : Philipp S
' Purpose   : Legt fest ob das HTML Tag automatisch eingefgt werden soll
'---------------------------------------------------------------------------------------
'
Property Let AutoHTMLTag(ByVal vData As Boolean)

   On Error GoTo AutoHTMLTag_Error

   mAutoHTMLTag = vData
   Draw

   On Error GoTo 0
   Exit Property

AutoHTMLTag_Error:

   MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure AutoHTMLTag of Benutzersteuerelement oHtmlLabel"
End Property

Property Get AutoHTMLTag() As Boolean
   AutoHTMLTag = mAutoHTMLTag
End Property

'---------------------------------------------------------------------------------------
' Procedure : ShowParseErrors
' DateTime  : 08.01.2006 17:46
' Author    : Philipp S
' Purpose   : Legt fest ob Fehler im XML angezeigt werden sollen
'---------------------------------------------------------------------------------------
'
Property Let ShowParseErrors(ByVal vData As Boolean)

   On Error GoTo ShowParseErrors_Error

   mParseErrors = vData

   On Error GoTo 0
   Exit Property

ShowParseErrors_Error:

   MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure ShowParseErrors of Benutzersteuerelement oHtmlLabel"
End Property

Property Get ShowParseErrors() As Boolean
   ShowParseErrors = mParseErrors
End Property

'---------------------------------------------------------------------------------------
' Procedure : BackColor
' DateTime  : 03.01.2006 11:05
' Author    : Philipp S
' Purpose   : Setzt die Hintergrundfarbe
'---------------------------------------------------------------------------------------
'
Public Property Let BackColor(ByVal lBackColor As OLE_COLOR)
   UserControl.BackColor = lBackColor
   Call UserControl.PropertyChanged("BackColor")
End Property

'---------------------------------------------------------------------------------------
' Procedure : BackColor
' DateTime  : 03.01.2006 11:05
' Author    : Philipp S
' Purpose   : Gibt die Hintergrundfarbe zurck
'---------------------------------------------------------------------------------------
'
Public Property Get BackColor() As OLE_COLOR
   BackColor = UserControl.BackColor
End Property

'---------------------------------------------------------------------------------------
' Procedure : AddUserTag
' DateTime  : 31.12.2006 23:00
' Author    : STANDART
' Purpose   : Erstellt ein neues Tag aus einem IXMLDOMElement
'---------------------------------------------------------------------------------------
'
Private Function AddUserTag(dElement As IXMLDOMElement)
Dim I As Long
Dim dAttr As IXMLDOMAttribute
   
   'Wenn der BaseName nicht define heit Funktion verlassen
   If LCase(dElement.baseName) <> "define" Then Exit Function
   
   'mUserTags ein neues Element hinzufgen
   ReDim Preserve mUserTags(mUserTagCount)
   
   With mUserTags(mUserTagCount)
      'Alle Atribute durchgehen und die Werte in mUserTags speichern
      For I = 1 To dElement.Attributes.Length
         Set dAttr = dElement.Attributes(I - 1)
         Select Case LCase(dAttr.baseName)
         Case "name"
            .l_sTagName = LCase(dAttr.Value)
         Case "bold"
            If LCase(dAttr.Value) = "true" Then
               .l_alOption.l_bBold = True
            ElseIf LCase(dAttr.Value) = "false" Then
               .l_alOption.l_bBold = False
            End If
            .l_lFormatSet = .l_lFormatSet Or c_BOLD
         Case "italic"
            If LCase(dAttr.Value) = "true" Then
               .l_alOption.l_bItalic = True
            ElseIf LCase(dAttr.Value) = "false" Then
               .l_alOption.l_bItalic = False
            End If
            .l_lFormatSet = .l_lFormatSet Or c_ITALIC
         Case "underline"
            If LCase(dAttr.Value) = "true" Then
               .l_alOption.l_bUnderline = True
            ElseIf LCase(dAttr.Value) = "false" Then
               .l_alOption.l_bUnderline = False
            End If
            .l_lFormatSet = .l_lFormatSet Or c_UNDERLINE
         Case "smoothingmode"
            If LCase(dAttr.Value) = "antialias" Then
               .l_alOption.l_bAnitAlias = True
            ElseIf LCase(dAttr.Value) = "default" Then
               .l_alOption.l_bAnitAlias = False
            End If
            .l_lFormatSet = .l_lFormatSet Or c_ANTIALIAS
         Case "strikeout"
            If LCase(dAttr.Value) = "true" Then
               .l_alOption.l_bStrikeout = True
            ElseIf LCase(dAttr.Value) = "false" Then
               .l_alOption.l_bStrikeout = False
            End If
            .l_lFormatSet = .l_lFormatSet Or c_STRIKEOUT
         Case "font"
            .l_alOption.l_bFont = dAttr.Value
            .l_lFormatSet = .l_lFormatSet Or c_FONT
         Case "size"
            mUserTags(mUserTagCount).l_alOption.l_lSize = Val(dAttr.Value)
           .l_lFormatSet = .l_lFormatSet Or c_SIZE
         Case "width"
            .l_alOption.l_rSize.Width = Val(dAttr.Value)
            .l_lFormatSet = .l_lFormatSet Or c_WIDTH
         Case "height"
            .l_alOption.l_rSize.Height = Val(dAttr.Value)
            .l_lFormatSet = .l_lFormatSet Or c_HEIGHT
         Case "color"
            .l_alOption.l_lColor = TranslateColor(dAttr.Value)
            .l_lFormatSet = .l_lFormatSet Or c_COLOR
         Case "bgcolor"
            .l_alOption.l_lbgColor = TranslateColor(dAttr.Value)
            .l_lFormatSet = .l_lFormatSet Or c_BGCOLOR
         Case "sub"
            If dAttr.Value = "true" Then
               .l_alOption.l_lFormat = .l_alOption.l_lFormat Or c_SUB
               .l_lFormatSet = .l_lFormatSet Or c_FORMAT
            ElseIf dAttr.Value = "false" Then
               .l_alOption.l_lFormat = .l_alOption.l_lFormat Xor c_SUB
               .l_lFormatSet = .l_lFormatSet Or c_FORMAT
            End If
         Case "sup"
            If dAttr.Value = "true" Then
               .l_alOption.l_lFormat = .l_alOption.l_lFormat Or c_SUP
               .l_lFormatSet = .l_lFormatSet Or c_FORMAT
            ElseIf dAttr.Value = "false" Then
               .l_alOption.l_lFormat = .l_alOption.l_lFormat Xor c_SUP
               .l_lFormatSet = .l_lFormatSet Or c_FORMAT
            End If
         Case "bgimage"
            .l_alOption.l_bbgImage = dAttr.Value
            .l_lFormatSet = .l_lFormatSet Or c_BGIMAGE
         End Select
      Next I
   End With
   
   'Die Anzahl an UserTags um eins erhhen
   mUserTagCount = mUserTagCount + 1
End Function

'---------------------------------------------------------------------------------------
' Procedure : InitGDI
' DateTime  : 01.01.2006 16:17
' Author    : Philipp S
' Purpose   : Initialisiert GDIPlus
'---------------------------------------------------------------------------------------
'
Private Function InitGDI(Version As Integer) As Boolean
Dim gdi_SInput As GdiplusStartupInput
   On Error GoTo InitGDI_Error

   gdi_SInput.GdiplusVersion = Version
   If GdiplusStartup(mGDI_Token, gdi_SInput, 0&) <> 0 Then InitGDI = False

   On Error GoTo 0
   Exit Function

InitGDI_Error:

   MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure InitGDI of Benutzersteuerelement oHtmlLabel"
End Function

'---------------------------------------------------------------------------------------
' Procedure : TerminateGDI
' DateTime  : 01.01.2006 16:17
' Author    : Philipp S
' Purpose   : Beendet GDIPlus
'---------------------------------------------------------------------------------------
'
Private Function TerminateGDI()
   On Error GoTo TerminateGDI_Error
   
   GdiplusShutdown mGDI_Token

   On Error GoTo 0
   Exit Function

TerminateGDI_Error:

   MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure TerminateGDI of Benutzersteuerelement oHtmlLabel"
End Function

'---------------------------------------------------------------------------------------
' Procedure : GetARGB
' DateTime  : 31.12.2006 22:59
' Author    : STANDART
' Purpose   : Gibt von einem Longwert die Farbbestandteile zurck
'---------------------------------------------------------------------------------------
'
Private Function GetARGB(argb As Long) As COLORBYTES
   Dim bytestruct As COLORBYTES
   Dim result As COLORLONG
   
   'Farbe in ein UDT mit einem Longfeld schreiben
   result.longval = argb
   
   'In ein UDT mit 4 Byte feldern umwandeln
   LSet bytestruct = result
   
   'UDT zurckgeben
   GetARGB = bytestruct
End Function

'---------------------------------------------------------------------------------------
' Procedure : MakeARGB
' DateTime  : 31.12.2006 22:59
' Author    : STANDART
' Purpose   : Erstellt einen Longwert aus den einzelnen Farbbestandteilen ARGB
'---------------------------------------------------------------------------------------
'
Private Function MakeARGB(ByVal Alpha As Byte, ByVal Red As Byte, ByVal Green As Byte, ByVal Blue As Byte) As Long
   Dim bytestruct As COLORBYTES
   Dim result As COLORLONG
   
   'Farben in einem UDT mit 4 Byte Feldern speichern
   With bytestruct
      .AlphaByte = Alpha
      .RedByte = Red
      .GreenByte = Green
      .BlueByte = Blue
   End With
   
   'In ein UDT mit einem Long Feld umwandeln
   LSet result = bytestruct
   'Das Longfeld zurckgeben
   MakeARGB = result.longval
End Function

'---------------------------------------------------------------------------------------
' Procedure : GetColorByName
' DateTime  : 31.12.2006 22:57
' Author    : STANDART
' Purpose   : Gibt den Longwert zu einem Farbnamen zurck
'---------------------------------------------------------------------------------------
'
Private Function GetColorByName(ColorName As String) As Long
   Select Case LCase(ColorName)
      Case "aliceblue":
         GetColorByName = &HFFF0F8FF
      Case "antiquewhite":
         GetColorByName = &HFFFAEBD7
      Case "aqua":
         GetColorByName = &HFF00FFFF
      Case "aquamarine":
         GetColorByName = &HFF7FFFD4
      Case "azure":
         GetColorByName = &HFFF0FFFF
      Case "beige":
         GetColorByName = &HFFF5F5DC
      Case "bisque":
         GetColorByName = &HFFFFE4C4
      Case "black":
         GetColorByName = &HFF000000
      Case "blanchedalmond":
         GetColorByName = &HFFFFEBCD
      Case "blue":
         GetColorByName = &HFF0000FF
      Case "blueviolet":
         GetColorByName = &HFF8A2BE2
      Case "brown":
         GetColorByName = &HFFA52A2A
      Case "burlywood":
         GetColorByName = &HFFDEB887
      Case "cadetblue":
         GetColorByName = &HFF5F9EA0
      Case "chartreuse":
         GetColorByName = &HFF7FFF00
      Case "chocolate":
         GetColorByName = &HFFD2691E
      Case "coral":
         GetColorByName = &HFFFF7F50
      Case "cornflowerblue":
         GetColorByName = &HFF6495ED
      Case "cornsilk":
         GetColorByName = &HFFFFF8DC
      Case "crimson":
         GetColorByName = &HFFDC143C
      Case "cyan":
         GetColorByName = &HFF00FFFF
      Case "darkblue":
         GetColorByName = &HFF00008B
      Case "darkcyan":
         GetColorByName = &HFF008B8B
      Case "darkgoldenrod":
         GetColorByName = &HFFB8860B
      Case "darkgray":
         GetColorByName = &HFFA9A9A9
      Case "darkgreen":
         GetColorByName = &HFF006400
      Case "darkkhaki":
         GetColorByName = &HFFBDB76B
      Case "darkmagenta":
         GetColorByName = &HFF8B008B
      Case "darkolivegreen":
         GetColorByName = &HFF556B2F
      Case "darkorange":
         GetColorByName = &HFFFF8C00
      Case "darkorchid":
         GetColorByName = &HFF9932CC
      Case "darkred":
         GetColorByName = &HFF8B0000
      Case "darksalmon":
         GetColorByName = &HFFE9967A
      Case "darkseagreen":
         GetColorByName = &HFF8FBC8B
      Case "darkslateblue":
         GetColorByName = &HFF483D8B
      Case "darkslategray":
         GetColorByName = &HFF2F4F4F
      Case "darkturquoise":
         GetColorByName = &HFF00CED1
      Case "darkviolet":
         GetColorByName = &HFF9400D3
      Case "deeppink":
         GetColorByName = &HFFFF1493
      Case "deepskyblue":
         GetColorByName = &HFF00BFFF
      Case "dimgray":
         GetColorByName = &HFF696969
      Case "dodgerblue":
         GetColorByName = &HFF1E90FF
      Case "firebrick":
         GetColorByName = &HFFB22222
      Case "floralwhite":
         GetColorByName = &HFFFFFAF0
      Case "forestgreen":
         GetColorByName = &HFF228B22
      Case "fuchsia":
         GetColorByName = &HFFFF00FF
      Case "gainsboro":
         GetColorByName = &HFFDCDCDC
      Case "ghostwhite":
         GetColorByName = &HFFF8F8FF
      Case "gold":
         GetColorByName = &HFFFFD700
      Case "goldenrod":
         GetColorByName = &HFFDAA520
      Case "gray":
         GetColorByName = &HFF808080
      Case "green":
         GetColorByName = &HFF008000
      Case "greenyellow":
         GetColorByName = &HFFADFF2F
      Case "honeydew":
         GetColorByName = &HFFF0FFF0
      Case "hotpink":
         GetColorByName = &HFFFF69B4
      Case "indianred":
         GetColorByName = &HFFCD5C5C
      Case "indigo":
         GetColorByName = &HFF4B0082
      Case "ivory":
         GetColorByName = &HFFFFFFF0
      Case "khaki":
         GetColorByName = &HFFF0E68C
      Case "lavender":
         GetColorByName = &HFFE6E6FA
      Case "lavenderblush":
         GetColorByName = &HFFFFF0F5
      Case "lawngreen":
         GetColorByName = &HFF7CFC00
      Case "lemonchiffon":
         GetColorByName = &HFFFFFACD
      Case "lightblue":
         GetColorByName = &HFFADD8E6
      Case "lightcoral":
         GetColorByName = &HFFF08080
      Case "lightcyan":
         GetColorByName = &HFFE0FFFF
      Case "lightgoldenrodyellow":
         GetColorByName = &HFFFAFAD2
      Case "lightgray":
         GetColorByName = &HFFD3D3D3
      Case "lightgreen":
         GetColorByName = &HFF90EE90
      Case "lightpink":
         GetColorByName = &HFFFFB6C1
      Case "lightsalmon":
         GetColorByName = &HFFFFA07A
      Case "lightseagreen":
         GetColorByName = &HFF20B2AA
      Case "lightskyblue":
         GetColorByName = &HFF87CEFA
      Case "lightslategray":
         GetColorByName = &HFF778899
      Case "lightsteelblue":
         GetColorByName = &HFFB0C4DE
      Case "lightyellow":
         GetColorByName = &HFFFFFFE0
      Case "lime":
         GetColorByName = &HFF00FF00
      Case "limegreen":
         GetColorByName = &HFF32CD32
      Case "linen":
         GetColorByName = &HFFFAF0E6
      Case "magenta":
         GetColorByName = &HFFFF00FF
      Case "maroon":
         GetColorByName = &HFF800000
      Case "mediumaquamarine":
         GetColorByName = &HFF66CDAA
      Case "mediumblue":
         GetColorByName = &HFF0000CD
      Case "mediumorchid":
         GetColorByName = &HFFBA55D3
      Case "mediumpurple":
         GetColorByName = &HFF9370DB
      Case "mediumseagreen":
         GetColorByName = &HFF3CB371
      Case "mediumslateblue":
         GetColorByName = &HFF7B68EE
      Case "mediumspringgreen":
         GetColorByName = &HFF00FA9A
      Case "mediumturquoise":
         GetColorByName = &HFF48D1CC
      Case "mediumvioletred":
         GetColorByName = &HFFC71585
      Case "midnightblue":
         GetColorByName = &HFF191970
      Case "mintcream":
         GetColorByName = &HFFF5FFFA
      Case "mistyrose":
         GetColorByName = &HFFFFE4E1
      Case "moccasin":
         GetColorByName = &HFFFFE4B5
      Case "navajowhite":
         GetColorByName = &HFFFFDEAD
      Case "navy":
         GetColorByName = &HFF000080
      Case "oldlace":
         GetColorByName = &HFFFDF5E6
      Case "olive":
         GetColorByName = &HFF808000
      Case "olivedrab":
         GetColorByName = &HFF6B8E23
      Case "orange":
         GetColorByName = &HFFFFA500
      Case "orangered":
         GetColorByName = &HFFFF4500
      Case "orchid":
         GetColorByName = &HFFDA70D6
      Case "palegoldenrod":
         GetColorByName = &HFFEEE8AA
      Case "palegreen":
         GetColorByName = &HFF98FB98
      Case "paleturquoise":
         GetColorByName = &HFFAFEEEE
      Case "palevioletred":
         GetColorByName = &HFFDB7093
      Case "papayawhip":
         GetColorByName = &HFFFFEFD5
      Case "peachpuff":
         GetColorByName = &HFFFFDAB9
      Case "peru":
         GetColorByName = &HFFCD853F
      Case "pink":
         GetColorByName = &HFFFFC0CB
      Case "plum":
         GetColorByName = &HFFDDA0DD
      Case "powderblue":
         GetColorByName = &HFFB0E0E6
      Case "purple":
         GetColorByName = &HFF800080
      Case "red":
         GetColorByName = &HFFFF0000
      Case "rosybrown":
         GetColorByName = &HFFBC8F8F
      Case "royalblue":
         GetColorByName = &HFF4169E1
      Case "saddlebrown":
         GetColorByName = &HFF8B4513
      Case "salmon":
         GetColorByName = &HFFFA8072
      Case "sandybrown":
         GetColorByName = &HFFF4A460
      Case "seagreen":
         GetColorByName = &HFF2E8B57
      Case "seashell":
         GetColorByName = &HFFFFF5EE
      Case "sienna":
         GetColorByName = &HFFA0522D
      Case "silver":
         GetColorByName = &HFFC0C0C0
      Case "skyblue":
         GetColorByName = &HFF87CEEB
      Case "slateblue":
         GetColorByName = &HFF6A5ACD
      Case "slategray":
         GetColorByName = &HFF708090
      Case "snow":
         GetColorByName = &HFFFFFAFA
      Case "springgreen":
         GetColorByName = &HFF00FF7F
      Case "steelblue":
         GetColorByName = &HFF4682B4
      Case "tan":
         GetColorByName = &HFFD2B48C
      Case "teal":
         GetColorByName = &HFF008080
      Case "thistle":
         GetColorByName = &HFFD8BFD8
      Case "tomato":
         GetColorByName = &HFFFF6347
      Case "transparent":
         GetColorByName = &HFFFFFF
      Case "turquoise":
         GetColorByName = &HFF40E0D0
      Case "violet":
         GetColorByName = &HFFEE82EE
      Case "wheat":
         GetColorByName = &HFFF5DEB3
      Case "white":
         GetColorByName = &HFFFFFFFF
      Case "whitesmoke":
         GetColorByName = &HFFF5F5F5
      Case "yellow":
         GetColorByName = &HFFFFFF00
      Case "yellowgreen":
         GetColorByName = &HFF9ACD32
   End Select
End Function

'---------------------------------------------------------------------------------------
' Procedure : AddDomElement
' DateTime  : 06.01.2006 20:48
' Author    : Philipp S
' Purpose   : Fgt dem mDomList Array ein neues Element hinzu mit dem
'             Abild des alPtr Array Elements
'             Wenn der alPtr nicht gesetzt wurde werden die
'             Standartwerte gesetzt
'---------------------------------------------------------------------------------------
'
Private Function AddDomElement(Optional ByVal alPtr As Long) As Long
Dim al As aTagOption

'Den mDomCount um eins erhhen
mDomCount = mDomCount + 1
'mDomList neu Dimensionieren
ReDim Preserve mDomList(mDomCount - 1)
If alPtr <> 0 Then 'berprfen ob alPtr angegeben wurde
   With mDomList(mDomCount - 1)
      'Aus alPtr einen UDT laden und Die Daten kopieren
      LSet al = mDomList(alPtr)
      .l_bBold = al.l_bBold
      .l_bItalic = al.l_bItalic
      .l_bUnderline = al.l_bUnderline
      .l_bStrikeout = al.l_bStrikeout
      .l_bAnitAlias = al.l_bAnitAlias
      
      .l_lColor = al.l_lColor
      .l_lSize = al.l_lSize
      .l_lbgColor = al.l_lbgColor
      .l_lFormat = al.l_lFormat
      
      LSet .l_rSize = al.l_rSize
      
      .l_bFont = al.l_bFont
      .l_bbgImage = al.l_bbgImage
   End With
Else
   mDomList(mDomCount - 1).l_lSize = 12
   mDomList(mDomCount - 1).l_lColor = Colors.Black
   mDomList(mDomCount - 1).l_lbgColor = Colors.Black
End If
'Rckgabewert setzen
AddDomElement = mDomCount - 1
'Aktuelle Dom Nummer = die ganze Anzahl - 1
maDomNumber = mDomCount - 1
End Function

'---------------------------------------------------------------------------------------
' Procedure : TranslateColor
' DateTime  : 06.01.2006 15:33
' Author    : Philipp S
' Purpose   : bersetzt eine HTML/GDI+ Farbe in einen Long Wert
'---------------------------------------------------------------------------------------
'
Private Function TranslateColor(Color As String) As Long
Dim tmp As Long
Dim cBytes As COLORBYTES
Color = Trim$(Color)
'Handelt es sich um einen Hex Wert in der VB schreibweise
If Left(Color, 1) = "&H" Then
   tmp = CLng(Color)
'Wenn das erste Zeichen ein # ist dann in ein &H umwandeln
ElseIf Left(Color, 1) = "#" Then
   tmp = CLng("&H" & Right(Color, Len(Color) - 1))
ElseIf IsNumeric(Color) Then
'Ist es schon ein Longwert
   tmp = Color
Else
'Ansonsten aus den Longwert von dem Namen der Farbe zurckgeben
   tmp = GetColorByName(Color)
End If

'Farbe aufspalten -> Wenn die Farbe nicht sichtbar ist(Alpha=0)
'dann sichtbar machen Alpha=255
cBytes = GetARGB(tmp)
If cBytes.AlphaByte = 0 Then
   tmp = 255
Else
   tmp = cBytes.AlphaByte
End If
tmp = MakeARGB(tmp, cBytes.RedByte, cBytes.GreenByte, cBytes.BlueByte)

TranslateColor = CLng(tmp)
End Function

'---------------------------------------------------------------------------------------
' Procedure : GdipError
' DateTime  : 06.01.2006 16:19
' Author    : Philipp S
' Purpose   : behandelt den GDI+ Rckgabewert
'---------------------------------------------------------------------------------------
'
Private Sub GdipError(Status As GpStatus)
   Dim sStatus          As String
   
   'berprft ob der Rckgabewert einen Fehler enthlt und gibt eine
   'Fehlernachricht zurck
   If Status <> Ok Then
      Select Case Status
      Case 1:
         sStatus = "Generic Error"
      Case 2:
         sStatus = "Invalid Parameter"
      Case 3:
         sStatus = "Out Of Memory"
      Case 4:
         sStatus = "Object Busy"
      Case 5:
         sStatus = "Insufficient Buffer"
      Case 6:
         sStatus = "Not Implemented"
      Case 7:
         sStatus = "Win 32 Error"
      Case 8:
         sStatus = "Wrong State"
      Case 9:
         sStatus = "Aborted"
      Case 10:
         sStatus = "File Not Found"
      Case 11:
         sStatus = "Value Overflow"
      Case 12:
         sStatus = "Access Denied"
      Case 13:
         sStatus = "Unknown Image Format"
      Case 14:
         sStatus = "Font Family Not Found"
      Case 15:
         sStatus = "Font Style Not Found"
      Case 16:
         sStatus = "Not TrueType Font"
      Case 17:
         sStatus = "Unsupported GDI+ Version"
      Case 18:
         sStatus = "GDI+ Not Initialized"
      Case 19:
         sStatus = "Property Not Found"
      Case 20:
         sStatus = "Property Not Supported"
      End Select
      If mParseErrors Then
         Err.Raise vbObjectError, "GDI+", sStatus & ": Status = " & Status
      End If
   End If
End Sub

Private Sub UserControl_Resize()
   'Neu Zeichnen wenn sich die gre verndert hat
   Draw
End Sub

Private Sub UserControl_Initialize()
   'GDI+ laden
   InitGDI 1
   ReDim mLineHeight(0)
   Draw
End Sub

Private Sub UserControl_Terminate()
   'GDI+ entladen
   TerminateGDI
End Sub

'---------------------------------------------------------------------------------------
' Procedure : UserControl_ReadProperties
' DateTime  : 31.12.2005 17:25
' Author    : Philipp S
' Purpose   : Eigenschaften lesen
'---------------------------------------------------------------------------------------
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
   mText = PropBag.ReadProperty("Text", "")
   mAutoHTMLTag = PropBag.ReadProperty("AutoHTMLTag", True)
   mParseErrors = PropBag.ReadProperty("ShowParseErrors", False)
   UserControl.BackColor = PropBag.ReadProperty("BackColor", vbWhite)
   'Steuerelement neu Zeichnen
   Draw
End Sub

'---------------------------------------------------------------------------------------
' Procedure : UserControl_WriteProperties
' DateTime  : 31.12.2005 17:26
' Author    : Philipp S
' Purpose   : Eigenschaften schreiben
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
   'Eigenschaften schreiben
   PropBag.WriteProperty "Text", mText, ""
   PropBag.WriteProperty "ShowParseErrors", mParseErrors, False
   PropBag.WriteProperty "BackColor", UserControl.BackColor, vbWhite
   PropBag.WriteProperty "AutoHTMLTag", AutoHTMLTag, True
End Sub

