VERSION 5.00
Begin VB.UserControl ucMLLabel 
   ClientHeight    =   345
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6255
   ScaleHeight     =   345
   ScaleWidth      =   6255
End
Attribute VB_Name = "ucMLLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*************************************************************************
'* ML-Label Control                                                      *
'* ----------------                                                      *
'*                                                                       *
'* Autor      : Stefan Ziems                                             *
'* Datum      : 23.12.2005                                               *
'* Version    : 1.0                                                      *
'* nderungen : 23.12.2005 - Erstellung des Controls                     *
'*              26.12.2005 - Events erweitern                            *
'*************************************************************************

Option Explicit

Private Declare Function CreateFontIndirect Lib "gdi32.dll" Alias "CreateFontIndirectA" (ByRef lpLogFont As LOGFONT) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function SetBkColor Lib "gdi32.dll" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetBkMode Lib "gdi32.dll" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function DrawState Lib "user32.dll" Alias "DrawStateA" (ByVal hdc As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As Long, ByVal wParam As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal n3 As Long, ByVal n4 As Long, ByVal un As Long) As Long
Private Declare Function TextOut Lib "gdi32.dll" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function MulDiv Lib "kernel32.dll" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function GetTextExtentPoint32 Lib "gdi32.dll" Alias "GetTextExtentPoint32A" (ByVal hdc As Long, ByVal lpsz As String, ByVal cbString As Long, ByRef lpSize As Size) As Long
Private Declare Function SetTextColor Lib "gdi32.dll" (ByVal hdc As Long, ByVal crColor As Long) As Long

Private Type Size
    cx As Long
    cy As Long
End Type

Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName As String * 32
End Type

' Font Konstanten
Private Const FW_NORMAL As Long = 400
Private Const FW_BOLD As Long = 700

Private Const LOGPIXELSX As Long = 88
Private Const LOGPIXELSY As Long = 90

'Events
Public Event Clicked()
Public Event DblClick()
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

Private WithEvents myFont As StdFont
Attribute myFont.VB_VarHelpID = -1

Private myAlignment       As AlignmentConstants
Private myText            As String
Private myForeColor       As Long

'*********************************************
'* Property - Font
'*********************************************
Public Property Get Font() As StdFont
   Set Font = myFont
End Property

Public Property Set Font(newFont As StdFont)
   With myFont
      .Bold = newFont.Bold
      .Italic = newFont.Italic
      .Name = newFont.Name
      .Size = newFont.Size
      .Charset = newFont.Charset
   End With
   PropertyChanged "Font"
End Property

'*********************************************
'* Property - Text
'*********************************************
Public Property Let Text(sValue As String)
    myText = sValue
    Refresh
End Property

Public Property Get Text() As String
    Text = myText
End Property

'*********************************************
'* Property - ForeColor
'*********************************************
Public Property Let ForeColor(lValue As Long)
    myForeColor = lValue
    Refresh
End Property

Public Property Get ForeColor() As Long
    ForeColor = myForeColor
End Property

Private Sub myFont_FontChanged(ByVal PropertyName As String)
   Set UserControl.Font = myFont
   Refresh
End Sub

'*********************************************
'* Events
'*********************************************
Private Sub UserControl_Click()
    RaiseEvent Clicked
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub UserControl_Initialize()
    Set myFont = New StdFont
    Set UserControl.Font = myFont
End Sub

'*********************************************
'* Text zeichnen
'*********************************************
Private Sub UserControl_Paint()
    Dim drawFont                As LOGFONT ' Type zum erstellen der Schriftart
    Dim fontSize                As Size    ' Gre des Fonts
    Dim lFont                   As Long    ' Handle zum Font
    Dim sTextWrite              As String  ' Das soll geschrieben werden
    Dim sTextLine               As String  ' Eine 'unbearbeitete' Textzeile
    Dim saTextArray()           As String  ' Der gesamte Text, getrennt nach Zeilen
    Dim sTag                    As String  ' Tag der Bearbeitet werden muss
    Dim lPosTagOpen             As Long    ' Position, Anfang des Tag
    Dim lPosTagClose            As Long    ' Position, Ende des Tag
    Dim lLastPos                As Long    ' Position, Temporr fr nchsten Schleifendurchlauf
    Dim lZeile                  As Long    ' Zhler fr Zeile
    Dim lXPos                   As Long    ' X - Position des Textes
    Dim lYPos                   As Long    ' Y - Position des Textes
    Dim lMaxTextHeightPerLine   As Long    ' Hhe vom Text
    'Control leeren
    Cls
    
    'Wenn nichts zu schreiben ist, dann raus
    If Len(myText) < 1 Then Exit Sub
    
    'Font vorbereiten
    With drawFont
        .lfFaceName = myFont.Name + Chr(0)
        .lfHeight = -MulDiv(myFont.Size, GetDeviceCaps(hdc, LOGPIXELSY), 72)
        .lfItalic = myFont.Italic
        .lfWeight = myFont.Weight
        .lfUnderline = myFont.Underline
        .lfStrikeOut = myFont.Strikethrough
        .lfCharSet = myFont.Charset
    End With
    
    SetTextColor hdc, myForeColor
    
    saTextArray = Split(myText, vbCrLf)
    
    For lZeile = LBound(saTextArray) To UBound(saTextArray)
        sTextLine = saTextArray(lZeile)
        
        lPosTagOpen = 1
        lLastPos = 0
        lXPos = 0
        lYPos = lYPos + lMaxTextHeightPerLine
        lMaxTextHeightPerLine = 0
        Do
            'Text durchsuchen nach [
            lPosTagOpen = InStr(lPosTagOpen, sTextLine, "[")
            lPosTagClose = 0
            sTag = ""
            
            If lPosTagOpen > 0 Then
                lPosTagClose = InStr(lPosTagOpen, sTextLine, "]")
                
                If lPosTagClose > 0 Then
                    'Tag gefunden
                    sTag = Mid(sTextLine, lPosTagOpen + 1, lPosTagClose - lPosTagOpen - 1)
                End If
            Else
                lPosTagOpen = Len(sTextLine)
            End If
            
            ' Zu schreibenden Text ermitteln (Tag rausgefiltert)
            If lPosTagClose > 0 Then
                sTextWrite = Mid(sTextLine, lLastPos + 1, lPosTagOpen - lLastPos - 1)
                lLastPos = lPosTagClose
                lPosTagOpen = lPosTagClose + 1
            Else
                sTextWrite = Mid(sTextLine, lLastPos + 1, lPosTagOpen - lLastPos)
                lPosTagOpen = lPosTagOpen + 1
                lLastPos = lPosTagOpen
            End If
            
            'Font erstellen
            lFont = CreateFontIndirect(drawFont)
            
            Call SelectObject(hdc, lFont)
        
            'Herrausfinden wie lang unser Text ist
            GetTextSize sTextWrite, fontSize
            
            lMaxTextHeightPerLine = Max(lMaxTextHeightPerLine, fontSize.cy)
            
            'Text ausgeben
            TextOut hdc, lXPos, lYPos, sTextWrite, Len(sTextWrite)
    
            'Textposition "merken"
            lXPos = lXPos + fontSize.cx
            
            DeleteObject (lFont)
            
            'ggf. Font fr den nchsten Text anpassen
            UpdateFont sTag, drawFont, lYPos
        Loop While lPosTagOpen < Len(sTextLine)
    Next
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
On Error Resume Next
    With PropBag
        Me.Text = .ReadProperty("Text", "")
        Me.Font = .ReadProperty("Font")
        Me.ForeColor = .ReadProperty("ForeColor", RGB(0, 0, 0))
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "Text", myText, ""
        .WriteProperty "Font", myFont
        .WriteProperty "ForeColor", myForeColor, RGB(0, 0, 0)
    End With
End Sub

Private Sub UpdateFont(ByVal sTag As String, ByRef drawFont As LOGFONT, ByRef lYPos As Long)
Dim bTagOn As Boolean
Dim lPos   As Long
Dim sValue As String
Dim lR     As Long
Dim lG     As Long
Dim lB     As Long

Static sPreviousFont As String
Static lPreviousSize As Long

    bTagOn = True

    If sTag = "" Then Exit Sub
    
    If Left(sTag, 1) = "/" Then
        bTagOn = False
        sTag = Mid(sTag, 2)
    End If
    
    lPos = InStr(sTag, "=")
    
    If lPos > 0 Then
        sValue = Mid(sTag, lPos + 1)
        sTag = Left(sTag, lPos - 1)
    End If
        
    With drawFont
        Select Case LCase(sTag)
            Case "b" ' Fett
                If bTagOn Then
                    .lfWeight = FW_BOLD
                Else
                    .lfWeight = FW_NORMAL
                End If
            Case "i" ' Kursiv
                .lfItalic = bTagOn
            Case "u" ' Unterstrichen
                .lfUnderline = bTagOn
            Case "s" ' Durchgestrichen
                .lfStrikeOut = bTagOn
            Case "up" ' Hochgestellt
                If bTagOn Then
                    lYPos = lYPos - 3
                Else
                    lYPos = lYPos + 3
                End If
            Case "down" ' Runtergestellt
                If bTagOn Then
                    lYPos = lYPos + 3
                Else
                    lYPos = lYPos - 3
                End If
            Case "color" ' Format #RRGGBB z.b #FFFF00 fr Gelb
                If bTagOn Then
                    If Left(sValue, 1) = "#" And Len(sValue) = 7 Then
                        lR = Val("&H" + Mid(sValue, 2, 2))
                        lG = Val("&H" + Mid(sValue, 4, 2))
                        lB = Val("&H" + Mid(sValue, 6, 2))
                        
                        SetTextColor hdc, RGB(lR, lG, lB)
                    End If
                Else
                    SetTextColor hdc, myForeColor
                End If
            Case "font" ' Name der Schriftart
                If bTagOn Then
                    sPreviousFont = .lfFaceName
                    .lfFaceName = sValue + Chr(0)
                Else
                    .lfFaceName = sPreviousFont
                End If
            Case "fontsize" ' Gre der Schriftart
                If bTagOn Then
                    lPreviousSize = .lfHeight
                    .lfHeight = -MulDiv(Val(sValue), GetDeviceCaps(hdc, LOGPIXELSY), 72)
                Else
                    .lfHeight = lPreviousSize
                End If
        End Select
    End With
End Sub

Private Function Max(ByVal lZahl1 As Long, ByVal lZahl2 As Long) As Long
    If lZahl1 > lZahl2 Then Max = lZahl1 Else Max = lZahl2
End Function

Private Function GetTextSize(ByVal sText As String, ByRef fontSize As Size)
    'Wenn der Text leer ist, wenigstens einen Buchstaben nehmen, um zu sehen wie hoch der Text ist
    If sText = "" Then sText = "I"

    GetTextExtentPoint32 hdc, sText, Len(sText), fontSize
End Function
