VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CScanner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mOffset      As Long
Private mLength      As Long
Private mLastChar    As Long
Private mStream()    As Byte
Private mEOS         As Boolean

'##########################################################################
'# Properties                                                             #
'##########################################################################

'-------------------------------------------------
'Property: InputStream
'-------------------------------------------------
Public Property Get InputStream() As String
    InputStream = TempInput
End Property

Public Property Let InputStream(RHS As String)
    mStream() = RHS
    mLength = UBound(mStream)
    mOffset = 0
    mEOS = False
End Property

'-------------------------------------------------
'GetNextToken As TToken
'Gibt den nchsten Token zurck
'Optional: ohne den Streampointer zu bewegen
'-------------------------------------------------
Friend Property Get GetNextToken( _
    Optional MovePointer As Boolean = True _
) As TToken

    Dim CurOffset       As Long

    If mEOS Then
        GetNextToken.TT_Type = ETT_EOS
        Exit Property
    End If

    CurOffset = mOffset

    GetNextToken = GetToken()

    If MovePointer = False Then
        mOffset = CurOffset
        mEOS = False
    End If
End Property

'##########################################################################
'# Subs/Functions                                                         #
'##########################################################################

'-------------------------------------------------
'GetToken As TToken
'Findet den nchsten Token
'-------------------------------------------------
Private Function GetToken() As TToken
    Const VBO       As Long = &H5B      '[
    Const VBC       As Long = &H5D      ']
    Const VTO       As Long = &H3C      '<
    Const VTC       As Long = &H3E      '>
    Const VTE       As Long = &H2F      '/
    Const VEQ       As Long = &H3D      '=

    Const VLU       As Long = &H55      'U
    Const VSU       As Long = &H75      'u
    Const VLI       As Long = &H49      'I
    Const VSI       As Long = &H69      'i
    Const VLB       As Long = &H42      'B
    Const VSB       As Long = &H62      'b
    Const VLH       As Long = &H48      'H
    Const VSH       As Long = &H68      'h
    Const VLL       As Long = &H4C      'L
    Const VSL       As Long = &H6C      'l
    Const VLf       As Long = &H46      'F
    Const VSF       As Long = &H66      'f
    Const VLC       As Long = &H43      'C
    Const VSC       As Long = &H63      'c
    Const VLS       As Long = &H53      'S
    Const VSS       As Long = &H73      's
    Const VCr       As Long = &HD       'vbCrLf

    Dim CurWord     As String
    Dim Status      As Long
    Dim TagOpen     As Boolean
    Dim CurTag      As ETokenType

    Do Until mEOS
        Select Case Status

            Case 0

                Select Case NextChar
                    Case VBO, VTO
                        If CurWord <> "" Then
                            GetToken.TT_Text = CurWord
                            GetToken.TT_Type = ETT_Text
                            CurWord = ""

                            Call Reset
                            Exit Do
                        End If

                        Status = 1
                        CurWord = CurWord & ChrW(mLastChar)
                    Case VCr
                        If CurWord <> "" Then
                            GetToken.TT_Text = CurWord
                            GetToken.TT_Type = ETT_Text
                            CurWord = ""

                            Call Reset
                            Exit Do
                        End If

                        Call NextChar
                        GetToken.TT_Type = ETT_LineBreak
                        Exit Do

                    Case -1
                        Exit Do

                    Case Else
                        CurWord = CurWord & ChrW(mLastChar)
                End Select

            Case 1

                Select Case NextChar
                    Case VTE
                        CurWord = CurWord & ChrW(mLastChar)
                        TagOpen = False
                        Status = 2

                    Case VLU, VSU, VLI, VSI, VLB, VSB, VLH, VSH, VLL, VSL
                        CurWord = CurWord & ChrW(mLastChar)
                        CurTag = CharToTag(mLastChar)
                        TagOpen = True
                        Status = 3

                    Case VLf, VSF
                        CurWord = CurWord & ChrW(mLastChar)
                        Status = 4

                    Case VLC, VSC
                        CurWord = CurWord & ChrW(mLastChar)
                        Status = 5

                    Case VLS, VSS
                        CurWord = CurWord & ChrW(mLastChar)
                        Status = 6

                    Case VCr
                        If CurWord <> "" Then
                            GetToken.TT_Text = CurWord
                            GetToken.TT_Type = ETT_Text
                            CurWord = ""

                            Call Reset
                            Exit Do
                        End If

                        Call NextChar
                        GetToken.TT_Type = ETT_LineBreak
                        Exit Do

                    Case Else
                        CurWord = CurWord & ChrW(mLastChar)
                        Status = 0
                End Select

            Case 2

                Select Case NextChar
                    Case VLU, VSU, VLI, VSI, VLB, VSB, VLH, VSH, _
                         VLL, VSL, VLf, VSF, VLC, VSC, VSS, VLS

                        CurWord = CurWord & ChrW(mLastChar)
                        CurTag = CharToTag(mLastChar)
                        Status = 3

                    Case VCr
                        If CurWord <> "" Then
                            GetToken.TT_Text = CurWord
                            GetToken.TT_Type = ETT_Text
                            CurWord = ""

                            Call Reset
                            Exit Do
                        End If

                        Call NextChar
                        GetToken.TT_Type = ETT_LineBreak
                        Exit Do

                    Case Else
                        CurWord = CurWord & ChrW(mLastChar)
                        Status = 0
                End Select

            Case 3

                Select Case NextChar
                    Case VBC, VTC
                        Select Case CurTag

                            Case ETT_UnderlineStart
                                If TagOpen = True Then
                                    GetToken.TT_Type = ETT_UnderlineStart
                                Else
                                    GetToken.TT_Type = ETT_UnderlineStop
                                End If

                                Exit Do

                            Case ETT_ItalicStart
                                If TagOpen = True Then
                                    GetToken.TT_Type = ETT_ItalicStart
                                Else
                                    GetToken.TT_Type = ETT_ItalicStop
                                End If

                                Exit Do

                            Case ETT_BoldStart
                                If TagOpen = True Then
                                    GetToken.TT_Type = ETT_BoldStart
                                Else
                                    GetToken.TT_Type = ETT_BoldStop
                                End If

                                Exit Do

                            Case ETT_HigherStart
                                If TagOpen = True Then
                                    GetToken.TT_Type = ETT_HigherStart
                                Else
                                    GetToken.TT_Type = ETT_HigherStop
                                End If

                                Exit Do

                            Case ETT_LowerStart
                                If TagOpen = True Then
                                    GetToken.TT_Type = ETT_LowerStart
                                Else
                                    GetToken.TT_Type = ETT_LowerStop
                                End If

                                Exit Do

                            Case ETT_FontStart
                                If TagOpen = False Then _
                                    GetToken.TT_Type = ETT_FontStop

                                Exit Do
                            Case ETT_FontSizeStart
                                If TagOpen = False Then _
                                    GetToken.TT_Type = ETT_FontSizeStop

                                Exit Do
                            Case ETT_ColorStart
                                If TagOpen = False Then _
                                    GetToken.TT_Type = ETT_ColorStop

                                Exit Do
                        End Select

                    Case VCr
                        If CurWord <> "" Then
                            GetToken.TT_Text = CurWord
                            GetToken.TT_Type = ETT_Text
                            CurWord = ""

                            Call Reset
                            Exit Do
                        End If

                        Call NextChar
                        GetToken.TT_Type = ETT_LineBreak
                        Exit Do

                    Case Else
                        CurWord = CurWord & ChrW(mLastChar)
                        Status = 0
                End Select

            Case 4
                Select Case NextChar
                    Case VEQ
                        GetToken = ExtractFont()
                        Exit Do

                    Case VCr
                        If CurWord <> "" Then
                            GetToken.TT_Text = CurWord
                            GetToken.TT_Type = ETT_Text
                            CurWord = ""

                            Call Reset
                            Exit Do
                        End If

                        Call NextChar
                        GetToken.TT_Type = ETT_LineBreak
                        Exit Do

                    Case Else
                        CurWord = CurWord & ChrW(mLastChar)
                        Status = 0
                End Select

            Case 5
                Select Case NextChar
                    Case VEQ
                        GetToken = ExtractColor()
                        Exit Do

                    Case VCr
                        If CurWord <> "" Then
                            GetToken.TT_Text = CurWord
                            GetToken.TT_Type = ETT_Text
                            CurWord = ""

                            Call Reset
                            Exit Do
                        End If

                        Call NextChar
                        GetToken.TT_Type = ETT_LineBreak
                        Exit Do

                    Case Else
                        CurWord = CurWord & ChrW(mLastChar)
                        Status = 0
                End Select

            Case 6
                Select Case NextChar
                    Case VEQ
                        GetToken = ExtractSize()
                        Exit Do

                    Case VCr
                        If CurWord <> "" Then
                            GetToken.TT_Text = CurWord
                            GetToken.TT_Type = ETT_Text
                            CurWord = ""

                            Call Reset
                            Exit Do
                        End If

                        Call NextChar
                        GetToken.TT_Type = ETT_LineBreak
                        Exit Do

                    Case Else
                        CurWord = CurWord & ChrW(mLastChar)
                        Status = 0
                End Select
        End Select
    Loop

    If mEOS And CurWord <> "" Then
        GetToken.TT_Type = ETT_Text
        GetToken.TT_Text = CurWord
    End If

    If mEOS And GetToken.TT_Type = ETT_Invalid Then _
        GetToken.TT_Type = ETT_EOS

End Function

'-------------------------------------------------
'ExtractFont As TToken
'"Extrahiert" den Namen der Schriftart
'-------------------------------------------------
Private Function ExtractFont() As TToken
    Const VBC       As Long = &H5D      ']
    Const VTC       As Long = &H3E      '>

    Dim CurFont     As String

    Do Until mEOS
        Select Case NextChar
            Case VBC, VTC
                ExtractFont.TT_Font = CurFont
                ExtractFont.TT_Type = ETT_FontStart

                Exit Do
            Case Else
                CurFont = CurFont & ChrW(mLastChar)
        End Select
    Loop
End Function

'-------------------------------------------------
'ExtractColor As TToken
'"Extrahiert" die Schriftfarbe, zusammengesetzt aus
'RGB Werten
'-------------------------------------------------
Private Function ExtractColor() As TToken
    Const VBC       As Long = &H5D      ']
    Const VTC       As Long = &H3E      '>
    Const V0        As Long = &H30
    Const V9        As Long = &H39
    Const VComma    As Long = &H2C

    Dim CurColor    As Long
    Dim Status      As Long
    Dim CurWord     As String

    ExtractColor.TT_Type = ETT_ColorStart

    Do Until mEOS
        Select Case NextChar
            Case V0 To V9
                CurColor = 10 * CurColor + mLastChar - V0
                CurWord = CurWord & ChrW(mLastChar)

            Case VComma
                CurWord = CurWord & ChrW(mLastChar)
                If CurColor > 255 Then _
                    CurColor = 255

                Select Case Status
                    Case 0
                        ExtractColor.TT_Color = CurColor
                        CurColor = 0
                        Status = 1
                    Case 1
                        ExtractColor.TT_Color = _
                            ExtractColor.TT_Color Or (CurColor * 256&)

                        CurColor = 0
                        Status = 2
                End Select

            Case VBC, VTC
                If Status = 2 Then
                    If CurColor > 255 Then _
                        CurColor = 255

                    ExtractColor.TT_Color = _
                        ExtractColor.TT_Color Or (CurColor * 65536)

                Else
                    ExtractColor.TT_Text = CurWord
                    ExtractColor.TT_Type = ETT_Text
                End If

                Exit Do

        End Select
    Loop
End Function

'-------------------------------------------------
'ExtractSize As TToken
'"Extrahiert" die Schriftgre
'-------------------------------------------------
Private Function ExtractSize() As TToken
    Const VBC       As Long = &H5D      ']
    Const VTC       As Long = &H3E      '>
    Const V0        As Long = &H30
    Const V9        As Long = &H39

    Dim CurSize     As Long
    Dim CurWord     As String

    ExtractSize.TT_Type = ETT_FontSizeStart

    Do Until mEOS
        Select Case NextChar
            Case V0 To V9
                CurSize = 10 * CurSize + mLastChar - V0
                CurWord = CurWord & ChrW(mLastChar)
            Case VBC, VTC
                ExtractSize.TT_FontSize = CurSize

                Exit Do
            Case Else
                ExtractSize.TT_Type = ETT_Text
                ExtractSize.TT_Text = CurWord

                Exit Do
        End Select
    Loop
End Function

'-------------------------------------------------
'CharToTag As ETokenType
'Gibt den Tokentyp zum Tokenkrzel zurck
'-------------------------------------------------
Private Function CharToTag(Char As Long) As ETokenType
    Dim tmp     As String

    tmp = LCase(ChrW(Char))
    Select Case tmp
        Case "u":   CharToTag = ETT_UnderlineStart
        Case "i":   CharToTag = ETT_ItalicStart
        Case "b":   CharToTag = ETT_BoldStart
        Case "h":   CharToTag = ETT_HigherStart
        Case "l":   CharToTag = ETT_LowerStart
        Case "c":   CharToTag = ETT_ColorStart
        Case "s":   CharToTag = ETT_FontSizeStart
        Case "f":   CharToTag = ETT_FontStart
    End Select
End Function

'-------------------------------------------------
'NextChar As Long
'Gibt das nchste Zeichen zurck
'-------------------------------------------------
Private Function NextChar() As Long
    If mOffset < mLength Then
        NextChar = mStream(mOffset) + mStream(mOffset + 1) * 256
        mOffset = mOffset + 2

        mLastChar = NextChar
    Else
        mEOS = True
        NextChar = -1
    End If
End Function

'-------------------------------------------------
'Reset
'Setzt den Streampointer ein Zeichen zurck
'-------------------------------------------------
Private Sub Reset()
    If mOffset > 0 And Not mEOS Then _
        mOffset = mOffset - 2
End Sub
