VERSION 5.00
Begin VB.UserControl MarkupLabel 
   ClientHeight    =   495
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2700
   HasDC           =   0   'False
   ScaleHeight     =   495
   ScaleWidth      =   2700
   Begin VB.PictureBox picOutput 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'Kein
      Height          =   375
      Left            =   0
      ScaleHeight     =   375
      ScaleWidth      =   2535
      TabIndex        =   0
      Top             =   0
      Width           =   2535
   End
End
Attribute VB_Name = "MarkupLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'MarkupLabel
'25.12.2005 by Simon Taddiken

'Update am 28.12.2005
'* Tags fr Schriftart, -farbe und -gre knnen geschlossen werden.
'* Events hinzugefgt
'* Namen der Eigenschaften verndert
'* Beispiele berarbeitet

'Erstellt fr die Weihnachtsausschreibung 2005 von www.activevb.de

'Das Label kann mit einer einfachen Markuplanguage formatiert werden.
'Es gibt 8 verschiedene Formatierungsmglichkeiten:

'[b] Text [/b]          Fett gedruckt
'[i] Text [/i]          Kursiv
'[u] Text [/U]          Unterstrichen
'[h] Text [/h]          Hhergestellt
'[l] Text [/l]          Tiefergestellt
'[f=Arial] Text [/f]    Schriftart ndern
'[c=r,g,b] Text [/c]    Schriftfarbe ndern
'[s=size] Text [/s]     Schriftgre ndern

'Statt den eckigen Klammern knnen auch < und > verwendet werden.
'Tags mssen nicht zwingend wieder geschlossen werden. Wird ein Tag nicht
'geschlossen, so wird der gesamte Text bis zum Ende hin formatiert.
'Fehlerhafte Tags werden als normaler Text dargestellt (z.B. < /bi>).
'Fr die RGB-Werte beim Tag 'c' drfen nur Zahlen zwischen 0 und 255 gewhlt werden.
'Hhere Zahlen werden automatisch auf 255 zurckgestellt.

'Die Eigenschaft Unmarked gibt die Caption ohne Tags als String zurck.

'Das Label macht keine automatischen Zeilenumbrche. Es knnen aber trotzdem
'mehrzeilige Captions verwendet werden indem man die Umbrche selbst hinzufgt.

'Anmerkung: Ich bitte zu entschuldigen, dass die Funktionen "hherstellen" und
'           "tieferstellen" nicht hundertprozentig funktionieren, da ich nur wenig
'           Zeit hatte, diese Funktionen zu implementieren. Stellt man die Schrift
'           allerdings auf Arial erhlt man ein ziemlich gutes Ergebnis. Zum Beispiel
'           <f=Arial>H<l>2</l>O

'An dieser Stelle mchte ich mich bei KonRad Rudolph bedanken. An seinem Funktionsparser
'hab ich mir das Konzept fr den Scanner "abgeguckt" und somit hab ich das Ganze hier
'relativ schnell auf die Beine gestellt.

Private mParser         As CParser
Private mCaption        As String
Private mFormatCaption  As Boolean

Public Event Change()
Public Event Click()
Public Event DblClick()
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

'##########################################################################
'# Properties                                                             #
'##########################################################################

'-------------------------------------------------
'Property: Caption
'-------------------------------------------------
Public Property Get Caption() As String
    Caption = mCaption
End Property

Public Property Let Caption(RHS As String)
    Call Clear

    mCaption = RHS

    Call DrawCaption
    Call PropertyChanged("Caption")
End Property

'-------------------------------------------------
'Property: FormatCaption
'-------------------------------------------------
Public Property Get FormatCaption() As Boolean
    FormatCaption = mFormatCaption
End Property

Public Property Let FormatCaption(RHS As Boolean)
    mFormatCaption = RHS

    Call DrawCaption
    Call PropertyChanged("FormatCaption")
End Property

'-------------------------------------------------
'Property: Unmarked
'-------------------------------------------------
Public Property Get Unmarked() As String
    Unmarked = mParser.Unmarked
End Property

'##########################################################################
'# Event auslser                                                         #
'##########################################################################

Private Sub picOutput_Click()
    RaiseEvent Click
End Sub

Private Sub picOutput_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub picOutput_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub picOutput_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub picOutput_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

'##########################################################################
'# Subs/Functions                                                         #
'##########################################################################

Private Sub UserControl_Resize()
    Call picOutput.Move( _
        0, 0, ScaleWidth, ScaleHeight _
    )
End Sub

Private Sub UserControl_Initialize()
    Set mParser = New CParser
    Set mParser.OutputDevice = picOutput
End Sub

Private Sub UserControl_Terminate()
    Set mParser = Nothing
End Sub

Private Sub UserControl_InitProperties()
    mCaption = UserControl.Name
    mParser.MarkUp = UserControl.Name
    mFormatCaption = True

    Call DrawCaption
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    mCaption = PropBag.ReadProperty("Caption", UserControl.Name)
    mFormatCaption = PropBag.ReadProperty("FormatCaption", True)

    Call DrawCaption
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Caption", mCaption, UserControl.Name)
    Call PropBag.WriteProperty("FormatCaption", mFormatCaption, True)
End Sub
'-------------------------------------------------

'-------------------------------------------------
'Clear
'Setzt die Einstellungen fr die Output Picturebox
'zurck.
'-------------------------------------------------
Private Sub Clear()
    mParser.MarkUp = "</i></b></u></h></l></s></c></f>"
    Call mParser.Parse
    picOutput.Cls
End Sub

'-------------------------------------------------
'DrawCaption
'Zeichnet die caption formatiert oder
'unformatiert
'-------------------------------------------------
Private Sub DrawCaption()
    Call Clear

    mParser.MarkUp = mCaption

    If mFormatCaption Then _
        Call mParser.Parse _
    Else _
        picOutput.Print mParser.Unmarked

    RaiseEvent Change
End Sub
