VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cML_Label"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type tagTRACKMOUSEEVENT
    cbSize As Long
    dwFlags As Long
    hwndTrack As Long
    dwHoverTime As Long
End Type
Private Declare Function PtInRect Lib "user32.dll" (ByRef lpRect As tRECT, ByVal x As Long, ByVal y As Long) As Long

Private Const TME_CANCEL As Long = &H80000000
Private Const TME_HOVER As Long = &H1
Private Const TME_LEAVE As Long = &H2
Private Const TME_NONCLIENT As Long = &H10
Private Const TME_QUERY As Long = &H40000000

Private Declare Function TrackMouseEvent Lib "COMCTL32.DLL" Alias "_TrackMouseEvent" (lpEventTrack As tagTRACKMOUSEEVENT) As Long
   
Private Const HOVER_DEFAULT As Long = &HFFFFFFFF

Private m_clsSubclass       As cSubclass
Private m_clsBuffer         As cAlphaDIBSection
Private m_hWnd              As Long
Private m_lngBkColor1       As Long         ' Hintergrundfarbe
Private m_lngBkColor2       As Long         ' 2.Hintergrundfarbe (fr Farbverlauf)
Private m_sngGardientPos     As Single
Private m_blnMouseTrack     As Boolean

Private Type tEventItem
        lID     As Long
        tRECT   As tRECT
        bMo     As Boolean
End Type

Private m_udtEvents() As tEventItem
Private m_lngEventCount As Long

Private m_strText           As String


Implements iSubclass

Public Event NoValidWindowSize()
Public Event AfterRendering(hdc As Long, lWidth As Long, lHeight As Long)
Public Event MouseLeave(lID As Long)
Public Event MouseOver(lID As Long)
Public Event MouseHover(lID As Long)

Public Event LeftButtenDblClick(lID As Long, lX As Long, lY As Long)
Public Event LeftButtenUp(lID As Long, lX As Long, lY As Long)
Public Event LeftButtenDown(lID As Long, lX As Long, lY As Long)

Public Event MiddleButtenDblClick(lID As Long, lX As Long, lY As Long)
Public Event MiddleButtenUp(lID As Long, lX As Long, lY As Long)
Public Event MiddleButtenDown(lID As Long, lX As Long, lY As Long)

Public Event RightButtenDblClick(lID As Long, lX As Long, lY As Long)
Public Event RightButtenUp(lID As Long, lX As Long, lY As Long)
Public Event RightButtenDown(lID As Long, lX As Long, lY As Long)

' Wendepunkt fr Varbverlauf angeben
Public Property Get GardientPos() As String
    GardientPos = m_sngGardientPos
End Property
Public Property Let GardientPos(NewValue As String)
    If Not m_sngGardientPos = NewValue Then
       m_sngGardientPos = NewValue
       If m_sngGardientPos > 1 Then m_sngGardientPos = 1
       If m_sngGardientPos < 0 Then m_sngGardientPos = 0
       Render
    End If
End Property

' Text
Public Property Get Text() As String
    Text = m_strText
End Property
Public Property Let Text(NewValue As String)
    If Not m_strText = NewValue Then
       m_strText = NewValue
       Render
    End If
End Property

' 1. Hintergrundfarbe setzen
Public Property Get BackColor() As Long
    BackColor = m_lngBkColor1
End Property
Public Property Let BackColor(NewValue As Long)
    If Not m_lngBkColor1 = NewValue Then
       m_lngBkColor1 = NewValue
       Render
    End If
End Property

' 2. Hintergrundfarbe setzen
Public Property Get BackSecColor() As Long
    BackSecColor = m_lngBkColor2
End Property
Public Property Let BackSecColor(NewValue As Long)
    If Not m_lngBkColor2 = NewValue Then
       m_lngBkColor2 = NewValue
       Render
    End If
End Property


' Alles initialisieren
Public Sub Init(hwnd As Long)
    If hwnd <> 0& Then
      ' Vorbereitungen frs Subclassing
      If Not m_clsSubclass Is Nothing Then
         With m_clsSubclass
            .UnSubclass
         End With
      Else
         Set m_clsSubclass = New cSubclass
      End If
      
      ' Subclassing starten
      With m_clsSubclass
          .AddMsg WM_PAINT, MSG_AFTER
          .AddMsg WM_SIZE, MSG_BEFORE
          
          .AddMsg WM_MOUSEHOVER, MSG_BEFORE
          .AddMsg WM_MOUSELEAVE, MSG_BEFORE
          .AddMsg WM_MOUSEMOVE, MSG_BEFORE
          .AddMsg WM_LBUTTONDBLCLK, MSG_BEFORE
          .AddMsg WM_LBUTTONDOWN, MSG_BEFORE
          .AddMsg WM_LBUTTONUP, MSG_BEFORE
          .AddMsg WM_MBUTTONDBLCLK, MSG_BEFORE
          .AddMsg WM_MBUTTONDOWN, MSG_BEFORE
          .AddMsg WM_MBUTTONUP, MSG_BEFORE
          .AddMsg WM_RBUTTONDBLCLK, MSG_BEFORE
          .AddMsg WM_RBUTTONDOWN, MSG_BEFORE
          .AddMsg WM_RBUTTONUP, MSG_BEFORE
          
          .Subclass hwnd, Me
      End With
      
      m_hWnd = hwnd
      pResizeBufferImg
    End If
    
    m_sngGardientPos = 0.8
End Sub

Private Sub Class_Initialize()
    Set m_clsBuffer = New cAlphaDIBSection
    m_lngBkColor1 = &HC0C0C0
    m_lngBkColor2 = -1
End Sub

Private Sub Class_Terminate()
    If Not m_clsSubclass Is Nothing Then
       m_clsSubclass.UnSubclass
       Set m_clsSubclass = Nothing
    End If
    
    Set m_clsBuffer = Nothing
End Sub

' Maus nicht mehr auf dem Steuerelement
Private Sub pMouseLeave()
    Dim lngIndex As Long
    
    For lngIndex = 1 To m_lngEventCount
        If m_udtEvents(lngIndex).bMo Then
           m_udtEvents(lngIndex).bMo = False
           RaiseEvent MouseLeave(m_udtEvents(lngIndex).lID)
        End If
    Next
End Sub
' Maus over...
Private Function pMouseOver(lX As Long, lY As Long) As Long
    Dim lngIndex As Long
    Dim lngItem  As Long
    Dim lngIds() As Long
    Dim lngIdCount As Long
    
    ' Erst mal von den Textstcken, auf denen die Maus mal war, Events auslsen
    For lngIndex = 1 To m_lngEventCount
        If PtInRect(m_udtEvents(lngIndex).tRECT, lX, lY) = 0 Then
           If m_udtEvents(lngIndex).bMo Then
              lngIdCount = lngIdCount + 1
              ReDim Preserve lngIds(1 To lngIdCount) As Long
              lngIds(lngIdCount) = m_udtEvents(lngIndex).lID
              m_udtEvents(lngIndex).bMo = False
           End If

        Else
           If lngItem = 0 Then lngItem = lngIndex
        End If
    Next
    
    For lngIndex = 1 To lngIdCount
        RaiseEvent MouseLeave(lngIds(lngIndex))
    Next
    
    If lngItem > 0 Then
       pMouseOver = m_udtEvents(lngItem).lID
       m_udtEvents(lngItem).bMo = True
    End If
    
End Function

Private Sub iSubclass_After(lReturn As Long, ByVal hwnd As Long, ByVal uMsg As WinSubHook.eMsg, ByVal wParam As Long, ByVal lParam As Long)
    Select Case uMsg
           Case WinSubHook.WM_PAINT
                ReDraw
                
           Case WinSubHook.WM_SIZE
                pResizeBufferImg
    End Select
End Sub

Private Sub iSubclass_Before(bHandled As Boolean, lReturn As Long, hwnd As Long, uMsg As WinSubHook.eMsg, wParam As Long, lParam As Long)
    Dim lngX As Long
    Dim lngY As Long
    Dim lngID As Long
    
    Select Case uMsg
           Case WinSubHook.WM_SIZE
                pResizeBufferImg
                ReDraw
                                                           
           Case WM_MOUSEMOVE
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent MouseOver(lngID)
                
                If Not m_blnMouseTrack Then pStartMouseTracking
                
           Case WM_MOUSEHOVER
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent MouseHover(lngID)
                                                
           Case WM_MOUSELEAVE
                m_blnMouseTrack = False
                pMouseLeave
            
           Case WM_LBUTTONUP
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent LeftButtenUp(lngID, lngX, lngY)
                
           Case WM_LBUTTONDBLCLK
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent LeftButtenDblClick(lngID, lngX, lngY)
                
           Case WM_LBUTTONDOWN
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent MiddleButtenDblClick(lngID, lngX, lngY)
                
           Case WM_MBUTTONUP
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent MiddleButtenUp(lngID, lngX, lngY)
                
           Case WM_MBUTTONDBLCLK
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent MiddleButtenDblClick(lngID, lngX, lngY)
                
           Case WM_MBUTTONDOWN
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent MiddleButtenDown(lngID, lngX, lngY)
                
           Case WM_RBUTTONUP
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent RightButtenUp(lngID, lngX, lngY)
                
           Case WM_RBUTTONDBLCLK
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent RightButtenDblClick(lngID, lngX, lngY)
                
           Case WM_RBUTTONDOWN
                lngX = lParam And &HFFFF&
                lngY = (lParam \ &H10000) And &HFFFF&
                
                lngID = pMouseOver(lngX, lngY)
                If lngID > 0 Then RaiseEvent RightButtenDown(lngID, lngX, lngY)

    End Select
End Sub
Private Sub pStartMouseTracking(Optional lHoverTime As Long = HOVER_DEFAULT)
    Dim udtTrack  As tagTRACKMOUSEEVENT
    udtTrack.cbSize = Len(udtTrack)
    udtTrack.dwFlags = TME_HOVER Or TME_LEAVE
    udtTrack.dwHoverTime = lHoverTime
    udtTrack.hwndTrack = m_hWnd
       
    TrackMouseEvent udtTrack
    
    m_blnMouseTrack = True
End Sub


' ndert die Gre des Puffers (Dib)
Private Sub pResizeBufferImg()
    Dim rectTmp     As tRECT
    Dim lngWidth    As Long
    Dim lngHeight   As Long
    
    If m_hWnd = 0& Then Exit Sub
    ' Gre des untereordneten Fensters
    If GetClientRect(m_hWnd, rectTmp) = 0& Then
       ' Wenn dies scheitert, dann Gre des Hauptfensters ermitteln
       If GetWindowRect(m_hWnd, rectTmp) = 0& Then
          ' ...sollte auch das scheitern, dann Event auslsen und Funktion beenden
          RaiseEvent NoValidWindowSize
          Exit Sub
       End If
    End If
    
    ' Gre des Puffers angleichen
    With rectTmp
         lngWidth = .Right - .Left
         If lngWidth < 0 Then lngWidth = 0
         
         lngHeight = .Bottom - .Top
         If lngHeight < 0 Then lngHeight = 0
         
         m_clsBuffer.Create lngWidth, lngHeight
    End With
    Render
End Sub

' Bild erstellen
Public Sub Render()
    Dim hdc As Long

    If Not m_hWnd = 0& Then
       hdc = m_clsBuffer.hdc
       pCreateBkImg hdc         ' Hintergrund zeichnen
       
       m_lngEventCount = 0
       
       DrawText m_strText, hdc, Me
       
       RaiseEvent AfterRendering(hdc, m_clsBuffer.Width, m_clsBuffer.Height)
    End If
    
    ReDraw
End Sub


Friend Sub fAddEvent(lID As Long, lLeft As Long, lTop As Long, lRight As Long, lBottom As Long)
    m_lngEventCount = m_lngEventCount + 1
    ReDim Preserve m_udtEvents(1 To m_lngEventCount) As tEventItem
    With m_udtEvents(m_lngEventCount)
        .lID = lID
        .tRECT.Left = lLeft
        .tRECT.Top = lTop
        .tRECT.Right = lRight
        .tRECT.Bottom = lBottom
    End With
End Sub

' Hintergrundbild erstellen
Private Sub pCreateBkImg(hdc As Long)
    Dim lngCol1 As Long
    Dim lngCol2 As Long
    Dim rectTmp As tRECT
    Dim LBTmp   As LOGBRUSH
    Dim hBrush  As Long
    Dim hPen    As Long
    
    lngCol1 = m_lngBkColor1
    lngCol2 = m_lngBkColor2
    If lngCol1 = -1& Then
       lngCol1 = m_lngBkColor2
       lngCol2 = -1
       If lngCol1 = -1& Then lngCol1 = 0&
    End If
    
    If lngCol2 = -1& Then
       ' Kein Farbverlauf
       
       SetRect rectTmp, 0, 0, m_clsBuffer.Width, m_clsBuffer.Height
       
       LBTmp.lbColor = TranslateColor(lngCol1)
       LBTmp.lbHatch = 0&
       LBTmp.lbStyle = BS_SOLID
       hBrush = CreateBrushIndirect(LBTmp)
       If hBrush <> 0& Then
          FillRect hdc, rectTmp, hBrush
          DeleteObject hBrush
       End If
    Else
       ' Farbverlauf
       Dim tTV(0 To 1) As TRIVERTEX
       Dim tGR         As GRADIENT_RECT
   
       SetTriVertexColor tTV(0), TranslateColor(lngCol1)
       SetTriVertexColor tTV(1), TranslateColor(lngCol2)
   
       With tTV(0)
            .x = 0
            .y = 0
       End With
          
       With tTV(1)
            .x = m_clsBuffer.Width
            .y = m_clsBuffer.Height * m_sngGardientPos
       End With
       
       tGR.LowerRight = 1
       tGR.UpperLeft = 0
   
       GradientFill hdc, tTV(0), 2, tGR, 1, eGradientFlags.GRADIENT_FILL_RECT_V
       
       With tTV(0)
            .x = 0
            .y = m_clsBuffer.Height
       End With
       
       SetTriVertexColor tTV(0), BlendColor(lngCol1, lngCol2, 120)
       
       tGR.LowerRight = 0
       tGR.UpperLeft = 1
       GradientFill hdc, tTV(0), 2, tGR, 1, eGradientFlags.GRADIENT_FILL_RECT_V
    End If
End Sub

Private Sub ReDraw()
    Dim hdc As Long
    
    If m_hWnd <> 0& Then
       m_clsBuffer.PaintPicture GetDC(m_hWnd)
    End If
       
End Sub
