Attribute VB_Name = "mod_Declares"
Option Explicit

Public Declare Function IsRectEmpty Lib "user32.dll" (ByRef lpRect As tRECT) As Long
Public Declare Function SetRect Lib "user32.dll" (ByRef lpRect As tRECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function FillRect Lib "user32.dll" (ByVal hdc As Long, ByRef lpRect As tRECT, ByVal hBrush As Long) As Long

Public Type LOGBRUSH
    lbStyle As Long
    lbColor As Long
    lbHatch As Long
End Type
Public Declare Function CreateBrushIndirect Lib "gdi32.dll" (ByRef lpLogBrush As LOGBRUSH) As Long

Public Const PS_DOT As Long = 2
Public Const PS_SOLID As Long = 0
Public Const PS_NULL As Long = 5
Public Const BS_SOLID As Long = 0
Public Const BS_NULL As Long = 1
Public Declare Function CreatePen Lib "gdi32.dll" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long


Enum eGradientFlags
     GRADIENT_FILL_RECT_H = &H0
     GRADIENT_FILL_RECT_V = &H1
     GRADIENT_FILL_TRIANGLE = &H2
End Enum
Public Type TRIVERTEX
   X As Long
   Y As Long
   Red As Integer
   Green As Integer
   Blue As Integer
   alpha As Integer
End Type

Public Const PI = 3.14159265358979
Public Type GRADIENT_RECT
    UpperLeft As Long
    LowerRight As Long
End Type

Public Type GRADIENT_TRIANGLE
    Vertex1 As Long
    Vertex2 As Long
    Vertex3 As Long
End Type

Public Declare Function GradientFill Lib "msimg32" (ByVal hdc As Long, pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As GRADIENT_RECT, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Long
Public Declare Function GradientFillTriangle Lib "msimg32" Alias "GradientFill" (ByVal hdc As Long, pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As GRADIENT_TRIANGLE, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Long
Public Declare Function ColorHLSToRGB Lib "shlwapi.dll" (ByVal wHue As Integer, ByVal wLuminance As Integer, ByVal wSaturation As Integer) As Long
Public Declare Sub ColorRGBToHLS Lib "shlwapi.dll" (ByVal clrRGB As Long, ByRef pwHue As Integer, ByRef pwLuminance As Integer, ByRef pwSaturation As Integer)
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, ByRef lColorRef As Long) As Long

Private Type RGBQUAD
    rgbRed As Byte
    rgbGreen As Byte
    rgbBlue As Byte
    rgbReserved As Byte
End Type
Private Const CLR_INVALID As Long = &HFFFF&


' Farben mischen
Public Function BlendColor(ByVal oColorFrom As OLE_COLOR, ByVal oColorTo As OLE_COLOR, Optional ByVal alpha As Byte = 128) As Long
    Dim udtColor1   As RGBQUAD
    Dim udtColor2   As RGBQUAD
    Dim udtDest     As RGBQUAD
    
    oColorFrom = TranslateColor(oColorFrom)
    oColorTo = TranslateColor(oColorTo)
    
    CopyMemory udtColor1, oColorFrom, 4&
    CopyMemory udtColor2, oColorTo, 4&
    
    
    udtDest.rgbRed = (udtColor1.rgbRed * (alpha / 255)) + (udtColor2.rgbRed * ((255 - alpha) / 255))
    udtDest.rgbBlue = (udtColor1.rgbBlue * (alpha / 255)) + (udtColor2.rgbBlue * ((255 - alpha) / 255))
    udtDest.rgbGreen = (udtColor1.rgbGreen * (alpha / 255)) + (udtColor2.rgbGreen * ((255 - alpha) / 255))

  
    CopyMemory BlendColor, udtDest, 4&
End Function

Public Function TranslateColor(ByVal clr As OLE_COLOR, Optional hpal As Long = 0) As Long
    If OleTranslateColor(clr, hpal, TranslateColor) Then
        TranslateColor = CLR_INVALID
    End If
End Function

Public Sub SetTriVertexColor(tTV As TRIVERTEX, lColor As Long)
    Dim tRGB As RGBQUAD
    CopyMemory tRGB, lColor, 4&
    CopyMemory ByVal (VarPtr(tTV.Red) + 1), tRGB.rgbRed, 1&
    CopyMemory ByVal (VarPtr(tTV.Green) + 1), tRGB.rgbGreen, 1&
    CopyMemory ByVal (VarPtr(tTV.Blue) + 1), tRGB.rgbBlue, 1&
    CopyMemory ByVal (VarPtr(tTV.alpha) + 1), tRGB.rgbReserved, 1&
End Sub
