Attribute VB_Name = "mod_DrawText"
Option Explicit

#Const ccDrawRectAroundTLine = False          ' Rahmen um Textzeile zeichnen

Private Type RGBQUAD
    rgbRed As Byte
    rgbGreen As Byte
    rgbBlue As Byte
    rgbReserved As Byte
End Type

Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, ByRef lColorRef As Long) As Long
Private Const CLR_INVALID As Long = &HFFFF&

Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As eTextBkMode) As Long
Private Declare Function GetBkMode Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Const LOGPIXELSY As Long = 90

Private Type DRAWTEXTPARAMS
  cbSize As Long
  iTabLength As Long
  iLeftMargin As Long
  iRightMargin As Long
  uiLengthDrawn As Long
End Type

Private Declare Function DrawTextApi Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, ByRef lpRect As tRECT, ByVal wFormat As eDrawTextFlags) As Long
Private Declare Function DrawTextEx Lib "user32.dll" Alias "DrawTextExA" (ByVal hdc As Long, ByVal lpsz As String, ByVal n As Long, ByRef lpRect As tRECT, ByVal wFormat As eDrawTextFlags, ByRef lpDrawTextParams As DRAWTEXTPARAMS) As Long

Enum eTextBkMode
     TRANSPARENT = 1
     OPAQUE = 2
End Enum

Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function BeginPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function EndPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function StrokePath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function WidenPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function StrokeAndFillPath Lib "gdi32.dll" (ByVal hdc As Long) As Long


Private Type POLYTEXT
    x As Long
    y As Long
    n As Long
    lpStr As Long
    uiFlags As Long
    rcl As tRECT
    pdx As Long
End Type

Enum ePolyTextFlags
     ETO_OPAQUE = 2
     ETO_CLIPPED = 4
End Enum

Private Type TEXTMETRIC
    tmHeight As Long
    tmAscent As Long
    tmDescent As Long
    tmInternalLeading As Long
    tmExternalLeading As Long
    tmAveCharWidth As Long
    tmMaxCharWidth As Long
    tmWeight As Long
    tmOverhang As Long
    tmDigitizedAspectX As Long
    tmDigitizedAspectY As Long
    tmFirstChar As Byte
    tmLastChar As Byte
    tmDefaultChar As Byte
    tmBreakChar As Byte
    tmItalic As Byte
    tmUnderlined As Byte
    tmStruckOut As Byte
    tmPitchAndFamily As Byte
    tmCharSet As Byte
End Type

Private Type PANOSE
    ulculture As Long
    bFamilyType As Byte
    bSerifStyle As Byte
    bWeight As Byte
    bProportion As Byte
    bContrast As Byte
    bStrokeVariation As Byte
    bArmStyle As Byte
    bLetterform As Byte
    bMidline As Byte
    bXHeight As Byte
End Type

Private Type OUTLINETEXTMETRIC
    otmSize As Long
    otmTextMetrics As TEXTMETRIC
    otmFiller As Byte
    otmPanoseNumber As PANOSE
    otmfsSelection As Long
    otmfsType As Long
    otmsCharSlopeRise As Long
    otmsCharSlopeRun As Long
    otmItalicAngle As Long
    otmEMSquare As Long
    otmAscent As Long
    otmDescent As Long
    otmLineGap As Long
    otmsCapEmHeight As Long
    otmsXHeight As Long
    otmrcFontBox As tRECT
    otmMacAscent As Long
    otmMacDescent As Long
    otmMacLineGap As Long
    otmusMinimumPPEM As Long
    otmptSubscriptSize As tPOINT
    otmptSubscriptOffset As tPOINT
    otmptSuperscriptSize As tPOINT
    otmptSuperscriptOffset As tPOINT
    otmsStrikeoutSize As Long
    otmsStrikeoutPosition As Long
    otmsUnderscorePosition As Long
    otmsUnderscoreSize As Long
    otmpFamilyName As String
    otmpFaceName As String
    otmpStyleName As String
    otmpFullName As String
End Type
Enum eDrawTextFlags
    DT_BOTTOM = &H8
    DT_CALCRECT = &H400
    DT_CENTER = &H1
    DT_END_ELLIPSIS = &H8000
    DT_EDITCONTROL = &H2000
    DT_EXPANDTABS = &H40
    DT_EXTERNALLEADING = &H200
    DT_HIDEPREFIX = &H100000
    DT_INTERNAL = &H1000
    DT_LEFT = &H0
    DT_MODIFYSTRING = &H10000
    DT_NOCLIP = &H100
    DT_MULTILINE = (&H1)
    DT_NOFULLWIDTHCHARBREAK = &H80000
    DT_NOPREFIX = &H800
    DT_PATH_ELLIPSIS = &H4000
    DT_PREFIXONLY = &H200000
    DT_RIGHT = &H2
    DT_RTLREADING = &H20000
    DT_SINGLELINE = &H20
    DT_TABSTOP = &H80
    DT_TOP = &H0
    DT_VCENTER = &H4
    DT_WORD_ELLIPSIS = &H40000
    DT_WORDBREAK = &H10
End Enum

Private Declare Function GetVersion Lib "kernel32" () As Long

Private Type OSVERSIONINFO
   dwVersionInfoSize As Long
   dwMajorVersion As Long
   dwMinorVersion As Long
   dwBuildNumber As Long
   dwPlatformId As Long
   szCSDVersion(0 To 127) As Byte
End Type
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInfo As OSVERSIONINFO) As Long
Private Const VER_PLATFORM_WIN32_NT = 2

Private Enum pePolyText
             pePT_FirstRun = 0
             pePT_Linked = 1
End Enum

Private Declare Function MulDiv Lib "kernel32.dll" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function CreateFontIndirect Lib "gdi32.dll" Alias "CreateFontIndirectA" (ByRef lpLogFont As LOGFONT) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32.dll" () As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (ByRef Destination As Any, ByVal Length As Long)

Private Const LF_FACESIZE As Long = 32
Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(1 To LF_FACESIZE) As Byte
End Type

Enum eFontWeight
    FW_DONTCARE = 0
    FW_THIN = 100
    FW_EXTRALIGHT = 200
    FW_ULTRALIGHT = 200
    FW_LIGHT = 300
    FW_NORMAL = 400
    FW_REGULAR = 400
    FW_MEDIUM = 500
    FW_SEMIBOLD = 600
    FW_DEMIBOLD = 600
    FW_BOLD = 700
    FW_EXTRABOLD = 800
    FW_ULTRABOLD = 800
    FW_HEAVY = 900
    FW_BLACK = 900
End Enum

Enum eFontCharSet
    ANSI_CHARSET = 0
    ARABIC_CHARSET = 178
    BALTIC_CHARSET = 186
    CHINESEBIG5_CHARSET = 136
    DEFAULT_CHARSET = 1
    EASTEUROPE_CHARSET = 238
    GB2312_CHARSET = 134
    GREEK_CHARSET = 161
    HANGEUL_CHARSET = 129
    HANGUL_CHARSET = 129
    HEBREW_CHARSET = 177
    JOHAB_CHARSET = 130
    MAC_CHARSET = 77
    OEM_CHARSET = 255
    RUSSIAN_CHARSET = 204
    SHIFTJIS_CHARSET = 128
    SYMBOL_CHARSET = 2
    THAI_CHARSET = 222
    TURKISH_CHARSET = 162
    VIETNAMESE_CHARSET = 163
End Enum

Enum eFontOutPrecision
    OUT_CHARACTER_PRECIS = 2
    OUT_DEFAULT_PRECIS = 0
    OUT_DEVICE_PRECIS = 5
    OUT_PS_ONLY_PRECIS = 10
    OUT_RASTER_PRECIS = 6
    OUT_STRING_PRECIS = 1
    OUT_STROKE_PRECIS = 3
    OUT_TT_ONLY_PRECIS = 7
    OUT_TT_PRECIS = 4
    OUTLINE_PRECIS = 8
End Enum

Enum eFontClipPrecision
    CLIP_CHARACTER_PRECIS = 1
    CLIP_DEFAULT_PRECIS = 0
    CLIP_EMBEDDED = 128
    CLIP_LH_ANGLES = 16
    CLIP_MASK = &HF&
    CLIP_STROKE_PRECIS = 2
End Enum

Enum eFontQuality
     ANTIALIASED_QUALITY = 4
     CLEARTYPE_QUALITY = 5
     DEFAULT_QUALITY = 0
     DRAFT_QUALITY = 1
     NONANTIALIASED_QUALITY = 3
     PROOF_QUALITY = 2
End Enum

Enum eFontPitchAndFamily
     DEFAULT_PITCH = 0
     FIXED_PITCH = 1
     VARIABLE_PITCH = 2
     FF_DECORATIVE = 80
     FF_DONTCARE = 0
     FF_MODERN = 48
     FF_ROMAN = 16
     FF_SCRIPT = 64
     FF_SWISS = 32
End Enum

Enum eTextHAlign
    eha_Left = DT_LEFT
    eha_Center = DT_CENTER
    eha_Right = DT_RIGHT
End Enum

Private Declare Function GetObject Lib "gdi32.dll" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, ByRef lpObject As Any) As Long

Private Declare Function Rectangle Lib "gdi32.dll" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Const OBJ_BITMAP = 7
Private Declare Function GetCurrentObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal uObjectType As Long) As Long
Private Type tBitmap
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type


    
Private Type tFontStyle
     hFont           As Long
     sName           As String              ' Schriftart
     eWeight         As eFontWeight
     eCharSet        As eFontCharSet
     eOutPrecision   As eFontOutPrecision
     eClipPrecision  As eFontClipPrecision
     eQuality        As eFontQuality
     ePitchAndFamily As eFontPitchAndFamily
     lWidth          As Long                ' Schriftbreite
     bItalic         As Boolean             ' Text kursiv darstellen
     bStrikeOut      As Boolean             ' Text durchgestrichen darstellen
     bUnderline      As Boolean             ' Text unterstreichen
     sAngle          As Single              ' Winkel in dem der Text dargestellt werden soll
     eHAlign         As eTextHAlign         ' Horizontale Textausrichtung
     
     lTextColor      As Long
     lTextBKCol      As Long                ' Hintergrundfarbe
     
     lFontSize       As Long                ' Schriftgre
     
     bSuperior       As Boolean             ' Text hochstellen
     bInferior       As Boolean             ' Text tiefstellen
     
     lLastX          As Long                ' Punkt am Ende der letzten dargestellten Zeile
     lLastY          As Long                ' -"-
     
     lLineHeight     As Long                ' Hhe der letzten zeile
     lPrevLineBottom As Long                ' Untere Kante der vorherigen Zeile
     
     tDrawingRect    As tRECT               ' Feld, in dem der Text dargestellt wird
     tDistance2Border As tRECT              ' Textabstand zum Rand
     
     lLineDist       As Long                ' zus. Zeilenabstand
     
     lEventID        As Long
End Type

Private m_udtActiveSettings     As tFontStyle
Private m_udtLastSettings()     As tFontStyle
Private m_lngSettCount          As Long

' Aufrumen
Private Sub pClearUp()
    Dim lngIndex As Long
    
    For lngIndex = 1 To m_lngSettCount
        With m_udtLastSettings(lngIndex)
             If .hFont <> 0 Then DeleteObject .hFont
             .hFont = 0&
        End With
    Next
    Erase m_udtLastSettings
    m_lngSettCount = 0
    
    With m_udtActiveSettings
        .lFontSize = 12
        .sAngle = 0
        .sName = "MS Sans Serif"
        .bInferior = False
        .bItalic = False
        .bStrikeOut = False
        .bSuperior = False
        .bUnderline = False
        .eCharSet = DEFAULT_CHARSET
        .eClipPrecision = CLIP_DEFAULT_PRECIS
        .eHAlign = eha_Left
        .eOutPrecision = OUT_DEFAULT_PRECIS
        .ePitchAndFamily = DEFAULT_PITCH
        .eQuality = ANTIALIASED_QUALITY
        .eWeight = FW_NORMAL
        .lLastX = 0
        .lLastY = 0
        .lPrevLineBottom = 0
        .lLineDist = 0
        .lLineHeight = 0
        .lTextBKCol = 0&
        .lTextBKCol = -1
        .lWidth = 0
        With .tDistance2Border
             .Bottom = 0
             .Left = 0
             .Right = 0
             .Top = 0
        End With
    End With
End Sub

' Settings sichern
Private Sub pSaveSettings()
    m_lngSettCount = m_lngSettCount + 1
    ReDim Preserve m_udtLastSettings(1 To m_lngSettCount) As tFontStyle
    With m_udtLastSettings(m_lngSettCount)
         .sAngle = m_udtActiveSettings.sAngle
         .sName = m_udtActiveSettings.sName
         
         .eCharSet = m_udtActiveSettings.eCharSet
         .eClipPrecision = m_udtActiveSettings.eClipPrecision
         .eHAlign = m_udtActiveSettings.eHAlign
         .eOutPrecision = m_udtActiveSettings.ePitchAndFamily
         .eQuality = m_udtActiveSettings.eQuality
         .eWeight = m_udtActiveSettings.eWeight
         
         .hFont = m_udtActiveSettings.hFont
         
         .lFontSize = m_udtActiveSettings.lFontSize
         .lLineDist = m_udtActiveSettings.lLineDist
         .lLineHeight = m_udtActiveSettings.lLineHeight
         .lTextBKCol = m_udtActiveSettings.lTextBKCol
         .lTextColor = m_udtActiveSettings.lTextColor
         .lWidth = m_udtActiveSettings.lWidth
         .lLastX = m_udtActiveSettings.lLastX
         .lLastY = m_udtActiveSettings.lLastY
         .lLineHeight = m_udtActiveSettings.lLineHeight
         
         LSet .tDistance2Border = m_udtActiveSettings.tDistance2Border
         LSet .tDrawingRect = m_udtActiveSettings.tDrawingRect
         
         .bInferior = m_udtActiveSettings.bInferior
         .bItalic = m_udtActiveSettings.bItalic
         .bStrikeOut = m_udtActiveSettings.bStrikeOut
         .bSuperior = m_udtActiveSettings.bSuperior
         .bUnderline = m_udtActiveSettings.bUnderline
         .lEventID = m_udtActiveSettings.lEventID
    End With
End Sub

' Einstellungen wieder herstellen
Private Sub pRestoreSettings()
    If m_lngSettCount < 1 Then Exit Sub ' keine Sicherungen vorhanden
    
    With m_udtActiveSettings
         .sAngle = m_udtLastSettings(m_lngSettCount).sAngle
         .sName = m_udtLastSettings(m_lngSettCount).sName
         
         .eCharSet = m_udtLastSettings(m_lngSettCount).eCharSet
         .eClipPrecision = m_udtLastSettings(m_lngSettCount).eClipPrecision
         .eHAlign = m_udtLastSettings(m_lngSettCount).eHAlign
         .eOutPrecision = m_udtLastSettings(m_lngSettCount).ePitchAndFamily
         .eQuality = m_udtLastSettings(m_lngSettCount).eQuality
         .eWeight = m_udtLastSettings(m_lngSettCount).eWeight
         
         .hFont = m_udtLastSettings(m_lngSettCount).hFont
         
         .lFontSize = m_udtLastSettings(m_lngSettCount).lFontSize
         .lLineDist = m_udtLastSettings(m_lngSettCount).lLineDist
         .lLineHeight = m_udtLastSettings(m_lngSettCount).lLineHeight
         .lTextBKCol = m_udtLastSettings(m_lngSettCount).lTextBKCol
         .lTextColor = m_udtLastSettings(m_lngSettCount).lTextColor
         .lWidth = m_udtLastSettings(m_lngSettCount).lWidth
         
         LSet .tDistance2Border = m_udtLastSettings(m_lngSettCount).tDistance2Border
         LSet .tDrawingRect = m_udtLastSettings(m_lngSettCount).tDrawingRect
         
         .bInferior = m_udtLastSettings(m_lngSettCount).bInferior
         .bItalic = m_udtLastSettings(m_lngSettCount).bItalic
         .bStrikeOut = m_udtLastSettings(m_lngSettCount).bStrikeOut
         .bSuperior = m_udtLastSettings(m_lngSettCount).bSuperior
         .bUnderline = m_udtLastSettings(m_lngSettCount).bUnderline
         
         .lEventID = m_udtLastSettings(m_lngSettCount).lEventID
    End With
    m_lngSettCount = m_lngSettCount - 1
    If m_lngSettCount < 1 Then
       m_lngSettCount = 0
    End If
End Sub

' Text ausgeben
Public Sub DrawText(sText As String, hdc As Long, cOwner As cML_Label)
    Dim hBmp    As Long
    Dim BMP     As tBitmap
    
    ' Bitmap von Puffer ermitteln
    hBmp = GetCurrentObject(hdc, OBJ_BITMAP)
    If hBmp <> 0& Then
       ' Info von Pufferbitmap ermitteln
       GetObject hBmp, Len(BMP), BMP
       
       ' Gre bergeben
       With m_udtActiveSettings
            With .tDrawingRect
                 .Left = 0
                 .Top = 0
                 .Right = BMP.bmWidth
                 .Bottom = BMP.bmHeight
            End With
            
            ' Startposition festlegen
            .lLastX = 0
            .lLastY = 0
            
            ' Standartwerte
            .lTextColor = &H0&
            .lTextBKCol = -1
       End With
    
       pAnalyseText sText, hdc, cOwner
       
       
    End If
End Sub

' Text extrahieren
Public Function pExtractText(ByVal src As String) As String
       Dim lngStart As Long
       Dim lngEnd As Long
       
       lngStart = InStr(src, "'")
       If lngStart > 0 Then
          lngEnd = lngStart + 1
          Do
             lngEnd = InStr(lngEnd, src, "'")
             If lngEnd = 0 Then Exit Do
             If Not Mid$(src, lngEnd + 1, 1) = "'" Then Exit Do Else lngEnd = lngEnd + 2
          Loop
          
          pExtractText = Replace(Mid$(Left$(src, lngEnd - 1), lngStart + 1), "''", "'")
       End If
End Function

' Farbwert extrahieren
Private Function pExtractColor(src As String) As Long
    On Local Error Resume Next
    
    Dim udtRgb As RGBQUAD
    
    Select Case Left$(src, 2)
        Case "0x", "&H"
        Case Else
             Exit Function
    End Select
    
    With udtRgb
        .rgbRed = Val("&H" & Left$(Right$(src, 2), 2))
        .rgbGreen = Val("&H" & Left$(Right$(src, 4), 2))
        .rgbBlue = Val("&H" & Left$(Right$(src, 6), 2))
    End With
    
    CopyMemory pExtractColor, udtRgb, 4&
End Function

Private Sub pAnalyseText(sText As String, hdc As Long, cOwner As cML_Label)
       Dim lngIndex As Long
       Dim lngStart As Long     ' Start des Textsegments
       Dim lngEnd   As Long     ' Ende des Textsegments
       Dim strPrevText As String
       Dim strKW       As String
       Dim strOpt      As String
       Dim strTmp      As String
       Dim lngPos      As Long
       Dim lngRet      As Long
       
       pClearUp
     
       lngStart = 0
       lngIndex = 1
       Do Until lngIndex > Len(sText)
           ' Taganfang filtern
           If Mid$(sText, lngIndex, 2) = "<!" Then
              ' Text vor dem Tag sichern
              lngEnd = lngIndex - 1
              strPrevText = Mid$(Left$(sText, lngEnd), lngStart + 1)
              
              ' Tagende suchen
              lngPos = InStr(lngIndex + 1, sText, ">")
              If lngPos <= 0 Then Exit Sub   ' Tag kann nicht geschlossen werden. Abbruch
              
              ' Taginhalt extrahieren
              strTmp = Mid$(Left$(sText, lngPos - 1), lngIndex + 2)
              
              lngStart = lngPos
              lngIndex = lngStart
              
              
              ' Optionen des Tags extrahieeren
              lngPos = InStr(strTmp, "=")
              If lngPos > 0 Then
                 ' hat Optionen
                 strOpt = Trim$(Mid$(strTmp, lngPos + 1))
                 strKW = Trim$(Left$(strTmp, lngPos - 1))
                 
                 If Left$(strOpt, 1) = "'" Then strOpt = pExtractText(strOpt)
                 
              Else
                 ' hat keine
                 strOpt = ""
                 strKW = Trim$(strTmp)
              End If
              
              Select Case strKW
                     Case "!"       ' Einstellungen wiederherstellen
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pRestoreSettings
                          
                     Case "TC"    ' Textvordergrundfarbe
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.lTextColor = pExtractColor(strOpt)
                          
                     Case "BC"    ' TextHintergrundfarbe
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          
                          If strOpt = "No" Then
                             m_udtActiveSettings.lTextBKCol = -1
                          Else
                             m_udtActiveSettings.lTextBKCol = pExtractColor(strOpt)
                          End If
                          
                     Case "SP"  ' Text hochgestellt
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.bSuperior = True
                        
                     Case "IF"  ' Text tiefgestellt
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.bInferior = True
                          
                     Case "RestX"   ' Letztes Textabschnittsende wieder herstellen
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          
                          If UBound(m_udtLastSettings) > m_lngSettCount Then
                            m_udtActiveSettings.lLastX = m_udtLastSettings(m_lngSettCount + 1).lLastX
                          End If
                          
                     Case "FS"      ' Schriftgre
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.lFontSize = Val(Left$(strOpt, 3))
                          
                     Case "X"      ' Verschiebung in X
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          
                          Select Case Left$(strOpt, 1)
                                 Case "+": m_udtActiveSettings.lLastX = m_udtActiveSettings.lLastX + Val(Mid$(strOpt, 2))
                                 Case "-": m_udtActiveSettings.lLastX = m_udtActiveSettings.lLastX + Val(Mid$(strOpt, 2))
                                 Case "*": m_udtActiveSettings.lLastX = m_udtActiveSettings.lLastX + Val(Mid$(strOpt, 2))
                                 Case "/"
                                      If Val(Mid$(strOpt, 2)) <> 0 Then m_udtActiveSettings.lLastX = m_udtActiveSettings.lLastX + Val(Mid$(strOpt, 2))
                                 Case Else: m_udtActiveSettings.lLastX = Val(strOpt)
                          End Select
                        
                    Case "Y"      ' Verschiebung in Y
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          
                          Select Case Left$(strOpt, 1)
                                 Case "+": m_udtActiveSettings.lLastY = m_udtActiveSettings.lLastY + Val(Mid$(strOpt, 2))
                                 Case "-": m_udtActiveSettings.lLastY = m_udtActiveSettings.lLastY + Val(Mid$(strOpt, 2))
                                 Case "*": m_udtActiveSettings.lLastY = m_udtActiveSettings.lLastY + Val(Mid$(strOpt, 2))
                                 Case "/"
                                      If Val(Mid$(strOpt, 2)) <> 0 Then m_udtActiveSettings.lLastY = m_udtActiveSettings.lLastY + Val(Mid$(strOpt, 2))
                                 Case Else: m_udtActiveSettings.lLastY = Val(strOpt)
                          End Select
                          
                    Case "Angle"    ' Winkel
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          If IsNumeric(strOpt) Then
                             m_udtActiveSettings.sAngle = CSng(strOpt)
                          End If
                          
                    Case "Font"    ' Schriftart ndern
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.sName = strOpt
                          
                    Case "B"    ' Bold
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.eWeight = FW_BOLD
                    
                    Case "I"   ' Kursiv
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.bItalic = True
                          
                    Case "U"   ' Unterstrichen
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.bUnderline = True
                          
                    Case "SO"   ' Durchgestrichen
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.bStrikeOut = True
                          
                    Case "EV"   ' Mouseevents auslsen
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.lEventID = Val(strOpt)
                          
                          
                    Case "DTB.Left", "DTB.Top", "DTB.Right", "DTB.Bottom"   ' Abstand zum Rand festlegen
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          Select Case Mid$(strKW, 5)
                                 Case "Left": m_udtActiveSettings.tDistance2Border.Left = Val(strOpt)
                                 Case "Top": m_udtActiveSettings.tDistance2Border.Top = Val(strOpt)
                                 Case "Right": m_udtActiveSettings.tDistance2Border.Right = Val(strOpt)
                                 Case "Bottom": m_udtActiveSettings.tDistance2Border.Bottom = Val(strOpt)
                          End Select
                          
                    Case "AL", "AC", "AR"   ' Horizontale Ausrichtung
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          If strKW = "AL" Then
                             m_udtActiveSettings.eHAlign = eha_Left
                          ElseIf strKW = "AC" Then
                             m_udtActiveSettings.eHAlign = eha_Center
                          Else
                             m_udtActiveSettings.eHAlign = eha_Right
                          End If
                          
                     Case "Q"
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          Select Case strOpt
                                 Case "ANTIALIASED_QUALITY": m_udtActiveSettings.eQuality = ANTIALIASED_QUALITY
                                 Case "CLEARTYPE_QUALITY":   m_udtActiveSettings.eQuality = CLEARTYPE_QUALITY
                                 Case "DEFAULT_QUALITY":     m_udtActiveSettings.eQuality = DEFAULT_QUALITY
                                 Case "DRAFT_QUALITY":       m_udtActiveSettings.eQuality = DRAFT_QUALITY
                                 Case "NONANTIALIASED_QUALITY":  m_udtActiveSettings.eQuality = NONANTIALIASED_QUALITY
                                 Case "PROOF_QUALITY":       m_udtActiveSettings.eQuality = PROOF_QUALITY
                          End Select
                          
                     Case "Weight"
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          Select Case strOpt
                                 Case "BLACK":        m_udtActiveSettings.eWeight = FW_BLACK
                                 Case "BOLD":         m_udtActiveSettings.eWeight = FW_BOLD
                                 Case "DEMIBOLD":     m_udtActiveSettings.eWeight = FW_DEMIBOLD
                                 Case "DONTCARE":     m_udtActiveSettings.eWeight = FW_DONTCARE
                                 Case "EXTRABOLD":    m_udtActiveSettings.eWeight = FW_EXTRABOLD
                                 Case "EXTRALIGHT":   m_udtActiveSettings.eWeight = FW_EXTRALIGHT
                                 Case "HEAVY":        m_udtActiveSettings.eWeight = FW_HEAVY
                                 Case "LIGHT":        m_udtActiveSettings.eWeight = FW_LIGHT
                                 Case "MEDIUM":       m_udtActiveSettings.eWeight = FW_MEDIUM
                                 Case "NORMAL":       m_udtActiveSettings.eWeight = FW_NORMAL
                                 Case "REGULAR":      m_udtActiveSettings.eWeight = FW_REGULAR
                                 Case "SEMIBOLD":     m_udtActiveSettings.eWeight = FW_SEMIBOLD
                                 Case "THIN":         m_udtActiveSettings.eWeight = FW_THIN
                                 Case "ULTRABOLD":    m_udtActiveSettings.eWeight = FW_ULTRABOLD
                                 Case "ULTRALIGHT":   m_udtActiveSettings.eWeight = FW_ULTRALIGHT
                            End Select
                            
                     Case "CharSet"
                           lngRet = pDrawText(strPrevText, hdc, cOwner)
                           strPrevText = ""
                           pSaveSettings
                           Select Case strOpt
                                  Case "ANSI":      m_udtActiveSettings.eCharSet = ANSI_CHARSET
                                  Case "ARABIC":    m_udtActiveSettings.eCharSet = ARABIC_CHARSET
                                  Case "BALTIC": m_udtActiveSettings.eCharSet = BALTIC_CHARSET
                                  Case "CHINESEBIG5": m_udtActiveSettings.eCharSet = CHINESEBIG5_CHARSET
                                  Case "DEFAULT":   m_udtActiveSettings.eCharSet = DEFAULT_CHARSET
                                  Case "ESTEUROPE": m_udtActiveSettings.eCharSet = EASTEUROPE_CHARSET
                                  Case "GB2312":    m_udtActiveSettings.eCharSet = GB2312_CHARSET
                                  Case "GREEK":     m_udtActiveSettings.eCharSet = GREEK_CHARSET
                                  Case "HANGEUL":   m_udtActiveSettings.eCharSet = HANGEUL_CHARSET
                                  Case "HEBREW":    m_udtActiveSettings.eCharSet = HEBREW_CHARSET
                                  Case "JOHAB":     m_udtActiveSettings.eCharSet = JOHAB_CHARSET
                                  Case "MAC":       m_udtActiveSettings.eCharSet = MAC_CHARSET
                                  Case "OEM":       m_udtActiveSettings.eCharSet = OEM_CHARSET
                                  Case "RUSSIAN":   m_udtActiveSettings.eCharSet = RUSSIAN_CHARSET
                                  Case "SHIFTJIS":  m_udtActiveSettings.eCharSet = SHIFTJIS_CHARSET
                                  Case "SYMBOL":    m_udtActiveSettings.eCharSet = SYMBOL_CHARSET
                                  Case "THAI":      m_udtActiveSettings.eCharSet = THAI_CHARSET
                                  Case "TURKISH":   m_udtActiveSettings.eCharSet = TURKISH_CHARSET
                                  Case "VIETNAMESE": m_udtActiveSettings.eCharSet = VIETNAMESE_CHARSET
                           End Select
                            
                      Case "Width"
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.lWidth = Val(strOpt)
                          
                      Case "LD"
                          lngRet = pDrawText(strPrevText, hdc, cOwner)
                          strPrevText = ""
                          pSaveSettings
                          m_udtActiveSettings.lLineDist = Val(strOpt)
              End Select
              
              
           End If
           lngIndex = lngIndex + 1
           
           If lngRet = -1 Then Exit Sub
       Loop
       If lngStart < lngIndex Then
          strPrevText = Mid$(Left$(sText, lngIndex), lngStart + 1)
          If strPrevText <> "" Then pDrawText strPrevText, hdc, cOwner
       End If
       
End Sub

Public Sub pSetFont(hdc As Long)
    Dim LF  As LOGFONT
    Dim lngIndex As Long
    Dim strName  As String
    
    With m_udtActiveSettings
         If .hFont <> 0& Then DeleteObject .hFont
         
         If .lFontSize < 1 Then .lFontSize = 1
         If .bSuperior Or .bInferior Then .lFontSize = .lFontSize * 0.5
         LF.lfHeight = -MulDiv(.lFontSize, GetDeviceCaps(hdc, LOGPIXELSY), 72)
         
         
         LF.lfCharSet = .eCharSet
         LF.lfWeight = .eWeight
         LF.lfItalic = Abs(CLng(.bItalic))
         LF.lfUnderline = Abs(CLng(.bUnderline))
         LF.lfStrikeOut = Abs(CLng(.bStrikeOut))
        
         strName = Left$(.sName, LF_FACESIZE)
         ZeroMemory LF.lfFaceName(1), Len(strName)
        
         If strName = "" Then strName = "Arial"
         For lngIndex = 1 To Len(strName)
            LF.lfFaceName(lngIndex) = Asc(Mid$(strName, lngIndex, 1))
         Next
        
         LF.lfOutPrecision = .eOutPrecision
         LF.lfClipPrecision = .eClipPrecision
         LF.lfQuality = .eQuality
         LF.lfPitchAndFamily = .ePitchAndFamily
         LF.lfWidth = .lWidth
        
         If (.sAngle <> 0) Then
            LF.lfCharSet = ANSI_CHARSET
            LF.lfOutPrecision = OUT_TT_ONLY_PRECIS
         End If
         
         LF.lfEscapement = .sAngle * 10
         LF.lfOrientation = LF.lfEscapement
         
         .hFont = CreateFontIndirect(LF)
    End With

    
End Sub

Private Function pDrawText(sText As String, hdc As Long, cOwner As cML_Label) As Long
'*
    If sText = "" Then Exit Function
    Dim strTmp As String
    Dim rectTmp As tRECT
    Dim udtDTP As DRAWTEXTPARAMS

    Dim lngWidth  As Long
    Dim lngLeft   As Long
    Dim lngTmpY   As Long
    Dim lngLineW  As Long
    Dim lngLineH  As Long
    
    Dim hOldB     As Long
    Dim hOldP     As Long
    
    Dim hPen1     As Long
    Dim hBrush1   As Long
    Dim LB        As LOGBRUSH
    
    Dim hPen2     As Long
    Dim hBrush2   As Long
    
    Dim hOldF     As Long
    
    Dim blnIfTmp    As Boolean
    Dim blnSpTmp    As Boolean
    Dim lngIndex    As Long
    
    #If ccDrawRectAroundTLine Then
        '-----------------------------------------------------
        ' Dieser Teil ist nur fr Testzwecke gedacht
        ' Aussehen der Zeilenumrahmung
        LB.lbStyle = BS_NULL
        LB.lbColor = &H0&
        hPen1 = CreatePen(PS_DOT, 1, &H0)
        hBrush1 = CreateBrushIndirect(LB)
    
        ' Aussehen der Eckenmarkierung
        LB.lbStyle = BS_SOLID
        LB.lbColor = &HFFFF&
        hPen2 = CreatePen(PS_SOLID, 1, &HFFA0A0)
        hBrush2 = CreateBrushIndirect(LB)
        '-----------------------------------------------------
    #End If
    
    strTmp = sText
    With m_udtActiveSettings
        If (.bInferior) Or (.bSuperior) Then
           lngIndex = m_lngSettCount
           lngLineH = m_udtLastSettings(lngIndex).lLineHeight
        End If
           
        pSetFont hdc
        If .hFont <> 0 Then
           hOldF = SelectObject(hdc, .hFont)
        End If
        
        ' Textfarbe setzen
        SetTextColor hdc, TranslateColor(.lTextColor)
        
        ' Texthintergrudfarbe setzten
        If .lTextBKCol <> -1 Then
           SetBkMode hdc, OPAQUE
           SetBkColor hdc, TranslateColor(.lTextBKCol)
        Else
           SetBkMode hdc, TRANSPARENT
        End If
        ' Hhe der Zeile ermitteln
    
        ' min. X-Position prfen
        If .lLastX < (.tDistance2Border.Left + .tDrawingRect.Left) Then
           .lLastX = .tDistance2Border.Left + .tDrawingRect.Left
        End If
        
        ' min. Y-Position prfen
        If .lLastY < (.tDistance2Border.Top + .tDrawingRect.Top) Then
           .lLastY = .tDistance2Border.Top + .tDrawingRect.Top
        End If
        
        
        If Not .eHAlign = eha_Right Then
           SetRect rectTmp, .lLastX, .lLastY, .tDrawingRect.Right - .tDistance2Border.Right, .tDrawingRect.Bottom - .tDistance2Border.Bottom
        Else
           SetRect rectTmp, .tDrawingRect.Left + .tDistance2Border.Left, .lLastY, .lLastX, .tDrawingRect.Bottom - .tDistance2Border.Bottom
        End If
    
        DrawTextApi hdc, strTmp, -1, rectTmp, DT_NOPREFIX Or DT_CALCRECT Or DT_SINGLELINE
        .lLineHeight = rectTmp.Bottom - rectTmp.Top
        
    End With
    
    ' Den Textabschnitt durchgehen bis dieser komplett dargestellt wurde
    Do
       udtDTP.cbSize = Len(udtDTP)
       
       ' max. sichtbare Zeichen ermitteln
       With m_udtActiveSettings
            
            If (.eHAlign = eha_Right) And (.lLastX <> 0) Then
                rectTmp.Right = .lLastX
            Else
                rectTmp.Right = .tDrawingRect.Right - .tDistance2Border.Right
            End If
            
            lngTmpY = rectTmp.Top
            
            If .bSuperior Then
                rectTmp.Top = rectTmp.Top - 2
            ElseIf .bInferior Then
                rectTmp.Top = rectTmp.Top + lngLineH + 2 - .lLineHeight
                rectTmp.Bottom = rectTmp.Top + .lLineHeight
            End If
               
            If .sAngle <> 0 Then
               DrawTextEx hdc, strTmp, -1, rectTmp, .eHAlign Or DT_NOPREFIX Or DT_EXPANDTABS Or DT_NOCLIP, udtDTP
            Else
               DrawTextEx hdc, strTmp, -1, rectTmp, .eHAlign Or DT_NOPREFIX Or DT_WORDBREAK Or DT_EDITCONTROL Or DT_EXPANDTABS, udtDTP
            End If
            
            rectTmp.Top = lngTmpY
       End With
    
       
       ' Gre der Textzeile in Pixel ermitteln
       DrawTextApi hdc, Left$(strTmp, udtDTP.uiLengthDrawn), -1, rectTmp, DT_NOPREFIX Or DT_EDITCONTROL Or DT_EXPANDTABS Or DT_CALCRECT
       With rectTmp
            hOldP = SelectObject(hdc, hPen1)
            hOldB = SelectObject(hdc, hBrush1)

            lngWidth = .Right - .Left
         
            If m_udtActiveSettings.eHAlign = eha_Left Then
               lngLeft = .Left - 1
            ElseIf m_udtActiveSettings.eHAlign = eha_Center Then
               With m_udtActiveSettings
                    lngLineW = .tDrawingRect.Right - .tDrawingRect.Left
                    lngLineW = lngLineW - (.tDistance2Border.Left + .tDistance2Border.Right)
            
                    lngLeft = (lngLineW * 0.5) - (lngWidth * 0.5) + .tDistance2Border.Left + .tDrawingRect.Left
               End With
            Else
               With m_udtActiveSettings
                    If .lLastX <> 0 Then
                       lngLeft = .lLastX - lngWidth
                    Else
                       lngLeft = .tDrawingRect.Right - .tDistance2Border.Right - 1 - lngWidth
                    End If
               End With
            End If
            
            ' Testen, ob ein MouseEvent gewnscht ist
            If m_udtActiveSettings.lEventID <> 0& Then
               cOwner.fAddEvent m_udtActiveSettings.lEventID, lngLeft, .Top, lngLeft + lngWidth, .Bottom
            End If
            
            '------------------------------------------------------------------------------
            ' Textzeile und deren Ecken hervorheben
            #If ccDrawRectAroundTLine Then
                Rectangle hdc, lngLeft, .Top - 1, lngLeft + lngWidth, .Bottom + 1

                SelectObject hdc, hOldB
                SelectObject hdc, hOldP
            
                hOldP = SelectObject(hdc, hPen2)
                hOldB = SelectObject(hdc, hBrush2)
            
                Rectangle hdc, lngLeft - 2, .Top - 2, lngLeft + 2, .Top + 2
                Rectangle hdc, lngLeft - 2, .Bottom - 2, lngLeft + 2, .Bottom + 2
                Rectangle hdc, lngLeft + lngWidth - 2, .Top - 2, lngLeft + lngWidth + 2, .Top + 2
                Rectangle hdc, lngLeft + lngWidth - 2, .Bottom - 2, lngLeft + lngWidth + 2, .Bottom + 2
           
                SelectObject hdc, hOldB
                SelectObject hdc, hOldP
            #End If
            '------------------------------------------------------------------------------
       End With
       
       ' Textzeile um den angezeigten Bereich krtzen
       strTmp = Mid$(strTmp, udtDTP.uiLengthDrawn + 1)
       
       ' Neue Zeilenposition berechnen
       With m_udtActiveSettings
            rectTmp.Left = .tDrawingRect.Left + .tDistance2Border.Left
   
            If (.bSuperior Or .bInferior) Then
                rectTmp.Top = rectTmp.Top + lngLineH + .lLineDist
                rectTmp.Bottom = rectTmp.Top + lngLineH

            Else
                rectTmp.Top = rectTmp.Bottom + .lLineDist
                rectTmp.Bottom = rectTmp.Top + .lLineHeight
            End If
       
            ' Wenn auserhalb des sichtbaren Breichs, dann Schleife verlassen
            If rectTmp.Bottom > (.tDrawingRect.Bottom - .tDistance2Border.Bottom) Then
               pDrawText = -1
               Exit Do
            End If
            
            .lLastX = 0
       End With
    Loop Until strTmp = ""
    
    ' Anschlussstelle fr nchstes Textsegment ermitteln
    With m_udtActiveSettings
        If .eHAlign = eha_Right Then
           .lLastX = rectTmp.Right - lngWidth
        Else
           .lLastX = rectTmp.Right + 1
        End If
        
        If (.bSuperior) Then
            .lLastY = rectTmp.Top - lngLineH - .lLineHeight
        ElseIf (.bInferior) Then
            .lLastY = rectTmp.Top - lngLineH
        Else
           .lLastY = rectTmp.Top - .lLineHeight
        End If
        
        If .hFont <> 0 Then
           ' evtl. act. Fontobjekt lschen (zur Sicherheit)
           SelectObject hdc, hOldF
           DeleteObject .hFont
           .hFont = 0&
        End If
    End With
    
    #If ccDrawRectAroundTLine Then
        ' Schn wieder aufrumen
        DeleteObject hPen1
        DeleteObject hBrush1
    
        DeleteObject hPen2
        DeleteObject hBrush2
    #End If
End Function

