VERSION 5.00
Begin VB.UserControl MLabel 
   ClientHeight    =   5340
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4500
   ScaleHeight     =   5340
   ScaleWidth      =   4500
End
Attribute VB_Name = "MLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private Declare Function SetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function DrawEdge Lib "user32.dll" (ByVal hdc As Long, ByRef qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Const BDR_INNER As Long = &HC
Private Const BDR_OUTER As Long = &H3
Private Const BDR_RAISED As Long = &H5
Private Const BDR_RAISEDINNER As Long = &H4
Private Const BDR_RAISEDOUTER As Long = &H1
Private Const BDR_SUNKEN As Long = &HA
Private Const BDR_SUNKENINNER As Long = &H8
Private Const BDR_SUNKENOUTER As Long = &H2

Private Const EDGE_BUMP As Long = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED As Long = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_RAISED As Long = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN As Long = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)

Private Const BF_BOTTOM As Long = &H8
Private Const BF_LEFT As Long = &H1
Private Const BF_RIGHT As Long = &H4
Private Const BF_TOP As Long = &H2
Private Const BF_RECT As Long = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)

Private WithEvents LabelClass   As cML_Label
Attribute LabelClass.VB_VarHelpID = -1

Enum eBorderStyle
     ebs_None = 0
     ebs_Solid = -1
     ebs_Bump = EDGE_BUMP
     ebs_Etched = EDGE_ETCHED
     ebs_Raised = EDGE_RAISED
     ebs_Sunken = EDGE_SUNKEN
End Enum

Private m_enmBorderStyle     As eBorderStyle


Public Event MouseLeave(lID As Long)
Public Event MouseOver(lID As Long)
Public Event MouseHover(lID As Long)

Public Event LeftButtenDblClick(lID As Long, lX As Long, lY As Long)
Public Event LeftButtenUp(lID As Long, lX As Long, lY As Long)
Public Event LeftButtenDown(lID As Long, lX As Long, lY As Long)

Public Event MiddleButtenDblClick(lID As Long, lX As Long, lY As Long)
Public Event MiddleButtenUp(lID As Long, lX As Long, lY As Long)
Public Event MiddleButtenDown(lID As Long, lX As Long, lY As Long)

Public Event RightButtenDblClick(lID As Long, lX As Long, lY As Long)
Public Event RightButtenUp(lID As Long, lX As Long, lY As Long)
Public Event RightButtenDown(lID As Long, lX As Long, lY As Long)

' Text (ohne Steuerzeichen!)
Public Property Get Text() As String
    Dim strTmp  As String
    Dim lngPos   As Long
    Dim lngEnd   As Long
    
    strTmp = LabelClass.Text
    strTmp = Replace(strTmp, "<!!>", "")
    Do
        lngPos = InStr(strTmp, "<!")
        If lngPos = 0 Then Exit Do
        
        lngEnd = lngPos - 1
        lngPos = InStr(lngPos + 1, strTmp, ">")
        If lngPos = 0 Then Exit Do
        
        strTmp = Left$(strTmp, lngEnd) & Mid$(strTmp, lngPos + 1)
    Loop
    Text = strTmp
End Property
Public Property Let Text(NewValue As String)
    Source = NewValue
End Property

' Text (Source)
Public Property Get Source() As String
    Source = LabelClass.Text
End Property
Public Property Let Source(NewValue As String)
    LabelClass.Text = NewValue
End Property

' Objektrahmen
Public Property Get BorerStyle() As eBorderStyle
    BorderStyle = m_enmBorderStyle
End Property
Public Property Let BorerStyle(NewValue As eBorderStyle)
    If m_enmBorderStyle = NewValue Then Exit Property
    m_enmBorderStyle = NewValue
    LabelClass.Render
    PropertyChanged
End Property


' Hintergrundfarbe
Public Property Get BackColor() As OLE_COLOR
    BackColor = LabelClass.BackColor
End Property
Public Property Let BackColor(NewValue As OLE_COLOR)
    LabelClass.BackColor = NewValue
    PropertyChanged
End Property

' 2. Hintergrundfarbe
Public Property Get BackColor2() As OLE_COLOR
    BackColor2 = LabelClass.BackSecColor
End Property
Public Property Let BackColor2(NewValue As OLE_COLOR)
    LabelClass.BackSecColor = NewValue
    PropertyChanged
End Property

' Position fr Farbverlauf
Public Property Get GardientVCenter() As Single
    GardientVCenter = LabelClass.GardientPos * 100
End Property
Public Property Let GardientVCenter(NewValue As Single)
    LabelClass.GardientPos = NewValue / 100
    PropertyChanged
End Property

Private Sub LabelClass_AfterRendering(hdc As Long, lWidth As Long, lHeight As Long)
    Dim rectTmp As RECT
    
    SetRect rectTmp, 0, 0, lWidth, lHeight
    
    Select Case m_enmBorderStyle
           Case eBorderStyle.ebs_None
                ' Nichts zeichen
           Case eBorderStyle.ebs_Solid
                DrawEdge hdc, rectTmp, 0, BF_RECT
           Case Else
                DrawEdge hdc, rectTmp, m_enmBorderStyle, BF_RECT
    End Select
End Sub

Private Sub LabelClass_LeftButtenDblClick(lID As Long, lX As Long, lY As Long)
    RaiseEvent LeftButtenDblClick(lID, lX, lY)
End Sub

Private Sub LabelClass_LeftButtenDown(lID As Long, lX As Long, lY As Long)
    RaiseEvent LeftButtenDown(lID, lX, lY)
End Sub

Private Sub LabelClass_LeftButtenUp(lID As Long, lX As Long, lY As Long)
    RaiseEvent LeftButtenUp(lID, lX, lY)
End Sub

Private Sub LabelClass_MiddleButtenDblClick(lID As Long, lX As Long, lY As Long)
    RaiseEvent MiddleButtenDblClick(lID, lX, lY)
End Sub

Private Sub LabelClass_MiddleButtenDown(lID As Long, lX As Long, lY As Long)
    RaiseEvent MiddleButtenDown(lID, lX, lY)
End Sub

Private Sub LabelClass_MiddleButtenUp(lID As Long, lX As Long, lY As Long)
    RaiseEvent MiddleButtenUp(lID, lX, lY)
End Sub



Private Sub LabelClass_MouseHover(lID As Long)
    RaiseEvent MouseHover(lID)
End Sub

Private Sub LabelClass_MouseLeave(lID As Long)
    RaiseEvent MouseLeave(lID)
End Sub

Private Sub LabelClass_MouseOver(lID As Long)
    RaiseEvent MouseOver(lID)
End Sub

Private Sub LabelClass_RightButtenDblClick(lID As Long, lX As Long, lY As Long)
    RaiseEvent RightButtenDblClick(lID, lX, lY)
End Sub

Private Sub LabelClass_RightButtenDown(lID As Long, lX As Long, lY As Long)
    RaiseEvent RightButtenDown(lID, lX, lY)
End Sub

Private Sub LabelClass_RightButtenUp(lID As Long, lX As Long, lY As Long)
    RaiseEvent RightButtenUp(lID, lX, lY)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_enmBorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    
    LabelClass.BackColor = PropBag.ReadProperty("BackColor", &HC0C0C0)
    LabelClass.BackSecColor = PropBag.ReadProperty("BackColor2", -1)
    LabelClass.GardientPos = PropBag.ReadProperty("GardientVCenter", 80) * 100
    LabelClass.Text = PropBag.ReadProperty("Source", "ML-Label")
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BackColor", LabelClass.BackColor, &HC0C0C0)
    Call PropBag.WriteProperty("BackColor2", LabelClass.BackSecColor, -1)
    Call PropBag.WriteProperty("GardientVCenter", LabelClass.GardientPos / 100, 80)
    Call PropBag.WriteProperty("Source", LabelClass.Text, "ML-Label")
    
    Call PropBag.WriteProperty("BorderStyle", m_enmBorderStyle, 0)
End Sub


Private Sub UserControl_Initialize()
    If LabelClass Is Nothing Then Set LabelClass = New cML_Label
    LabelClass.Init UserControl.hwnd
    
End Sub

Private Sub UserControl_Terminate()
    Set LabelClass = Nothing
End Sub


